#!/bin/sh

# default IP address and gateway
ipaddress="192.168.14.10";
gateway="192.168.14.1";
submask="255.255.255.0";

mount -o remount,rw /;

# 各htmlページのapacheのIPを書き換える
dir="/home/toa/TOA_AM-CF1/Webserver/static/js/";
sed -i -e '2, 2d' ${dir}ws_set.js;
sed -i -e "1a var NOW_IPADDRESS =\"$ipaddress\";" ${dir}ws_set.js;

# set /home/toa/StartupShell/ipaddress.conf
sh /var/www/html/set_ipaddress.conf.sh $ipaddress $submask $gateway;

mount -o remount,ro /;

# UUIDを取得する
uuid=$(nmcli -t -f uuid c);


# ipアドレスを変更する
nmcli con mod $uuid ipv4.method manual ipv4.address "$ipaddress/24" ipv4.gateway $gateway connection.autoconnect "yes" ipv6.method ignore;

# 変更を反映する
nmcli con down $uuid;
nmcli con up $uuid;

