/*
 * dsp_through.h
 *
 *  Created on: 2016/09/23
 *      Author: toa29548
 */

#pragma once

#include <dsp_lib/include/dsp/dsp_module.h>

namespace dsp_lib {

class Through : public DspModule {
public:
	struct Config{};
	struct Param{};
	struct Status{};

	// -------------------------------------------------------------
	// コンフィギュレーション（実行時に変化しないパラメータ設定）
	// -------------------------------------------------------------
	static bool Configure(void) {
		return true;
	};
	static bool Attach(void) {
		return true;
	}

	Through(
			Config*	/*config_*/,
			Param*	/*param_*/,
			Status*	/*status_*/
	);
	bool Ready(void);
	bool Execute(
			const float*	input_,
			float*			output_
	);
	bool Task(void);
protected:
	void
	execute_through(
			const float*	input_,
				  float*	output_
	);
};

} //namespace dsp_lib
