# -*- coding:utf-8 -*-
import json, copy, math, sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command
from master_data_const import Get_Speaker_Output_Assign_Gain

config_file_name = ''

command_file_name = '../../tmp/command_cf1_matrix_spout_assign.json'
result_file_name = '../../tmp/result_matrix_spout_assign.json'
# ---------------------------------------------------------
def Set_Speaker_Output_Assign(auxin_state,codecin_state):

    matrix_AUX_gain = Get_Speaker_Output_Assign_Gain(auxin_state)
    matrix_CODEC_gain = Get_Speaker_Output_Assign_Gain(codecin_state)

    commands = [{"access": "set", "block_no": BlockNo.MATRIX_1, "type": "matrix", "param": {"gain":{"input_ch":5,"output_ch":4,"gain":matrix_AUX_gain }}},
                {"access": "set", "block_no": BlockNo.MATRIX_1, "type": "matrix", "param": {"gain":{"input_ch":6,"output_ch":3,"gain":matrix_AUX_gain }}},
                {"access": "set", "block_no": BlockNo.MATRIX_1, "type": "matrix", "param": {"gain":{"input_ch":2,"output_ch":3,"gain":matrix_CODEC_gain}}},
                {"access": "set", "block_no": BlockNo.MATRIX_1, "type": "matrix", "param": {"gain":{"input_ch":2,"output_ch":4,"gain":matrix_CODEC_gain}}}]

    with open(command_file_name, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)
    
    send_command(command_file_name, result_file_name)
