/************************************************************************
 *
 *	coeff_hpf18.c
 *
 *	20020925	Tsuyoshi Ogawa
 *
 ************************************************************************/

#include "fdesign_prototypes.h"

namespace dsp_lib {

/*============================================================*/
void
Fdesign_HPF18_CheckParameter(
	float*	f_,
	float*	q_
)
{
	Fdesign_LPF18_CheckParameter(f_, q_);
}

/*============================================================*/
void
Fdesign_HPF18(
	float	f_,
	float	q_,
	int		bypass_,
	float*	coeff1_,
	float*	coeff2_
)
{
	Fdesign_HPF12(f_, q_, bypass_, coeff1_);
	Fdesign_HPF6(f_, bypass_, coeff2_);
}

/*============================================================*/
} // namespace dsp_lib
