# -*- coding:utf-8 -*-
#Define each block No & block function
#[Example] USB input 1: USBinL, USB input 2: USBinR

#LEVEL in MIC
RAW_LEV_MIC1 = 0
RAW_LEV_MIC2 = 2
RAW_LEV_MIC3 = 4
RAW_LEV_MIC4 = 6
RAW_LEV_MIC5 = 8
RAW_LEV_MIC6 = 10
RAW_LEV_MIC7 = 12
RAW_LEV_MIC8 = 14

#GAIN in (Cannot change by WEB App)
RAW_GAIN_MIC1 = 1
RAW_GAIN_MIC2 = 3
RAW_GAIN_MIC3 = 5
RAW_GAIN_MIC4 = 7
RAW_GAIN_MIC5 = 9
RAW_GAIN_MIC6 = 11
RAW_GAIN_MIC7 = 13
RAW_GAIN_MIC8 = 15
RAW_GAIN_USBinL = 23
RAW_GAIN_USBinR = 30
RAW_GAIN_CODECin = 37
RAW_GAIN_BTinL = 44
RAW_GAIN_BTinR = 51
RAW_GAIN_AUXinL = 58
RAW_GAIN_AUXinR = 65

#Beam Forming
BF = 16

#LEVEL in
LEV_MIC = 17
LEV_USBinL = 24
LEV_USBinR = 31
LEV_CODECin = 38
LEV_BTinL = 45
LEV_BTinR = 52
LEV_AUXinL = 59
LEV_AUXinR = 66

#EQ in
EQ_MIC = 18         #(stage 10)
EQ_USBinL = 25      #(stage 5)
EQ_USBinR = 32      #(stage 5)
EQ_CODECin = 39     #(stage 5)
EQ_BTinL = 46       #(stage 5)
EQ_BTinR = 53       #(stage 5)
EQ_AUXinL = 60      #(stage 1)
EQ_AUXinR = 67      #(stage 1)

#GAIN in
GAIN_MIC = 19
GAIN_USBinL = 26    #(1 preset_gain.txt)
GAIN_USBinR = 33    #(2 preset_gain.txt)
GAIN_CODECin = 40   #(5 preset_gain.txt)
GAIN_BTinL = 47     #(3 preset_gain.txt)
GAIN_BTinR = 54     #(4 preset_gain.txt)
GAIN_AUXinL = 61    #(6 preset_gain.txt)
GAIN_AUXinR = 68    #(7 preset_gain.txt)

#AEC
AEC = 79

#NC
NC = 80

#EQ out
EQ_CODECout = 82    #(stage 3)
EQ_USBoutR = 86     #(stage 5)
EQ_AUXoutR = 90     #(stage 5)
EQ_SPoutR = 72      #(stage 10)
EQ_SPoutL = 75      #(stage 10)
EQ_AUXoutL = 96     #(stage 5)
EQ_USBoutL = 100    #(stage 5)
EQ_BToutL = 104     #(stage 1)

#GAIN out
GAIN_CODECout = 83  #(13 preset_gain.txt)
GAIN_USBoutR = 87   #(11 preset_gain.txt)
GAIN_AUXoutR = 91   #(15 preset_gain.txt)
GAIN_SPoutR = 73    #(9  preset_gain.txt)
GAIN_SPoutL = 76    #(8  preset_gain.txt)
GAIN_AUXoutL = 97   #(14 preset_gain.txt)
GAIN_USBoutL = 101  #(10 preset_gain.txt)
GAIN_BToutL = 105   #(12 preset_gain.txt)

#LEVEL out
LEV_CODECout = 85
LEV_USBoutR = 89
LEV_AUXoutR = 93
LEV_SPoutR = 94
LEV_SPoutL = 95
LEV_AUXoutL = 99
LEV_USBoutL = 103
LEV_BToutL = 107

#Matrix
MATRIX_1 = 71
MATRIX_2 = 78
MATRIX_3 = 81
