# -*- coding:utf-8 -*-
import codecs

codecs_open_char = 'utf-8' #ファイルオープン時文字コード定義(www-dataがアクセスする対象ファイルは、fopen時に文字コード定義が必要)
codecs_open_ignore = 'ignore' #読み込むときに定義

def Convert_str_eq_param(param):
    return "{0:.1f}".format(float(param))

def Write_eq_param(EQ_param_fname, SP_types, SP_freqs, SP_qs, SP_gains):
    types = SP_types[0:5]
    freqs = list(map(Convert_str_eq_param, SP_freqs[0:5]))
    qs = list(map(str, SP_qs[0:5]))
    gains = list(map(Convert_str_eq_param, SP_gains[0:5]))

    with codecs.open(EQ_param_fname,'w', codecs_open_char, codecs_open_ignore) as f:
        f.write(",".join(types))
        f.write('\n')
        f.write(",".join(freqs))
        f.write('\n')
        f.write(",".join(qs))
        f.write('\n')
        f.write(",".join(gains))
        f.write('\n')
