# -*- coding:utf-8 -*-
import subprocess as sp
import json, os
import fcntl
import codecs

PATH = '/home/toa/TOA_AM-CF1/Application/data/'
LOCK_FILE_NAME = "/dev/send_command_lockf"

codecs_open_char = 'utf-8' #ファイルオープン時文字コード定義(www-dataがアクセスする対象ファイルは、fopen時に文字コード定義が必要)
codecs_open_ignore = 'ignore' #読み込むときに定義

def send_command(i_command, i_result):
    if os.path.isfile(LOCK_FILE_NAME) != True:
        f = open(LOCK_FILE_NAME, "w")
        f.close
    FAIL_TIME= 1000
    for i in range (FAIL_TIME):
        try:
            with codecs.open(LOCK_FILE_NAME,"r+", codecs_open_char, codecs_open_ignore) as lockfile:
                fcntl.flock(lockfile.fileno(), fcntl.LOCK_EX)
                if os.path.exists(i_result):
                    os.remove(i_result)
                sp.run([PATH + 'control.out', i_command, PATH + 'netlist.bin', i_result])
                with codecs.open(i_result, "r", codecs_open_char, codecs_open_ignore) as file:
                    result = json.load(file)
                    return 0
        except:
            if i == (FAIL_TIME - 1): #For No98,No117
                print('control.out Error')
            else:
                print('Re-send:', i_command)

    return -1
