import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time
import fcntl    # for ファイル排他

def Sum_SP_Gain(main_gain_filename, web_gain_filename):
    for i in range(1000): #For No98,117
        try:
            with open(main_gain_filename,'r') as f:
                main_gain = f.read()

            web_gains = "0\n1"
            with open(web_gain_filename,'r') as f:
                try:
                    # read 時は共有ロック
                    fcntl.flock(f, fcntl.LOCK_SH)

                    web_gains = f.readlines()
                except IOError as io_ex:
                    print('[{0}] exception : {1}'.format(
                        inspect.currentframe().f_code.co_name, io_ex))

            web_gain = int(web_gains[0].strip())
            web_mute = int(web_gains[1].strip())
            break
        except:
            print('Re-send:', i, ':', web_gain_filename)
    
    #if SP out mute on
    if web_mute == 0:
        web_gain = -150

    DSP_send_gain = int(main_gain) + web_gain

    return int(main_gain), web_gain, int(DSP_send_gain)