var SPIN_INCORRECT = false;

function Spins(screen, type) {

    var mod = this;
    mod.screen = screen;
    mod.type = type;
    mod.spin = ".spin-btn." + mod.type;
    mod.timeout = null;
    mod.interval = null;

    mod.init = function () {
        app.addUpdateFunc(mod.screen, mod.type, mod.updateValueFunc, mod.updateUnitFunc);
        app.addLimitUpdateFunc(mod.screen, mod.type, mod.updateChoicesFunc);
        mod.updateAllValues(false);
        mod.updateAllUnits(false);
        mod.events();
    }

    mod.updateValueFunc = function (value, trigger) {
        var response;
        value = parseFloat(value);
        var limit = limits[mod.screen][mod.type];
        if (limit.values) {
            if (limit.values.indexOf(value) >= 0) {
                if (limit.order) {
                    var data = app.getControlParent(mod.screen, this.parentID);
                    var index = app.getChildIndex(data, this.parentID);
                    if (limit.order == "INC") {
                        if (index == 0) {
                            if (data[index + 1][mod.type].value > value) {
                                if (limit.double_digits) this.value = ("0" + value).slice(-2);
                                else this.value = value;
                                mod.updateValue(this.parentID, trigger);
                                if ($('#filter1_fc').length) {
                                    //changePeq_1();
                                    //changePeq_2();
                                    //changePeq_3();
                                    //changePeq_4();
                                    //changePeq_5();
                                }
                                response = "ok";
                            }
                            else {
                                console.log("[SPIN BUTTON] Incorrect value");
                                SPIN_INCORRECT = true;
                                mod.clearTimers();
                                if (limit.error) alert(limit.error);
                                response = "invalid";
                            }
                        }
                        else if (index == data.length - 1) {
                            if (data[index - 1][mod.type].value < value) {
                                if (limit.double_digits) this.value = ("0" + value).slice(-2);
                                else this.value = value;
                                mod.updateValue(this.parentID, trigger);
                                if ($('#filter1_fc').length) {
                                    //changePeq_1();
                                    //changePeq_2();
                                    //changePeq_3();
                                    //changePeq_4();
                                    //changePeq_5();
                                }
                                response = "ok";
                            }
                            else {
                                console.log("[SPIN BUTTON] Incorrect value");
                                SPIN_INCORRECT = true;
                                mod.clearTimers();
                                if (limit.error) alert(limit.error);
                                response = "invalid";
                            }
                        }
                        else {
                            if (data[index - 1][mod.type].value < value && data[index + 1][mod.type].value > value) {
                                if (limit.double_digits) this.value = ("0" + value).slice(-2);
                                else this.value = value;
                                mod.updateValue(this.parentID, trigger);
                                if ($('#filter1_fc').length) {
                                    //changePeq_1();
                                    //changePeq_2();
                                    //changePeq_3();
                                    //changePeq_4();
                                    //changePeq_5();
                                }
                                response = "ok";
                            }
                            else {
                                console.log("[SPIN BUTTON] Incorrect value");
                                mod.clearTimers();
                                if (limit.error) alert(limit.error);
                                response = "invalid";
                            }
                        }
                    }
                    else {
                        if (index == 0) {
                            if (data[index + 1][mod.type].value < value) {
                                if (limit.double_digits) this.value = ("0" + value).slice(-2);
                                else this.value = value;
                                mod.updateValue(this.parentID, trigger);
                                if ($('#filter1_fc').length) {
                                    //changePeq_1();
                                    //changePeq_2();
                                    //changePeq_3();
                                    //changePeq_4();
                                    //changePeq_5();
                                }
                                response = "ok";
                            }
                            else {
                                console.log("[SPIN BUTTON] Incorrect value");
                                mod.clearTimers();
                                if (limit.error) alert(limit.error);
                                response = "invalid";
                            }
                        }
                        else if (index == data.length - 1) {
                            if (data[index - 1][mod.type].value > value) {
                                if (limit.double_digits) this.value = ("0" + value).slice(-2);
                                else this.value = value;
                                mod.updateValue(this.parentID, trigger);
                                if ($('#filter1_fc').length) {
                                    //changePeq_1();
                                    //changePeq_2();
                                    //changePeq_3();
                                    //changePeq_4();
                                    //changePeq_5();
                                }
                                response = "ok";
                            }
                            else {
                                console.log("[SPIN BUTTON] Incorrect value");
                                mod.clearTimers();
                                if (limit.error) alert(limit.error);
                                response = "invalid";
                            }
                        }
                        else {
                            if (data[index - 1][mod.type].value > value && data[index + 1][mod.type].value < value) {
                                if (limit.double_digits) this.value = ("0" + value).slice(-2);
                                else this.value = value;
                                mod.updateValue(this.parentID, trigger);
                                if ($('#filter1_fc').length) {
                                    //changePeq_1();
                                    //changePeq_2();
                                    //changePeq_3();
                                    //changePeq_4();
                                    //changePeq_5();
                                }
                                response = "ok";
                            }
                            else {
                                console.log("[SPIN BUTTON] Incorrect value");
                                mod.clearTimers();
                                if (limit.error) alert(limit.error);
                                response = "invalid";
                            }
                        }
                    }
                }
                else {
                    if (limit.double_digits) this.value = ("0" + value).slice(-2);
                    else this.value = value;
                    mod.updateValue(this.parentID, trigger);
                    if ($('#filter1_fc').length) {
                        changePeq_1();
                        changePeq_2();
                        changePeq_3();
                        changePeq_4();
                        changePeq_5();
                    }
                    response = "ok";
                }
            }
            else {
                console.log("[SPIN BUTTON] Incorrect value");
                mod.clearTimers();
                response = "invalid";
            }
        }
        else if (value >= limit.min && value <= limit.max && value % limit.step == 0) {
            if (limit.double_digits) this.value = ("0" + value).slice(-2);
            else this.value = value;
            mod.updateValue(this.parentID, trigger);
            if ($('#filter1_fc').length) {
                changePeq_1();
                changePeq_2();
                changePeq_3();
                changePeq_4();
                changePeq_5();
            }
            response = "ok";
        }
        else {
            console.log("[SPIN BUTTON] Incorrect value");
            mod.clearTimers();
            response = "invalid";
        }
        return response;
    }

    mod.updateAllValues = function (trigger) {
        $(mod.spin).each(function () {
            var controlID = $(this).attr("control-id");
            mod.updateValue(controlID, trigger);
        });
    }

    mod.updateValue = function (controlID, trigger) {
        var $spin = $(mod.spin + "[control-id='" + controlID + "']");
        var data = app.getControlData(mod.screen, controlID);
        $spin.find(".input").html(data[mod.type].value);
        if (trigger == null || trigger == true) {
            $(window).trigger("valueUpdated");
            $(mod.spin).trigger(controlID + "ValueUpdated");
        }
    }

    mod.updateUnitFunc = function (value, trigger) {
        var response;
        this.unit = value;
        mod.updateUnit(this.parentID, trigger);
        response = "ok";
    }

    mod.updateAllUnits = function (trigger) {
        $(mod.spin).each(function () {
            var controlID = $(this).attr("control-id");
            mod.updateUnit(controlID, trigger);
        });
    }

    mod.updateUnit = function (controlID, trigger) {
        var $spin = $(mod.spin + "[control-id='" + controlID + "']");
        var data = app.getControlData(mod.screen, controlID);
        $spin.find(".unit").html(data[mod.type].unit);
        if (trigger == null || trigger == true) {
            $(window).trigger("unitUpdated");
            $(mod.spin).trigger(controlID + "UnitUpdated");
        }
    }

    mod.updateChoicesFunc = function (value, trigger) {
        if (limits[mod.screen][mod.type].values) {
            limits[mod.screen][mod.type].values = value;
        }
        else {
            for (var key in value) {
                limits[mod.screen][mod.type][key] = value[key];
            }
        }

        if (trigger == null || trigger == true) {
            $(window).trigger("limitUpdated");
            $(window).trigger(mod.type + "LimitUpdated");
        }
    }

    mod.valuechange = function (controlID, sens) {
        var data = app.getControlData(mod.screen, controlID);
        var currVal = data[mod.type].value;
        var newVal = currVal;
        var limit = limits[mod.screen][mod.type];
        if (limit.values) {
            var currIndex = limit.values.indexOf(currVal);
            newVal = limit.values[currIndex + sens];
        }
        else newVal = parseFloat(currVal) + (sens * limit.step);
        data[mod.type].updateValue(newVal);
    }

    mod.events = function () {
        $(mod.spin).find(".up").on("mousedown", function () {
            if (!$(this).parents(mod.spin).hasClass("disabled")) {
                var controlID = $(this).parents(mod.spin).attr("control-id");
                mod.valuechange(controlID, 1);
                mod.clearTimers();
                if (SPIN_INCORRECT == false) {
                    mod.timeout = setTimeout(function () {
                        mod.interval = setInterval(function () {
                            mod.valuechange(controlID, 1);
                        }, 20);
                    }, 500);
                }else{
                SPIN_INCORRECT = false;
                }
            }
        });
        $(mod.spin).find(".down").on("mousedown", function () {
            if (!$(this).parents(mod.spin).hasClass("disabled")) {
                var controlID = $(this).parents(mod.spin).attr("control-id");
                mod.valuechange(controlID, -1);
                mod.clearTimers();
                if (SPIN_INCORRECT == false) {
                    mod.timeout = setTimeout(function () {
                        mod.interval = setInterval(function () {
                            mod.valuechange(controlID, -1);
                        }, 20);
                    }, 500);
                }else{
                SPIN_INCORRECT = false;
                }
            }
        });
        $(document).on("mouseup", function () {
            mod.clearTimers();
        });
    }

    mod.clearTimers = function () {
        if (mod.timeout != null) {
            clearTimeout(mod.timeout);
            mod.timeout = null;
        }
        if (mod.interval != null) {
            clearInterval(mod.interval);
            mod.interval = null;
        }
    }

    mod.getDom = function () {
        return $(mod.spin);
    }

    mod.getType = function () {
        return mod.type;
    }

}