from django.http import HttpResponse
from channels.handler import AsgiHandler
from channels import Group

from hello.set_json import Set_Volume
from hello.set_json import Set_EQ
from hello.set_json import Set_Audio_Setting
from hello.get_json import Get_Volume
from hello.get_json import Get_EQ
from hello.get_json import Get_Level
from hello.get_json import Get_Audio_Setting

from hello.preset import Save_Preset
from hello.preset import Load_Preset
from hello.preset import Reset_Preset
from hello.preset import Get_Default_Preset
from hello.preset import Set_Default_Preset

from hello.config import Set_Config
from hello.config import Get_Config
from hello.config import Set_Login

from hello.inspection import Get_Mic_Level
from hello.inspection import Get_Aec_params
from hello.inspection import Set_Aec_params
from hello.inspection import Get_Version

import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time

# status update
sys.path.append(os.path.join(os.path.dirname(__file__), "../../Application/data"))
import dspupdate

row =1
connection =1

#thisNAME_PATH = os.path.dirname(os.path.abspath(__name__))
thisNAME_PATH = "/home/toa/TOA_AM-CF1/Application/data/"
PATH = os.path.join(thisNAME_PATH, '../../tmp/')

UPDATE_FAILED_flag = "/home/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG"
UPDATE_FAILED_flag_org = "/home_org/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG"
WEB_STOP_flag = PATH + 'WEB_STOP_flag'

#websocket接続
def ws_add(message):
	#print('aaaaaaaaaaaaaaaaaaaa')
	message.reply_channel.send({"accept": True})
	Group("chat").add(message.reply_channel)

	global row
	global connection

#websocket切断
def ws_disconnect(message):
	Group("chat").discard(message.reply_channel)

	global connection

#メッセージを受け取ったら、メッセージを返す
def ws_message(message):
	#print('bbbbbbbbbbbb')
	#msgに受け取ったメッセージ格納
	msg = message.content['text']
	global row

	input_value = msg.split()
	#print("{input_value}".format(**locals()))

	if input_value[0] == 'ud_response':
		ws_send = "UPLOAD OK."
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})
		ws_disconnect("websocket disconnected")

	##################################################

