//*getaec_param_socket.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

ws.onerror = function () {
    alert('Failure to connect')
};

ws.onopen = function () {
    ws.send(
        ' insp ' + ' get_aec_params '
    );
    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:usbin_gain, 2:BTin_gain,
        //3:Codecin_gain, 4:AUXin_gain,
        //5:SPout_gain, 6:USBout_gain,
        //7:BT_gain, 8:Codecout_gain,
        //9:AUX_gain, 10～18:mute_sts*9 (0:ON 1:OFF)
        var LOOP = 100;
        var arrayString = e.data.split(",");
        if (arrayString[0] == "insp_get_aec_params") {
            $("#on_s").val(arrayString[1])
            $("#errmu_limit_s").val(arrayString[3])
            $("#rcv_dly__s").val(arrayString[4])
            $("#nlp_ratio0_s").val(arrayString[5])
            $("#nlp_ratio1_s").val(arrayString[6])
            $("#nlp_enhance0_s").val(arrayString[7])
            $("#nlp_enhance1_s").val(arrayString[8])
            $("#nlp_alpha0_s").val(arrayString[9])
            $("#nlp_alpha1_s").val(arrayString[10])
            $("#nlp_alpha2_s").val(arrayString[11])
            $("#nlp_step_s").val(arrayString[12])
            $("#drc_compTh_s").val(arrayString[13])
            $("#drc_compRatio_s").val(arrayString[14])
            $("#drc_compGain_s").val(arrayString[15])
            $("#drc_boostTh_s").val(arrayString[16])
            $("#drc_boostRatio_s").val(arrayString[17])
            $("#drc_boostGain_s").val(arrayString[18])
            $("#drc_AT_s").val(arrayString[19])
            $("#drc_RT_s").val(arrayString[20])
            $("#mic_mute_s").val(arrayString[21])
            $("#cng_noise_s").val(arrayString[22])
            $("#bmInput_fixedGain_s").val(arrayString[23])
            $("#nlp_fixedGain_s").val(arrayString[24])
            $("#drc_fixedGain_s").val(arrayString[25])
            $("#param_set_flag_s").val(arrayString[26])

            var mu_prms = arrayString[2].split("/")

            $("#mu_0_s").val(mu_prms[0])
            $("#mu_1_s").val(mu_prms[1])
            $("#mu_2_s").val(mu_prms[2])
            $("#mu_3_s").val(mu_prms[3])
            $("#mu_4_s").val(mu_prms[4])
            $("#mu_5_s").val(mu_prms[5])
            $("#mu_6_s").val(mu_prms[6])
            $("#mu_7_s").val(mu_prms[7])

        }
    }
}



$(function () {
    $('#aec_check_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        ws.send(
            ' insp ' + ' set_aec_params ' +
            $("#on").val() + ' ' +
            '[' + $("#mu_0").val() + '/' + $("#mu_1").val() + '/' +$("#mu_2").val() + '/' +$("#mu_3").val() + '/' +$("#mu_4").val() + '/' +$("#mu_5").val() + '/' +$("#mu_6").val() + '/' +$("#mu_7").val() + ']' + ' ' +
            $("#errmu_limit").val() + ' ' +
            $("#rcv_dly_").val() + ' ' +
            $("#nlp_ratio0").val() + ' ' +
            $("#nlp_ratio1").val() + ' ' +
            $("#nlp_enhance0").val() + ' ' +
            $("#nlp_enhance1").val() + ' ' +
            $("#nlp_alpha0").val() + ' ' +
            $("#nlp_alpha1").val() + ' ' +
            $("#nlp_alpha2").val() + ' ' +
            $("#nlp_step").val() + ' ' +
            $("#drc_compTh").val() + ' ' +
            $("#drc_compRatio").val() + ' ' +
            $("#drc_compGain").val() + ' ' +
            $("#drc_boostTh").val() + ' ' +
            $("#drc_boostRatio").val() + ' ' +
            $("#drc_boostGain").val() + ' ' +
            $("#drc_AT").val() + ' ' +
            $("#drc_RT").val() + ' ' +
            $("#mic_mute").val() + ' ' +
            $("#cng_noise").val() + ' ' +
            $("#bmInput_fixedGain").val() + ' ' +
            $("#nlp_fixedGain").val() + ' ' +
            $("#drc_fixedGain").val() + ' ' +
            $("#param_set_flag").val()
        );

        // websokcet already close? readyState:2 closing, 3 closed
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});
