#!/bin/sh

# $1: Subnet mask such as 255.255.255.0
# return 24 bit for above subnetmask
# return minus value for uncorrect subnetmask

sm1=`echo $1 | cut -d'.' -f 1`;
sm2=`echo $1 | cut -d'.' -f 2`;
sm3=`echo $1 | cut -d'.' -f 3`;
sm4=`echo $1 | cut -d'.' -f 4`;

bit=0;

# avoiding subnet mask like 255.0.0.255
if [ $sm1 -ge $sm2 ] && [ $sm2 -ge $sm3 ] && [ $sm3 -ge $sm4 ]; then
        case "$sm1" in
                "128" ) bit=$(($bit+1));;
                "192" ) bit=$(($bit+2));;
                "224" ) bit=$(($bit+3));;
                "240" ) bit=$(($bit+4));;
                "248" ) bit=$(($bit+5));;
                "252" ) bit=$(($bit+6));;
                "254" ) bit=$(($bit+7));;
                "255" ) bit=$(($bit+8));;
                *     ) bit=-1000000000;;
        esac

        case "$sm2" in
                "0"   ) ;;
                "128" ) bit=$(($bit+1));;
                "192" ) bit=$(($bit+2));;
                "224" ) bit=$(($bit+3));;
                "240" ) bit=$(($bit+4));;
                "248" ) bit=$(($bit+5));;
                "252" ) bit=$(($bit+6));;
                "254" ) bit=$(($bit+7));;
                "255" ) bit=$(($bit+8));;
                *     ) bit=-1000000000;;
        esac

        case "$sm3" in
                "0"   ) ;;
                "128" ) bit=$(($bit+1));;
                "192" ) bit=$(($bit+2));;
                "224" ) bit=$(($bit+3));;
                "240" ) bit=$(($bit+4));;
                "248" ) bit=$(($bit+5));;
                "252" ) bit=$(($bit+6));;
                "254" ) bit=$(($bit+7));;
                "255" ) bit=$(($bit+8));;
                *     ) bit=-1000000000;;
        esac

        case "$sm4" in
                "0"   ) ;;
                "128" ) bit=$(($bit+1));;
                "192" ) bit=$(($bit+2));;
                "224" ) bit=$(($bit+3));;
                "240" ) bit=$(($bit+4));;
                "248" ) bit=$(($bit+5));;
                "252" ) bit=$(($bit+6));;
                "254" ) bit=$(($bit+7));;
                "255" ) bit=$(($bit+8));;
                *     ) bit=-1000000000;;
        esac
else
        bit=-1000000000;
fi

# 31bit and 32bit subnet mask has no network
if [ $bit = 31 ] || [ $bit = 32 ]; then
        bit=-1000000000;
fi

echo $bit;

