#!/bin/sh

# samba off (add kura 20171025 No206
service smbd stop

# logrotate
/usr/sbin/logrotate /etc/logrotate.conf

# update **_new -> ** file
# execute new shell script when **_new file exsits
if [ -e /home/toa/StartupShell_new/startup_firmupdate.sh ]; then
	echo "# Chk file Contents/Owner/Permission NG #" >> /home/toa/TOA_AM-CF1/install.log;
	cp /home/toa/StartupShell_new/startup_firmupdate.sh /home/toa/startup_firmupdate.sh
	sh /home/toa/startup_firmupdate.sh
	rm /home/toa/startup_firmupdate.sh
else
	sh /home/toa/StartupShell/startup_firmupdate.sh
fi

mount -o remount,rw /

# judgement update success or fail by kura add 20171121
if [ -e /home/toa/StartupShell/chkfile_for_update.sh ] && [ -e /home/toa/StartupShell/chkfile_dat.tar.xz ]; then
	sh /home/toa/StartupShell/chkfile_for_update.sh #2nd time check
	if [ ${?} -eq 0 ]; then
    	rm /home_org/toa/TOA_AM-CF1/install.log; #delete log
    	rm /home/toa/TOA_AM-CF1/install.log; #delete log
	else
    	echo "# Chk file Contents/Owner/Permission NG #" >> /home/toa/TOA_AM-CF1/install.log;
    	cp /home/toa/TOA_AM-CF1/install.log /home_org/toa/TOA_AM-CF1/;
		touch /home/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG;
	fi
fi

rm     /home/toa/StartupShell/chkfile_for_update.sh
rm /home_org/toa/StartupShell/chkfile_for_update.sh
rm     /home/toa/StartupShell/chkfile_dat.tar.xz
rm /home_org/toa/StartupShell/chkfile_dat.tar.xz

# Modify Network setting files owner (root:root) permission (777)
# Bug fix change permission and owner when ip-change by web apply 
FILES_TO_CHANGE_OWNER_PERMISSION='
    /home/toa/StartupShell/ipaddress.conf
/home_org/toa/StartupShell/ipaddress.conf
    /home/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
/home_org/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
    /home/toa/TOA_AM-CF1/Application/data/config/config_net.txt
/home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt
' # end of quote
for file in ${FILES_TO_CHANGE_OWNER_PERMISSION}
do
    chown root:root ${file}
	chmod 777 ${file}
done

mount -o remount,ro /

# Delete all uploaded files in /var/www/file
sh /home/toa/StartupShell/delete_uploaded_file.sh

# Set IP address
sh /home/toa/StartupShell/set_ip.sh

# Kill mate-notification-daemon every 30 mins against cpu hang up
sh /home/toa/StartupShell/kill_mate-notification.sh &

#add 20171221 ver1.1.0.5
rm /home/toa/.xsession-errors;
ln -s /dev/null /home/toa/.xsession-errors;

# Main loop of AMCF1
sudo /home/toa/TOA_AM-CF1/Driver/STARTUP

