# -*- coding:utf-8 -*-
import json, copy,sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command

command_file_name = '../../tmp/command_cf1_get_output_gain.json'
result_file_name = '../../tmp/result_get_output_gain.json'
# ---------------------------------------------------------
def Get_OutputGain_init():
    command = {
        'access': 'get',
        'block_no': None,
        'type': 'gain',
        'config': {},
        'param': {'gain': None},
        'status': {}
    }
    commands = []
    for i in range(2):
        commands.append(copy.copy(command))
    commands[0]["block_no"] = BlockNo.GAIN_SPoutR
    commands[1]["block_no"] = BlockNo.GAIN_SPoutL
    with open(command_file_name, 'w') as f:
        json.dump(commands, f, indent=True)
    with open(result_file_name, 'w') as f:
        f.write(" ")
    send_command(command_file_name, result_file_name)
    
# ---------------------------------------------------------
def Get_OutputGain():
    send_command(command_file_name, result_file_name)
    with open(result_file_name, 'r') as f:
        result = json.load(f)
    if isinstance(result, list) is False:
        print('result.json must be array!')

    output_gain = []
    for result_no, result_obj in enumerate(result):
        if 'type' in result_obj:
            if result_obj['type'] == 'gain':
                try:
                    output_gain.append(result_obj['param']['gain'])
                except KeyError:
                    print('result[' + result_no + ']: invalid key!')
    return output_gain
