# -*- coding:utf-8 -*-
# -----------------------------------------
def Clear_ExceptionLog():
    exc_fpass = '/home/toa/TOA_AM-CF1/Webserver/templates/exception.txt'
    with open(exc_fpass, 'w') as file:
        log = [str(0), str(sys.exc_info()), str(traceback.format_exc()), "import_section"]
        file.seek(0)
        file.write(str(log))
# -----------------------------------------
def Dump_ExceptionLog(i_locate):
    times = 0
    retry = 0
    exc_fpass = '/home/toa/TOA_AM-CF1/Webserver/templates/exception.txt'

    with open(exc_fpass, 'r') as file:
        fsize = os.path.getsize(exc_fpass)
        if fsize is not 0:
            log = file.read()
            if '0' <= log[2] and log[2] <= '4':
                times = int(log[2])
            if '4' < log[2]:
                Clear_ExceptionLog()
    times += 1
    if times <= 3:
        retry = 1
    else :
        times = 0

    with open(exc_fpass, 'w') as file:
        log = [str(times), str(sys.exc_info()), str(traceback.format_exc()), i_locate]
        print("Save Exception Log File")
        file.seek(0)
        file.write(str(log))
        print(log)

    if retry == 1:
        print("Retry Main.py")
        sp.Popen("sudo killall AMCF1-WebServer", shell=True)
        os.system("sudo python3 /home/toa/TOA_AM-CF1/Application/data/main.py")
    else:
        sp.Popen("sudo killall AMCF1-WebServer", shell=True)
        sp.Popen("sudo killall python3", shell=True)
        sys.exit()
# -----------------------------------------

try:
    locate = "section_import_python_files"
    import sys, traceback, os.path
    from ctypes import *
    from cf1_init_func import Make_Init_Command_json
    from cf1_init_func import Make_FactoryPreset_Command_Json
    from cf1_init_func import startup
    from cf1_init_func import Load_PresetData
    from get_output_gain_func import Get_OutputGain
    from get_output_gain_func import Get_OutputGain_init
    from set_output_gain_func import Set_OutputGain_init
    from set_output_gain_func import Set_OutputGain
    from set_mute_func import Mute_Init
    from set_mute_func import Set_Mute
    from set_mute_func import Release_Mute
    from set_mute_func import Set_Mute_for_StandbyMode
    from set_mute_func import Release_Mute_from_StandbyMode
    from get_input_bf_level_func import Get_Bf_Level_in_init
    from get_input_bf_level_func import Get_Bf_Level_in

    sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
    from send_command import send_command
    from sum_gain_SPout import Sum_SP_Gain

    import subprocess as sp
    import json, time, os, fcntl, math

    locate = "section_import_shared_library"
    libDrivers=CDLL("/home/toa/TOA_AM-CF1/Driver/libCF1DriversLib.so")
    time_setting_fname ='/home/toa/TOA_AM-CF1/Webserver/templates/time_setting'

    locate = "section_make_init_command"
    Make_Init_Command_json()
    g_Count_RTC_Check = 0
    g_Count_USBAudioConnectCheck = 0
    g_Count_ConfigCheck = 0
    g_standby_mode = 0
    g_last_mute_status = 0    #For No191
    g_mute_sys_status = 0
    g_mute_ctrl_pulse = 0
    g_sp_vol_index = 7
    g_Status_Level_Mute = [0, 0]
    g_Cfg_CtrlInput = []
    g_Test_Enable = 0 # S1-Test

    locate = "section_make_sp_gain_status"
    main_SPgain_sts_fname = "/home/toa/TOA_AM-CF1/tmp/volume/main_SPgain_sts.txt"
    web_SPgain_sts_fname = "/home/toa/TOA_AM-CF1/tmp/volume/web_SPgain_sts.txt"
    with open(main_SPgain_sts_fname,'w') as f:
        f.write(str(0))

except KeyboardInterrupt:
    sys.exit()
except:
    Dump_ExceptionLog(locate)
# -----------------------------------------
def Show_Error():
    libDrivers.Ctrl_PowerLED(2)
    libDrivers.Ctrl_BluetoothLED(1)
    libDrivers.Ctrl_USBConnectionLED(1)
# -----------------------------------------
def TimeAdjust():
    print('time adjusting...')
    weekDayList = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"]
    YY = 17
    MM = 1
    DD = 1
    day = 1
    hh = 0
    mm = 0
    ss = 0
    # the value at first power on :01/01/00 01(Sun) 00:00:00 (DD:MM:YY DOW HH:MM:SS)
    tmp_yy = libDrivers.Get_Year()
    tmp_mm = libDrivers.Get_Month()
    tmp_dd = libDrivers.Get_Date()
    if tmp_yy < 17 and tmp_mm == 1 and tmp_dd == 1: # kura add 20171011 RTC minimum 2017/1/1 00:00:00
        libDrivers.Initialize_RTC(YY, MM, DD, day, hh, mm, ss)
    else:
        try:
            with open(time_setting_fname, 'r+') as file:
                strings = file.read()
                datetime = strings.split(",")
                if datetime[0] == '1':
                    file.seek(0)
                    file.write('0')
                    if int(datetime[1]) > 2034: # kura add 20171011 RTC set block 2035
                        YY = 34  # kura add 20171011 RTC maximum year 2034
                    else:
                        YY = int(datetime[1])%100
                    MM = int(datetime[2])
                    DD = int(datetime[3])
                    hh = int(datetime[4])
                    mm = int(datetime[5])
                    ss = int(datetime[6])
                    day = datetime[7]
                    day = day[:-1]
                    for i in range(7):
                        if weekDayList[i] == day:
                            day = int(i+1)
                    libDrivers.Initialize_RTC(YY, MM, DD, day, hh, mm, ss)
        except:
            libDrivers.Initialize_RTC(YY, MM, DD, day, hh, mm, ss)
    YY = libDrivers.Get_Year()
    MM = libDrivers.Get_Month()
    DD = libDrivers.Get_Date()
    hh = libDrivers.Get_Hour()
    mm = libDrivers.Get_Minute()
    if YY < 10:
        YY = '0'+str(YY)
    script = 'sudo date --set "20'+str(YY)+'/'+str(MM)+'/'+str(DD)+' '+str(hh)+':'+str(mm)+':00"'
    os.system(script)
# -----------------------------------------
def Initialize_Device():
    libDrivers.LibCTIMER_Init()
    libDrivers.Initialize_I2C()
    libDrivers.Initialize_GPIO()
    libDrivers.LibBT_Init()
# -----------------------------------------
def Is_FactoryReset():
    count_power_sw = 0
    i = 0
    if libDrivers.Get_PowerSwitch():	#POWER SW MODIFY I2C
        libDrivers.Ctrl_USBConnectionLED(1) #1秒点灯

        for i in range(3):      #1秒消灯 i=0、 1秒点灯 i=1、1秒消灯 i=2
            time.sleep(0.5)
            if libDrivers.Get_PowerSwitch():	#POWER SW MODIFY I2C
                libDrivers.Ctrl_USBConnectionLED(count_power_sw%2)
                count_power_sw += 1
            else:
                return 0    #３秒以内に離したら抜ける
    else:
        return 0    #押されていなければ抜ける

    #libDrivers.Ctrl_USBConnectionLED(0)

    if 3 <= count_power_sw:  #3秒以上押されていれば、工場出荷状態に設定する
        return 1

    else:
        return 0


# -----------------------------------------
def Exec_FactoryReset():
    time.sleep(0.5)
    libDrivers.Ctrl_USBConnectionLED(2)     #青をつける

    while 1:
        if (not libDrivers.Get_PowerSwitch()):
            break;

    Make_FactoryPreset_Command_Json()
    sp.Popen("sh /home/toa/StartupShell/set_ip_FactoryPreset.sh", shell=True)
    libDrivers.Ctrl_USBConnectionLED(0)     #消す
# -----------------------------------------
def Initialize_DspParameter():

    #libDrivers.Ctrl_PowerLED(1) #LED_ON_GREEN

    time.sleep(3)  # only 1 raspberry pi startup

    #ここでハード制御　電源BlueLEDを消す
    #libDrivers.Ctrl_POWER_Blue_LED_HARD(0)  #LED_OFF

    libDrivers.Ctrl_PowerLED(3) #LED_ON_ORANGE
    startup()      # only 1 raspberry pi startup
    time.sleep(1)  # only 1 raspberry pi startup
    libDrivers.Ctrl_PowerLED(1) #LED_ON_GREEN
# -----------------------------------------
def Create_Command():
    Mute_Init()
    Get_Bf_Level_in_init()
    Get_OutputGain_init()
    Set_OutputGain_init()
# -----------------------------------------
def Set_Config():
    with open("/home/toa/TOA_AM-CF1/Application/data/config/config_contled.txt",'r') as f:
        config = f.readlines()

    track = 1
    level = 1
    mute = 1
    ctrlin1 = 0
    ctrlin2 = 0
    ctrlout1 = 0
    ctrlout2 = 0
    table_cin = ['None','Mute(One-shot)','Mute(Edge)','Volume_Up','Volume_Down','Preset1','Preset2']
    table_cout = ['None','Mute_Status','Synch_Input1','Synch_Input2']

    # Tracking: 0:off, 1:on(default)
    value = config[4].split(",")
    if 'OFF' in value[1]:
        track = 0
    # Level display: 0:off, 1:on(default)
    value = config[5].split(",")
    if 'OFF' in value[1]:
        level = 0
    # Mute LED Pattern: 0:center, 1:all(default)
    value = config[6].split(",")
    if 'Only_Center' in value[1]:
        mute = 0
    # Control input
    value = config[0].split(",")
    for i in range(7):
        if table_cin[i] in value[1]:
            ctrlin1 = i
    value = config[1].split(",")
    for i in range(7):
        if table_cin[i] in value[1]:
            ctrlin2 = i
    # Control output
    value = config[2].split(",")
    for i in range(4):
        if table_cout[i] in value[1]:
            ctrlout1 = i
    value = config[3].split(",")
    for i in range(4):
        if table_cout[i] in value[1]:
            ctrlout2 = i

    libDrivers.Initialize_LedConfig(track,level,mute)
    libDrivers.Initialize_CtrlInputConfig(ctrlin1,ctrlin2)
    libDrivers.Initialize_CtrlOutputConfig(ctrlout1,ctrlout2)

# -----------------------------------------
def Activate_WebServer():
    if os.path.isfile("/home/toa/TOA_AM-CF1/Webserver/manage.py") == True:
        sp.Popen("sudo python3 /home/toa/TOA_AM-CF1/Webserver/manage.py runserver --insecure 0.0.0.0:8000", shell=True)
    else:
        Show_Error()
# -----------------------------------------
def Initialize_Status():
    global g_mute_ctrl_pulse
    global g_mute_sys_status    #For No191
    global g_Status_Level_Mute  #For No191

    #For No191
    if g_mute_ctrl_pulse == 1:
        g_mute_ctrl_pulse = 0
        Update_MuteStatus(g_mute_ctrl_pulse)
    g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
    libDrivers.Initialize_GPIOStatus()
    libDrivers.Initialize_SwitchStatus()
    libDrivers.Set_gpioMuteStatus(0)
    libDrivers.Set_i2cMuteStatus(0)
    libDrivers.Ctrl_USBConnectionLED(0)
    libDrivers.Ctrl_BluetoothLED(0)
    libDrivers.Set_ControlOutput1(0)
    libDrivers.Set_ControlOutput2(0)
# -----------------------------------------
def Update_BeamAngle():
    levels_in = []
    ch_mic_input = 0
    global bf_LED_Num_prev
    BF_LED_TURNOFF = -5000.0

    if libDrivers.Get_IndicateMode() == 0:
        datas = Get_Bf_Level_in()
        levels_in = [float(datas[0])]
        bf_LED_Num_curr = datas[1]
        # --- Determine LED position
        if type(levels_in[ch_mic_input]) == float:
            if bf_LED_Num_prev == bf_LED_Num_curr:
                libDrivers.Chg_LEDBrightness(bf_LED_Num_curr, c_float(levels_in[ch_mic_input]))
            else:
                libDrivers.Chg_LEDBrightness(bf_LED_Num_curr, c_float(levels_in[ch_mic_input]))
                libDrivers.Chg_LEDBrightness(bf_LED_Num_prev, c_float(BF_LED_TURNOFF))
            bf_LED_Num_prev = bf_LED_Num_curr
# -----------------------------------------
def Update_MuteStatus(i_st_sw):
    WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP
    global g_mute_sys_status
    global g_mute_ctrl_pulse
    global g_Status_Level_Mute

    if i_st_sw:
        if g_mute_sys_status == 0:
            #if g_Test_Enable == 0: # S1-Test
            #    if os.path.exists(WEB_STOP_flag) == False:
            #        with open(WEB_STOP_flag,'w') as f:
            #            f.write("")
            if os.path.exists(WEB_STOP_flag) == False:
                with open(WEB_STOP_flag,'w') as f:
                    f.write("")
            Set_Mute()
            libDrivers.Chg_IndicateMode(2)
    else:
        if (g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]) == 0:
            Release_Mute()
            libDrivers.Chg_IndicateMode(0)
    g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
    #For No202
    libDrivers.Set_gpioMuteStatus(g_mute_sys_status)  #Set data for Contact Output
    libDrivers.Set_i2cMuteStatus(g_mute_sys_status)   #Set data for Return from standby

# -----------------------------------------
def Chg_SpeakerVolume(i_updown):
    global g_sp_vol_index
    global g_mute_ctrl_pulse
    sp_vol_table = [-70, -24, -18, -12, -9, -6, -3, 0]

    with open(main_SPgain_sts_fname,'r') as f:  #add kura 20171006
        g_sp_vol_index = sp_vol_table.index(int(f.read()))    #add kura 20171006

    if i_updown:
        if 7 <= g_sp_vol_index:
            g_sp_vol_index = 7
        else:
            g_sp_vol_index += 1
    else:
        if g_sp_vol_index <= 0:
            g_sp_vol_index = 0
        else:
            g_sp_vol_index -= 1

    libDrivers.Chg_IndicateMode(1)
    libDrivers.Chg_VolumePosition(g_sp_vol_index)

    with open(main_SPgain_sts_fname,'w') as f:
        f.write(str(sp_vol_table[g_sp_vol_index]))

    SP_gain = Sum_SP_Gain(main_SPgain_sts_fname, web_SPgain_sts_fname)
    #[0]:main, [1]:web, [2]:DSP

    Set_OutputGain(SP_gain[2])

    #For No195
#    if g_mute_ctrl_pulse == 1:
#        g_mute_ctrl_pulse = 0
#        Update_MuteStatus(g_mute_ctrl_pulse)
# -----------------------------------------
def Update_SideSwitchStatus(i_num):
    global g_mute_ctrl_pulse

    #muteBT = libDrivers.LibBT_getMuteEvent()
    #if i_num == 1 or  muteBT == 1:
    #    if libDrivers.Read_MuteSwitch() == 1 or muteBT == 1:
            #if (g_Status_Level_Mute[0] or g_Status_Level_Mute[1]) == 0:    #S1

    if i_num == 1:
        if libDrivers.Read_MuteSwitch() == 1:
            #if (g_Status_Level_Mute[0] or g_Status_Level_Mute[1]) == 0:    #S1
            g_mute_ctrl_pulse ^= 1
            Update_MuteStatus(g_mute_ctrl_pulse)
    # --- Volume Up Switch Changed ---
    elif i_num == 2:
        if libDrivers.Read_VolumeUpSwitch() == 1:
            Chg_SpeakerVolume(1)
    # --- Volume Down Switch Changed ---
    elif i_num == 3:
        if libDrivers.Read_VolumeDownSwitch() == 1:
            Chg_SpeakerVolume(0)
# -----------------------------------------
def Update_CinConfigTable():
    global g_Cfg_CtrlInput
    for i in range(2):
        g_Cfg_CtrlInput[i] = libDrivers.Get_CtrlInputCfg(i)

# -----------------------------------------
def Update_ControlInputStatus(i_num):
    global g_Cfg_CtrlInput
    global g_Status_Level_Mute
    global g_mute_ctrl_pulse

    if i_num == 2 or i_num == 3:
        array = i_num - 2
        if g_Cfg_CtrlInput[array] == 1:   # Mute(Pulse)
            g_mute_ctrl_pulse ^= 1
            Update_MuteStatus(g_mute_ctrl_pulse)
        elif g_Cfg_CtrlInput[array] == 2: # Mute(Level)
            pre_mute_status = g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
            if array == 0:
                g_Status_Level_Mute[0] = libDrivers.Read_ControlInput1Status()
            else:
                g_Status_Level_Mute[1] = libDrivers.Read_ControlInput2Status()

            if g_mute_ctrl_pulse == 1:
                g_mute_ctrl_pulse = 0

            if(pre_mute_status != (g_Status_Level_Mute[0] | g_Status_Level_Mute[1])):
                Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])

        elif g_Cfg_CtrlInput[array] == 3: # Vol up
            Chg_SpeakerVolume(1)
        elif g_Cfg_CtrlInput[array] == 4: # Vol down
            Chg_SpeakerVolume(0)
        elif g_Cfg_CtrlInput[array] == 5: # preset1 load
            Load_PresetData(1)
        elif g_Cfg_CtrlInput[array] == 6: # preset2 load
            Load_PresetData(2)
# -----------------------------------------
#For No191,No197
def Update_ControlInputStatus_forStandbyMode(i_num): #add ishikawa
    if i_num == 2 or i_num == 3:
        array = i_num - 2
        if g_Cfg_CtrlInput[array] == 2: # Mute(Level)
            if array == 0:
                g_Status_Level_Mute[0] = libDrivers.Read_ControlInput1Status()
            else:
                g_Status_Level_Mute[1] = libDrivers.Read_ControlInput2Status()

# -----------------------------------------
def Update_PowerSwitchStatus():
    global g_standby_mode
    global g_last_mute_status    #For No191
    global g_Status_Level_Mute   #For No191
    global g_mute_sys_status     #For S1-test
    global g_mute_ctrl_pulse     #For S1-test

    if libDrivers.PowerSW_KeyScan() == 0:				#POWER SW MODIFY I2C

        if libDrivers.Read_PowerSwitchStatus():		#POWER SW MODIFY I2C
            g_standby_mode ^= 1
            if g_standby_mode:
                libDrivers.Ctrl_Smute(1)
                Initialize_Status()
                #For No191
                g_last_mute_status = g_Status_Level_Mute[0] | g_Status_Level_Mute[1]
            else:
                with open(main_SPgain_sts_fname,'w') as f:
                    f.write(str(0))
                SP_gain = Sum_SP_Gain(main_SPgain_sts_fname, web_SPgain_sts_fname)
                #[0]:main, [1]:web, [2]:DSP
                #print(SP_gain)
                Set_OutputGain(SP_gain[2])
                #libDrivers.Initialize_DAC()
                #Set_Config()                #For No16,No120
                Update_CinConfigTable()
                libDrivers.Ctrl_Smute(0)
            libDrivers.Ctrl_LEDforPowerStandby(g_standby_mode)
            #For No191
            if g_standby_mode == 0:
                if g_last_mute_status != ( g_Status_Level_Mute[0] | g_Status_Level_Mute[1] ):
                    Update_MuteStatus( g_Status_Level_Mute[0] | g_Status_Level_Mute[1] )

                elif g_last_mute_status == 1:
                       libDrivers.Chg_IndicateMode(2)
                       libDrivers.Set_gpioMuteStatus(1)
                       libDrivers.Set_i2cMuteStatus(1)
# -----------------------------------------
def Exec_ShutdownSeq():
    if libDrivers.Is_ShutdownMode() == 1:  #POWER SW MODIFY I2C

        Set_Mute_for_StandbyMode()  #DSP MUTE

        #OUTPUT MUTE & AMP Power Off 制御　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(0) #DISENABLE

        libDrivers.Set_ADDA_Reset(0)
        libDrivers.Chg_AllLEDState(0)
        libDrivers.Ctrl_PowerLED(0)
        libDrivers.Ctrl_BluetoothLED(0)
        libDrivers.Ctrl_USBConnectionLED(0)
        libDrivers.Set_ControlOutput1(0)
        libDrivers.Set_ControlOutput2(0)

        #HeartBeat端子を出力ピンに設定
        libDrivers.Set_HeartBeat_OUTPUT()
        #ここでハード制御　BlueLEDを点灯
        libDrivers.Ctrl_POWER_Blue_LED_HARD(1)  #LED_ON
        kill = sp.Popen("sudo killall AMCF1-WebServer", shell=True)
        kill.wait()
        sp.run(["sh","/home/toa/StartupShell/instead_saveoverlays.sh","&"]) # Execute Shutdown command
# -----------------------------------------
def Update_RTC_Setting():
    global g_Count_RTC_Check
    Req_RTC_Setting = 0
    g_Count_RTC_Check += 1
    if(200 < g_Count_RTC_Check) :
        g_Count_RTC_Check = 0
        with open(time_setting_fname, 'r') as file:
            strings = file.read()
            if strings[0] == '1':
                Req_RTC_Setting = 1
        if Req_RTC_Setting == 1:
            WEBSTOP = sp.Popen("sudo killall AMCF1-WebServer", shell=True)
            WEBSTOP.wait()
            TimeAdjust()
            sp.Popen("sudo python3 /home/toa/TOA_AM-CF1/Webserver/manage.py runserver --insecure 0.0.0.0:8000", shell=True)
# -----------------------------------------
def Update_USBAudioConnectStatus():
    global g_Count_USBAudioConnectCheck
    g_Count_USBAudioConnectCheck += 1
    if 100 < g_Count_USBAudioConnectCheck:
        g_Count_USBAudioConnectCheck = 0
        if libDrivers.Get_UsbAudioStatus():
            libDrivers.Ctrl_USBConnectionLED(1)
        else :
            libDrivers.Ctrl_USBConnectionLED(0)
# -----------------------------------------
def Update_Config():
    global g_Status_Level_Mute
    global g_mute_ctrl_pulse
    global g_Cfg_CtrlInput
    global g_Count_ConfigCheck
    global g_standby_mode
    global g_mute_sys_status

    g_Count_ConfigCheck += 1
    if 100 < g_Count_ConfigCheck:
        g_Count_ConfigCheck = 0
        state_change = 0
        if os.path.exists('/home/toa/TOA_AM-CF1/CONT_LED_FLAG'):
            Set_Config()
            Update_CinConfigTable()
            os.remove('/home/toa/TOA_AM-CF1/CONT_LED_FLAG')

            #For No196
            #if g_standby_mode == 0:    #For No191,197
            # IN1
            if (g_Cfg_CtrlInput[0] != 2):
                if (g_Status_Level_Mute[0] != 0):
                    g_Status_Level_Mute[0] = 0
                    state_change = 1
            else: #For No189
                if (libDrivers.Get_ControlInput1() == 1):
                    if g_Status_Level_Mute[0] == 0:
                        g_Status_Level_Mute[0] = 1
                        state_change = 1
            # IN2
            if (g_Cfg_CtrlInput[1] != 2):
                if (g_Status_Level_Mute[1] != 0):
                    g_Status_Level_Mute[1] = 0
                    state_change = 1
            else: #For No189
                if (libDrivers.Get_ControlInput2() == 1):
                    if g_Status_Level_Mute[1] == 0:
                        g_Status_Level_Mute[1] = 1
                        state_change = 1

            if g_standby_mode == 0:
                if state_change:
                    #mute_status = g_is_edge_mute_in1 | g_is_edge_mute_in2 #For No133
                    g_mute_ctrl_pulse = 0
                    Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])
            #For No191,197
            #else:
            #    if state_change:
            #        g_mute_sys_status = g_mute_ctrl_pulse | g_Status_Level_Mute[0] | g_Status_Level_Mute[1]

# -----------------------------------------
def Update_Status():
    libDrivers.Update_FrontLEDStatus()
    Update_RTC_Setting()
    Update_Config()
# -----------------------------------------
def Confirm_Preset_Load():  #kura add 20171013 For No.180,214
    global g_mute_ctrl_pulse
    global g_mute_sys_status
    global g_Status_Level_Mute
    PRESET_LOAD_FLAG = "/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG"
    WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP

    if os.path.exists(PRESET_LOAD_FLAG):    #read Preset Load Flag from WEB or Control IN
        os.remove(PRESET_LOAD_FLAG)     #Delete FLAG

        if g_mute_sys_status == 1:  # Not only pulse mute==1 (because no judged level)
            g_mute_ctrl_pulse = 0   # mute pulse set 0 (pulse mute is released)
            g_mute_sys_status = 0   # mute sys status set 0 (if sys_status=1 then not set mute)
            Update_MuteStatus(g_Status_Level_Mute[0] | g_Status_Level_Mute[1])  # if either mute level = 1 then Set_Mute
            if os.path.exists(WEB_STOP_flag) == True:
                os.remove(WEB_STOP_flag)
# -----------------------------------------
def Main():
    try:
        print("Start application")

        Initialize_Device()     #Init I2C & GPIO

        #OUTPUT MUTE & AMP Power Off 制御　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(0) #DISENABLE

        #ここでハード制御　電源BlueLEDを消す
        libDrivers.Ctrl_POWER_Blue_LED_HARD(0)  #LED_OFF
        libDrivers.Ctrl_PowerLED(1) #LED_ON_GREEN

        # --- Initialze and setting---
        TimeAdjust()

        if Is_FactoryReset():  #ここでPOWER_SWを呼んでいる
            Exec_FactoryReset()

        # NetworkManager STOP add kura 20171030
        sp.run(['sudo','service','NetworkManager-wait-online','stop'])
        sp.run(['sudo','service','NetworkManager','stop'])

        Initialize_DspParameter()
        Create_Command()
        Set_Config()
        Activate_WebServer()

        #OUTPUT MUTE & AMP Power Off 解除　
        libDrivers.Ctrl_AUDIO_OUTPUT_ENABLE(1) #ENABLE

        # --- Define Variable
        global g_standby_mode
        global g_Cfg_CtrlInput
        for i in range(2):
            g_Cfg_CtrlInput.append(libDrivers.Get_CtrlInputCfg(i))

        WEB_STOP_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag' #if file exists then WEB_STOP

        global bf_LED_Num_prev
        bf_LED_Num_prev = 0

        LOOP_MIN_TIME = 0.070 ## sec
        # --- main loop ---
        while 1:
            start_time = time.perf_counter()
            #----------------------------------

            if libDrivers.Is_VolMode() == 1:
                #print('WebApp Update Disable')
                if os.path.exists(WEB_STOP_flag) == False:
                    with open(WEB_STOP_flag,'w') as f:
                        f.write(" ")
            if libDrivers.Is_NormalMode() == 1:
                #print('WebApp Update Enable')
                if os.path.exists(WEB_STOP_flag) == True:
                    os.remove(WEB_STOP_flag)
                    #print('DELETE')
            # --- Display ArrayMicrophone angle & level  ---
            Update_BeamAngle()  #Front LED Control

            if g_standby_mode == 0:
                # --- keyscan and control (i2c)---
                Update_SideSwitchStatus(libDrivers.Exec_KeyScan())
                # --- Control Input Scan ---
                Update_ControlInputStatus(libDrivers.CinScan())
                # --- Control Output ---
                libDrivers.Update_CtrlOutput()
                # --- USB Connection Check ---
                Update_USBAudioConnectStatus()
                #---- Confirm Preset load flag --- For No214,180 add by kura
                Confirm_Preset_Load()

            #For No191,No197
            else:
                Update_ControlInputStatus_forStandbyMode(libDrivers.CinScan())

            # --- Bluetoorh Control ---
            libDrivers.LibBT_Control( g_standby_mode )
            # --- keyscan Power Switch ---
            Update_PowerSwitchStatus()
            # --- Shutdown ---
            Exec_ShutdownSeq()
            # --- Update LED, Control output, RTC ---
            Update_Status()  #Front LED Control

            end_time = time.perf_counter()
            if end_time > start_time:
                diff_time = end_time - start_time
                if LOOP_MIN_TIME > diff_time:
                    time.sleep(LOOP_MIN_TIME - diff_time)

    except KeyboardInterrupt:
        Show_Error()
        sys.exit()
    except:
        pass
# -----------------------------------------
if __name__ == '__main__':
    Main()
    print("Exception : Exit Main.py")
    Show_Error()
    libDrivers.Initialize_FrontPanel()
    print("ADDA RESET")
    libDrivers.Set_ADDA_Reset(0)
    time.sleep(1)
    libDrivers.Set_ADDA_Reset(1)
    print("DSP RESET")
    os.system("sudo python3 /home/toa/TOA_AM-CF1/Application/data/dspreset.py")
    Dump_ExceptionLog("section_main_loop")
