/************************************************************************
 *
 *	coeff_lpf12.c
 *
 *	20020920	Tsuyoshi Ogawa
 *
 ************************************************************************/
#include "fdesign_prototypes.h"

#ifndef	NULL
#include <stdio.h>
#endif

namespace dsp_lib {

/*============================================================*/
void
Fdesign_LPF12_CheckParameter(
	float*	f_,
	float*	q_
)
{
	Fdesign_XOverLPF12_CheckParameter(f_, q_, NULL);
}

/*============================================================*/
void
Fdesign_LPF12(
	float	f_,
	float	q_,
	int		bypass_,
	float*	coeff_
)
{
	Fdesign_XOverLPF12(f_, q_, 1.0f, bypass_, coeff_);
}
/*============================================================*/
} // namespace dsp_lib
