/*
 * misc.h
 *
 *  Created on: 2017/01/12
 *      Author: toa29548
 */

#pragma once

#include <cmath>
#include <stdint.h>

namespace dsp_lib {

inline bool
IsPowerOf2(uint32_t x_) {
	return (((x_)&(x_-1)) == 0)&&(x_>0);
}

inline int
NextPow2(int n_) {
    if(n_ < 0) {
        return 0;
    }
    if(n_ == 1) {
        return 1;
    }

    float	foo = log10(static_cast<float>(n_-1)) / log10(2.0f);

    return static_cast<int>(pow(2.0f, floor(foo) + 1.0f));
}

} //namespace dsp_lib
