/*
 * spi.h
 */

//********************************************************************************
#pragma once

//********************************************************************************
#include <stdint.h>
#include "spi_mode.h"

//********************************************************************************
bool
SpiWrite(
	const uint32_t	address_,
	const uint32_t	data_,
	const uint32_t	dev_num_
);

bool
SpiRead(
	const uint32_t	address_,
	uint32_t*		data_,
	const uint32_t	dev_num_
);
