//*voli_rdsd.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

var now_load_preset = 1; //grobal. used preset_upload.js

ws.onerror = function () {
    alert('Failure to connect')
};

ws.onopen = function () {
    ws.send(
        'ud_state'
    );
    
    ws.send(
        ' read ' + ' config '
    );

    ws.send(
        ' read ' + ' preset '
    )

    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:usbin_gain, 2:BTin_gain,
        //3:Codecin_gain, 4:AUXin_gain,
        //5:SPout_gain, 6:USBout_gain,
        //7:BT_gain, 8:Codecout_gain,
        //9:AUX_gain, 10～18:mute_sts*9 (0:ON 1:OFF)
        var arrayString = e.data.split(",");
        if (arrayString[0] == 'dialog') {
            alert(arrayString[1])

        } else if (arrayString[0] == 'config') {
            controls.config.NETWORK.ipfields[0].ip.updateValue(arrayString[1])
            controls.config.NETWORK.ipfields[1].ip.updateValue(arrayString[2])
            controls.config.NETWORK.ipfields[2].ip.updateValue(arrayString[3])
            controls.config.USER.username.text.updateValue(arrayString[4])
            controls.config.USER.password.text.updateValue(arrayString[5])

            if (arrayString[6] == 'Volume_Up') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Up")
            } else if (arrayString[6] == 'Volume_Down') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[0].input.updateValue(arrayString[6])
            }
            if (arrayString[7] == 'Volume_Up') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Up")
            } else if (arrayString[7] == 'Volume_Down') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[1].input.updateValue(arrayString[7])
            }

            if (arrayString[8] == 'Mute_Status') {
                controls.config.CONTACT.outputs[0].output.updateValue("Mute Status")
            } else if (arrayString[8] == 'Synch_Input1') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input1")
            } else if (arrayString[8] == 'Synch_Input2') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[0].output.updateValue(arrayString[8])
            }

            if (arrayString[9] == 'Mute_Status') {
                controls.config.CONTACT.outputs[1].output.updateValue("Mute Status")
            } else if (arrayString[9] == 'Synch_Input1') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input1")
            } else if (arrayString[9] == 'Synch_Input2') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[1].output.updateValue(arrayString[9])
            }

            controls.config.INDICATE.toggles[0].onoff.updateValue(arrayString[10])
            controls.config.INDICATE.toggles[1].onoff.updateValue(arrayString[11])
            if (arrayString[12] == 'Only_Center') {
                controls.config.INDICATE.mute.mute.updateValue("Only Center")
            } else if (arrayString[12] == 'ALL_LED') {
                controls.config.INDICATE.mute.mute.updateValue("ALL LED")
            }
            // Add CPU Version and DSP Version data
            document.getElementById("firm_version").textContent = arrayString[13];
            if (arrayString.length > 14){
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    arrayString[14] + "/" + arrayString[15] + "/" +
                    arrayString[16] + " " + arrayString[17] + ":" +
                    arrayString[18];
            }else{
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    "Failed to load.";
            }

        } else if (arrayString[0] == 'preset' && arrayString[1] == 'df') {
            if (arrayString[2] == '1') {
                controls.preset.SETTINGS.default.preset.updateValue('Preset 1')
            } else {
                controls.preset.SETTINGS.default.preset.updateValue('Preset 2')
            }
            if (arrayString[3] == '1') {
                $('#select_preset1').css("visibility", "visible");
                $('#select_preset2').css("visibility", "hidden");
                now_load_preset = 1;
            } else if(arrayString[3] == '2') {  //change kura 20171025
                $('#select_preset2').css("visibility", "visible");
                $('#select_preset1').css("visibility", "hidden");
                now_load_preset = 2;
            }
        }
    }
}

//Check mark means default Preset number//

$(function () {
    $('#preset_send').on('click', function () {
        // preset1.txt -> set_command_json -> DSP
        if (controls.preset.SETTINGS.default.preset.value == 'Preset 1') {
            var DFPreNo = 1;
        } else {
            var DFPreNo = 2;
        }

        ws.send(' send ' + ' preset ' + DFPreNo)
        // websokcet already close? readyState:2 closing, 3 closed
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});

$(function () {
    $('#preset1_load').on('click', function () {
        // get_command_json -> DSP -> result_json -> preset1.txt
        var text = $(this).attr('data-text');
        if (confirm(text)) {
            $.blockUI({
                message: "Please wait...",
                baseZ: 1000000  //一番手前で表示する
            });
            ws.send(' load ' + ' preset ' + ' p1 ');
            // websokcet already close? readyState:2 closing, 3 closed
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
                $.unblockUI();
            } else {
                ws.onmessage = function (e) {
                    var arrayString = e.data.split(",");
                    if (arrayString[0] == 'dialog') {
                        alert(arrayString[1])
                        $('#select_preset1').css("visibility", "visible");
                        $('#select_preset2').css("visibility", "hidden");
                        now_load_preset = 1;
                        $.unblockUI();
                    }
                }
            }
        }
        return;
    });
});

$(function () {
    $('#preset1_store').on('click', function () {
        // preset0.txt -> preset1.txt (not dsp)
        var text = $(this).attr('data-text');
        if (confirm(text)) {
            $.blockUI({
                message: "Please wait...",
                baseZ: 1000000  //一番手前で表示する
            });
            ws.send(' store ' + ' preset ' + ' p1')
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
                $.unblockUI();
            } else {
                ws.onmessage = function (e) {
                    var arrayString = e.data.split(",");
                    if (arrayString[0] == 'dialog') {
                        alert(arrayString[1])
                        $.unblockUI();
                    }
                }
            }
        }
        return;
    });
});

$(function () {
    $('#preset1_reset').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        var text = $(this).attr('data-text');
        if (confirm(text)) {
            $.blockUI({
                message: "Please wait...",
                baseZ: 1000000  //一番手前で表示する
            });
            ws.send(' reset ' + ' preset ' + ' p1 ')
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
                $.unblockUI();
            } else {
                ws.onmessage = function (e) {
                    var arrayString = e.data.split(",");
                    if (arrayString[0] == 'dialog') {
                        alert(arrayString[1])
                        $.unblockUI();
                    }
                }
            }
        }
        return;
    });
});


$(function () {
    $('#preset2_load').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        var text = $(this).attr('data-text');
        if (confirm(text)) {
            $.blockUI({
                message: "Please wait...",
                baseZ: 1000000  //一番手前で表示する
            });
            ws.send(' load ' + ' preset ' + ' p2 ')
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
                $.unblockUI();
            } else {
                ws.onmessage = function (e) {
                    var arrayString = e.data.split(",");
                    if (arrayString[0] == 'dialog') {
                        alert(arrayString[1])
                        $('#select_preset1').css("visibility", "hidden");
                        $('#select_preset2').css("visibility", "visible");
                        now_load_preset = 2;
                        $.unblockUI();
                    }
                }
            }
        }
        return;
    });
});

$(function () {
    $('#preset2_store').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        var text = $(this).attr('data-text');
        if (confirm(text)) {
            $.blockUI({
                message: "Please wait...",
                baseZ: 1000000  //一番手前で表示する
            });
            ws.send(' store ' + ' preset ' + ' p2 ')
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
                $.unblockUI();
            } else {
                ws.onmessage = function (e) {
                    var arrayString = e.data.split(",");
                    if (arrayString[0] == 'dialog') {
                        alert(arrayString[1])
                        $.unblockUI();
                    }
                }
            }
        }
        return;
    });
});

$(function () {
    $('#preset2_reset').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        var text = $(this).attr('data-text');
        if (confirm(text)) {
            $.blockUI({
                message: "Please wait...",
                baseZ: 1000000  //一番手前で表示する
            });
            ws.send(' reset ' + ' preset ' + ' p2 ')
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
                $.unblockUI();
            } else {
                ws.onmessage = function (e) {
                    var arrayString = e.data.split(",");
                    if (arrayString[0] == 'dialog') {
                        alert(arrayString[1])
                        $.unblockUI();
                    }
                }
            }
        }
        return;
    });
});

(function () {
    var ip_form = document.getElementById("ipchange")
    var config_down = document.getElementById("config_down")
    var div_ip = document.getElementById("ipaddress")
    var preset_down = document.getElementById("preset_down")


    ip_form.setAttribute("action", "http://" + NOW_IPADDRESS + "/ipchange.php");
    config_down.setAttribute("action", "http://" + NOW_IPADDRESS + "/config_download.php");
    div_ip.setAttribute("title", NOW_IPADDRESS);
    preset_down.setAttribute("action", "http://" + NOW_IPADDRESS + "/preset_download.php");

})();