<html lang="en">
<!--<![endif]-->

<head>
  <meta charset="utf-8" />
  <meta name="HandheldFriendly" content="True" />
  <meta name="format-detection" content="telephone=no" />
  <meta name="viewport" content="width=1200" />
  <meta name="description" content=" " />
  <meta name="keywords" content=" " />
  <title>Volume</title>
  <link rel="stylesheet" href="css/select2.css"/>
  <link rel="stylesheet" href="css/fancybox.css"/>
  <link rel="stylesheet" href="css/style.css?<?php echo uniqid(); ?>"/>

<script src="js/jquery-1.12.3.min.js"></script>
<script src="js/jquery.blockUI.js"></script>


  <!--[if IE]>
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
    <meta http-equiv="cleartype" content="on" />
  <![endif]-->
  <!--[if lte IE 9]>
    <script src={% static "js/vendors/html5shiv.min.js" %} ></script>
    <script src={% static "js/vendors/placeholders.min.js" %} ></script>
    <script src={% static "js/vendors/IE9.min.js" %} ></script>
  <![endif]-->
</head>

<body screen-id="ipchange">
<center>

<br><br><br><br>

<div><ul>
<?php

//DjangoからApacheのAjax実行の許可（本当は*をDjangoのOriginにしたいが、{{ipaddress}}を使えないから面倒）
//header('Access-Control-Allow-Origin: *');

//エラー表示
//ini_set("display_errors", On);
//error_reporting(E_ALL);

// 最初から結果が出力されるように、多数の空白を出力する
echo str_repeat( ' ', 1024 );

//URLをリンク化させるために必要
$pattern = '/((?:https?|ftp):\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)/u';
$replacement = '<a href="\1">\1</a>';

// 入力されたIPアドレス
$box_ip = [basename($_POST['box_ip1']), basename($_POST['box_ip2']),
             basename($_POST['box_ip3']), basename($_POST['box_ip4'])];
$box_ip = str_to_val($box_ip);
$ipaddress = "$box_ip[0].$box_ip[1].$box_ip[2].$box_ip[3]";
//echo "IP address: $ipaddress"; echo nl2br("\n");

//入力されたサブネットマスク
$box_submask = [basename($_POST['box_submask1']), basename($_POST['box_submask2']),
             basename($_POST['box_submask3']), basename($_POST['box_submask4'])];
$box_submask = str_to_val($box_submask);
$submask = "$box_submask[0].$box_submask[1].$box_submask[2].$box_submask[3]";
//echo "subnet mask: $submask"; echo nl2br("\n");

//入力されたデフォルトゲートウェイ
$box_gway = [basename($_POST['box_gway1']), basename($_POST['box_gway2']),
             basename($_POST['box_gway3']), basename($_POST['box_gway4'])];
$box_gway = str_to_val($box_gway);
$gway = "$box_gway[0].$box_gway[1].$box_gway[2].$box_gway[3]";
//echo "subnet mask: $gway"; echo nl2br("\n");

//各ブロックは数値の0~255のはず && submask ok
if (val_or_not($box_ip) && val_or_not($box_submask) && val_or_not($box_gway)
        && ipv4_check($box_ip) && ipv4_check($box_submask) && ipv4_check($box_gway)
	&& subnetmask($submask) && ip_check($ipaddress, $submask, $gway)) {

?>
    <script>
        $.blockUI({
            message: "Changing IP address.",
            baseZ: 1000000,  //一番手前で表示する
            fadein: 0,
            fadeout: 0,
            overlayCSS:  {
                backgroundColor: '#262626',
                opacity: 1,
                cursor: 'wait'
            },
        });
        setTimeout($.unblockUI, 30000);
    </script>
<?php
    // 出力バッファの内容を送信する
    ob_flush();
    flush();    

    sleep(1);

    echo "Congratulations!";
    echo nl2br("\n");
    echo "You have successfully updated the IP address.";
    echo nl2br("\n\n");
    echo "IP Address      : $ipaddress";
    echo nl2br("\n");
    echo "Subnet Mask     : $submask";
    echo nl2br("\n");
    echo "Default Gateway : $gway";
    echo nl2br("\n");

    // URLをリンク化
    echo nl2br("\n");
    //echo "Your new address: ";
    //echo preg_replace($pattern, $replacement, "http://$ipaddress:8000");
    ?>
    
    <input type="button" onClick="location.href='<?php echo "http://$ipaddress:8000"; ?>'"
     value=" Click here to go to the new address. ">
    
    <?php

    // 出力バッファの内容を送信する
    ob_flush();
    flush();

    // ip変更のシェル実行
    $output = shell_exec("sh ./ipchange.sh $ipaddress $submask $gway");

    sleep(3);
} else {
    echo "Incorrect IP Address";
    echo nl2br("\n");
    echo "IP Address      : $ipaddress";
    echo nl2br("\n");
    echo "Subnet Mask     : $submask";
    echo nl2br("\n");
    echo "Default Gateway : $gway";
    echo nl2br("\n");
//    echo "Your input is invalid. Please input again.";
    echo nl2br("\n");

    echo "Go back to " . preg_replace($pattern, $replacement, $_SERVER['HTTP_REFERER']);

    // 出力バッファの内容を送信する
    ob_flush();
    flush();
}
//----------------------------------------------------------------------------

//不正なIPをチェックする関数
function ip_check($ipaddress, $submask, $gway)
{
	$flag = false;
    $check_py = "/home/toa/TOA_AM-CF1/Application/data/check_ip_sm_dg.py";
	$result = shell_exec("python3 $check_py $ipaddress $submask $gway");
	if ($result != 0) {
		$flag = false;
	} else {
		$flag = true;
	}
	return $flag;
}


//配列の全ての要素を整数に変換する関数
function str_to_val($arr)
{
    for ($i=0; $i<count($arr); $i++) {
        $arr[$i] = intval($arr[$i]);
    }
    return $arr;
}

//配列の全ての要素が数値であるか確認する関数
function val_or_not($arr)
{
    $flag = false;
    for ($i=0; $i<count($arr); $i++) {
        if (ctype_digit(strval($arr[$i]))) {
            $flag = true;
        } else {
            $flag = false;
        }
    }
    return $flag;
}

// 0～255であることを確認する関数
function ipv4_check($arr)
{
    $flag = false;
    for ($i=0; $i<count($arr); $i++) {
        if ($arr[$i] >= 0 && $arr[$i] <=255) {
            $flag = true;
        } else {
            $flag = false;
        }
    }
    return $flag;
}

// Validation for Subnet mask
function subnetmask($par_submask)
{
	$flag = false;
	$submask = shell_exec("sh /home/toa/StartupShell/calc_subnet_bit.sh $par_submask");
	if ($submask < 0) {
		$flag = false;
	} else {
		$flag = true;
	}
	return $flag;
}

?>
</ul></div>
</center>

</body>

</html>
