# -*- coding:utf-8 -*-
import json
import subprocess as sp
import copy,os,sys,time
import codecs
import fcntl    # for ファイル排他
import inspect  # for ログ
import shutil
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command
from check_preset_config import Check_Preset_Data
from check_preset_config import Check_Config_Data
from param_set_get_flag import Wait_Param_Set_Flag
from eq_setting_param import Write_eq_param
import lbl_const as lbl
from master_data_const import GetDefault_Conf_Bluetooth
import master_data_const
import define_const as dc
from data_converter import Convert_nlp_ratio_1
#    pythonスクリプトの中で、pythonを実行
#    # Python実行
#    subprocess.call('python ../script/test.py')

codecs_open_char = 'utf-8' #ファイルオープン時文字コード定義(www-dataがアクセスする対象ファイルは、fopen時に文字コード定義が必要)
codecs_open_ignore = 'ignore' #読み込むときに定義

def startup():
    sp.run(['./startup.out','../../tmp/block_cf1_init.json','netlist.bin'])  #change!!

    sp.run(['./control.out','../../tmp/command_cf1_init_gain.json'  ,'netlist.bin', '../../tmp/result_init_gain.json'   ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_comp.json'        ,'netlist.bin', '../../tmp/result_init_comp.json'          ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_iir.json'         ,'netlist.bin', '../../tmp/result_init_iir.json'           ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_aec_nc.json'      ,'netlist.bin', '../../tmp/result_init_aec_nc.json'        ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_matrix.json'      ,'netlist.bin', '../../tmp/result_init_matrix.json'        ])  #change!!

def Confirm_Config_Setting(label):
    with open("/home/toa/TOA_AM-CF1/Application/data/config/config_contled.txt",'r') as f:
        config = f.readlines()
    # Mic Mute Func: 0:off, 1:on(default)
    if label == "MIC_MUTE":
        value = config[8].split(",")

        if (dc.ON in value[1]):
            ret = dc.ON
        else:
            ret = dc.OFF #configファイル壊れてても最悪初期値で起動する意図

    elif label == "SPOUT_ASSIGN_CODEC":
        value = config[9].split(",")

        if (dc.OFF in value[1]):
            ret = dc.OFF
        else:
            ret = dc.ON #configファイル壊れてても最悪初期値で起動する意図

    elif label == "SPOUT_ASSIGN_AUX":
        value = config[10].split(",")

        if (dc.OFF in value[1]):
            ret = dc.OFF
        else:
            ret = dc.ON #configファイル壊れてても最悪初期値で起動する意図

    return ret

#Webserver/templates/commandのcommand.jsonもここで作る必要あり
PATH = '/home/toa/TOA_AM-CF1/Application/data/'

def Make_init_gain(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_gain.txt'
    mute_sts_fname = PATH + '../../tmp/volume/' + 'mute_sts.txt' #Change!!
    WEB_SP_gain_fname = PATH + '../../tmp/volume/' + 'web_SPgain_sts.txt' #Change!!
    SPout_block_no = BlockNo.GAIN_SPoutL #SP OUT L
    mute_or_unmute_blockno = [
        BlockNo.GAIN_USBinL,BlockNo.GAIN_USBinR,BlockNo.GAIN_BTinL,BlockNo.GAIN_BTinR,BlockNo.GAIN_CODECin,BlockNo.GAIN_AUXinL,BlockNo.GAIN_AUXinR,
        BlockNo.GAIN_SPoutL,BlockNo.GAIN_SPoutR,BlockNo.GAIN_USBoutL,BlockNo.GAIN_USBoutR,BlockNo.GAIN_BToutL,BlockNo.GAIN_CODECout,BlockNo.GAIN_AUXoutL,BlockNo.GAIN_AUXoutR] # (Ref.) WEB Mixer Left to Right 
    ##################### Dynamic Change #####################
    blocknums = []
    gain_vals = []
    mute_sts = []
    mute_web_gain_sts =[]
    mute_blockno = []

    MUTE_GAIN = -150

    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            gain_vals.append(vals[1])
            if len(vals) >= 3:
                mute_blockno.append(vals[0])
                mute_sts.append(vals[2])
                mute_web_gain_sts.append(vals[1])

    if mute_sts[0] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[0])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[1])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[0])] = gain_vals[blocknums.index(mute_or_unmute_blockno[0])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[1])] = gain_vals[blocknums.index(mute_or_unmute_blockno[0])]

    if mute_sts[1] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[2])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[3])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[2])] = gain_vals[blocknums.index(mute_or_unmute_blockno[2])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[3])] = gain_vals[blocknums.index(mute_or_unmute_blockno[2])]

    if mute_sts[2] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[4])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[4])] = gain_vals[blocknums.index(mute_or_unmute_blockno[4])]

    if mute_sts[3] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[5])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[6])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[5])] = gain_vals[blocknums.index(mute_or_unmute_blockno[5])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[6])] = gain_vals[blocknums.index(mute_or_unmute_blockno[5])]

    if mute_sts[4] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[7])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[8])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[7])] = gain_vals[blocknums.index(mute_or_unmute_blockno[7])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[8])] = gain_vals[blocknums.index(mute_or_unmute_blockno[7])]

    if mute_sts[5] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[9])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[10])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[9])] = gain_vals[blocknums.index(mute_or_unmute_blockno[9])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[10])] = gain_vals[blocknums.index(mute_or_unmute_blockno[9])]

    if mute_sts[6] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[11])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[11])] = gain_vals[blocknums.index(mute_or_unmute_blockno[11])]

    if mute_sts[7] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[12])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[12])] = gain_vals[blocknums.index(mute_or_unmute_blockno[12])]

    if mute_sts[8] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[13])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[14])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[13])] = gain_vals[blocknums.index(mute_or_unmute_blockno[13])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[14])] = gain_vals[blocknums.index(mute_or_unmute_blockno[13])]

    blocknums.extend(blocknums)
    blk_ln = len(gain_vals)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = int(blocknums[i])
        commands[i]['type'] = 'gain'
        commands[i]['param'] = {'gain':None}

    for i in range(0,blk_ln):
        commands[i]['access'] = 'set'
        if commands[i]['block_no'] == BlockNo.GAIN_SPoutL or commands[i]['block_no'] == BlockNo.GAIN_SPoutR:
            commands[i]['param']['gain'] = int(gain_vals[i]) #Sum SP out
        else:
            commands[i]['param']['gain'] = int(gain_vals[i])
    

    ### Config ファイル 読み込み (contled.txt)
    ### Mic mute ON/OFFを確認
    ### ONなら素通り。OFFならマイクミュート
    # config設定読み込み
    # 先にPresetファイルより先にConfig設定を読むと、Preset読み込み時に変数を上書きするため、ここで読み込んで書き換える。
    # Presetファイルがマイクゲインを持ってしまっている。
    MUTE_ON_GAIN = -100
    if Confirm_Config_Setting("MIC_MUTE") == dc.ON:
        # マイク機能OFF
        for i in range(0,blk_ln):
            if commands[i]['block_no'] == BlockNo.GAIN_MIC:
                commands[i]['param']['gain'] = MUTE_ON_GAIN


    with codecs.open(c_fname,'w', codecs_open_char, codecs_open_ignore) as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    with codecs.open(mute_sts_fname,'r+' if os.path.exists(mute_sts_fname) else 'w', codecs_open_char, codecs_open_ignore) as f:
        try:
            # write 時は'r+'で open して排他ロック
            fcntl.flock(f, fcntl.LOCK_EX)
            if f.mode == 'r+':
                f.truncate(0)
                f.seek(os.SEEK_SET)

            f.write(",".join(mute_sts))
            f.write('\n')
            f.write(",".join(mute_web_gain_sts))
        except IOError as io_ex:
            print('[{0}] exception : {1}'.format(
                inspect.currentframe().f_code.co_name, io_ex))

    sp_index = mute_blockno.index(str(SPout_block_no))
    with codecs.open(WEB_SP_gain_fname,'r+' if os.path.exists(WEB_SP_gain_fname) else 'w', codecs_open_char, codecs_open_ignore) as f:
        try:
            # write 時は'r+'で open して排他ロック
            fcntl.flock(f, fcntl.LOCK_EX)
            if f.mode == 'r+':
                f.truncate(0)
                f.seek(os.SEEK_SET)

            f.write(mute_web_gain_sts[sp_index])
            f.write('\n')
            f.write(mute_sts[sp_index])
        except IOError as io_ex:
            print('[{0}] exception : {1}'.format(
                inspect.currentframe().f_code.co_name, io_ex))

def Make_init_comp(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_comp.txt'
    ##################### Static No Change #####################
    blocknums = []
    at_t = []
    rl_t = []
    thr = []
    mkup_g = []
    rto = []
    knee = []
    lv_typ = []

    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            at_t.append(float(vals[1]))
            rl_t.append(float(vals[2]))
            thr.append(float(vals[3]))
            mkup_g.append(float(vals[4]))
            rto.append(float(vals[5]))
            knee.append(vals[6])
            lv_typ.append(vals[7])

    blocknums.extend(blocknums)
    blk_ln = int(len(blocknums)/2)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = blocknums[i]
        commands[i]['type'] = 'comp'
        commands[i]['param'] = {'attack_time':None, 'release_time':None, 'threshold':None, 'makeup_gain':None, 'ratio':None, 'knee':None, 'level_type':None}

        if i < blk_ln:
            commands[i]['access'] = 'set'
            commands[i]['param']['attack_time'] = at_t[i]
            commands[i]['param']['release_time'] = rl_t[i]
            commands[i]['param']['threshold'] = thr[i]
            commands[i]['param']['makeup_gain'] = mkup_g[i]
            commands[i]['param']['ratio'] = rto[i]
            commands[i]['param']['knee'] = knee[i]
            commands[i]['param']['level_type'] = lv_typ[i]
        else:
            commands[i]['status'] = {'gain_target':None, 'gain_current':None, 'peak':None, 'rms':None}
    
    with codecs.open(c_fname,'w', codecs_open_char, codecs_open_ignore) as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

def Make_init_iir(preset_no,c_fname):
    # 工場出荷設定時のみ preset_no = 0 が入るため、必ず preset0_1_iir.txtを読み込む。
    if preset_no == 0:
        preset_fname = PATH + './preset/preset0_1_iir.txt'
    else:
        preset_fname = PATH + './preset/preset' + str(preset_no) + '_iir.txt'
    EQSP_param_fname = PATH + '../../tmp/EQ/EQSP_set_param.txt'
    EQAUX_param_fname = PATH + '../../tmp/EQ/EQAUX_set_param.txt'
    ##################### Dynamic Change #####################
    blocknums = []
    stagenums = []

    typs = []
    freq = []
    gain = []
    q = []

    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            stagenums.append(int(vals[1]))
            typs.append(vals[2])
            freq.append(float(vals[3]))
            q.append(float(vals[4]))
            gain.append(float(vals[5]))

    SP_types = []
    SP_freqs = []
    SP_gains = []
    SP_qs = []
    AUX_types = []
    AUX_freqs = []
    AUX_gains = []
    AUX_qs = []

    for i in range(len(blocknums)):
        if blocknums[i] == BlockNo.EQ_SPoutL:
            SP_types.append(typs[i])
            SP_freqs.append(str(freq[i]))
            SP_gains.append(str(gain[i]))
            SP_qs.append(str(q[i]))
        elif blocknums[i] == BlockNo.EQ_AUXoutL:
            AUX_types.append(typs[i])
            AUX_freqs.append(str(freq[i]))
            AUX_gains.append(str(gain[i]))
            AUX_qs.append(str(q[i]))
    
    Write_eq_param(EQSP_param_fname, SP_types, SP_freqs, SP_qs, SP_gains)
    Write_eq_param(EQAUX_param_fname, AUX_types, AUX_freqs, AUX_qs, AUX_gains)

    blk_ln = len(blocknums)

    blocknums.extend(blocknums)
    stagenums.extend(stagenums)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {},
        'config': {},
        'status': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = blocknums[i]
        commands[i]['type'] = 'iir'
        commands[i]['param'] = {'stage':None, 'type':None, 'frequency':None, 'q':None, 'gain':None}
        commands[i]['param']['stage'] = stagenums[i]

    for i in range(0,blk_ln):
        commands[i]['access'] = 'set'
        commands[i]['param']['type'] = typs[i]
        commands[i]['param']['frequency'] = freq[i]
        commands[i]['param']['q'] = q[i]
        commands[i]['param']['gain'] = gain[i]

    with codecs.open(c_fname,'w', codecs_open_char, codecs_open_ignore) as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)


def Make_init_aec_nc(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_aec_nc.txt'
    conf_data_fname = PATH + '../../tmp/audio/' + 'audio_set_conf.txt' #change!!
    ##################### Dynamic Change #####################
    blocknums = []

    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        vals = f.readlines()
        aec_prms = vals[1].strip().split(',') ## Qモデルでは、"mu_"パラメータを'/'区切りにしてください。
        nc_prms = vals[3].strip().split(',')
        bf_prms = vals[5].strip().split(',')
        conf_prms = vals[7].strip()

        del aec_prms[0] #0番目のblock番号要素を削除
        del nc_prms[0] #0番目のblock番号要素を削除
        del bf_prms[0] #0番目のblock番号要素を削除

        ## mu_パラメータを抽出し、'[]'削除し、/'で区切り、floatに変換
        _mu_prms = aec_prms[1].lstrip('[').rstrip(']').split('/')
        mu_prms = [float(i) for i in _mu_prms]

    # WEB設定を変数に格納(nlp_ratio1パラメータ決定用)
    split_conf_prms = conf_prms.split(',')
    nlplevel = split_conf_prms[2] #NLP Level high/mid/low
    aeconoff = split_conf_prms[3] #AEC on/off
    
    command = {
        'access': 'get',
        'block_no': None,
        'type': None,
        'param': {},
        'config': {},
        'status': {}
    }

    commands = []

    ## blocknumsでは、param_set_flagを確実に最後に設定するため、BlockNo.AECを末尾にも定義している
    blocknums=[BlockNo.AEC,BlockNo.NC,BlockNo.BF,BlockNo.AEC]
    blk_ln = len(blocknums)

    cnt = 0 #preset.txt 2行ごとにカウントアップする
    for i in range(0,((blk_ln)*2)):
        commands.append(copy.deepcopy(command))
        if i % 2 == 0:
            commands[i]['access'] = 'set'
            commands[i]['block_no'] = int(blocknums[cnt])
        else:
            commands[i]['block_no'] = int(blocknums[cnt])
            cnt = cnt + 1
    #0,1
    for i in range(0,2):
        commands[i]['type'] = 'aec'
        commands[i]['param'] = {'on':None,'mu_':None,'errmu_limit':None,'rcv_dly_':None,'nlp_ratio0':None,'nlp_ratio1':None,
                                'nlp_enhance0':None,'nlp_enhance1':None,'nlp_alpha0':None,'nlp_alpha1':None,'nlp_alpha2':None,'nlp_step':None,
                                'drc_compTh':None,'drc_compRatio':None,'drc_compGain':None,'drc_boostTh':None,'drc_boostRatio':None,'drc_boostGain':None,
                                'drc_AT':None,'drc_RT':None,'mic_mute':None,'cng_noise':None,'bmInput_fixedGain':None,'nlp_fixedGain':None,'drc_fixedGain':None
                                }
        if i % 2 == 0:
            if aec_prms[0] == 'true':
                commands[i]['param']['on'] = True
            else:
                commands[i]['param']['on'] = False
            commands[i]['param']['mu_'] = mu_prms
            commands[i]['param']['errmu_limit'] = float(aec_prms[2])
            commands[i]['param']['rcv_dly_'] = int(aec_prms[3])
            commands[i]['param']['nlp_ratio0'] = float(aec_prms[4])

            commands[i]['param']['nlp_ratio1'] = float(aec_prms[5])
            # 以下、nlp_ratio1をAEC_ONOFF、NLP Levelより判断する処理
            ## DSPパラメータ調整時、presetファイルのnlp_ratio1の値をそのまま反映させたい場合は、ここから下をコメントアウトしてください。(use preset nlp_ratio1)
            if aeconoff == "ON":
                commands[i]['param']['nlp_ratio1'] = Convert_nlp_ratio_1(nlplevel)
            else:
                commands[i]['param']['nlp_ratio1'] = dc.NLP_LEVEL_AECOFF
            ## ここまでコメントアウト(use preset nlp_ratio1)

            commands[i]['param']['nlp_enhance0'] = float(aec_prms[6])
            commands[i]['param']['nlp_enhance1'] = float(aec_prms[7])
            commands[i]['param']['nlp_alpha0'] = float(aec_prms[8])
            commands[i]['param']['nlp_alpha1'] = float(aec_prms[9])
            commands[i]['param']['nlp_alpha2'] = float(aec_prms[10])
            commands[i]['param']['nlp_step'] = int(aec_prms[11])
            commands[i]['param']['drc_compTh'] = int(aec_prms[12])
            commands[i]['param']['drc_compRatio'] = int(aec_prms[13])
            commands[i]['param']['drc_compGain'] = int(aec_prms[14])
            commands[i]['param']['drc_boostTh'] = int(aec_prms[15])
            commands[i]['param']['drc_boostRatio'] = int(aec_prms[16])
            commands[i]['param']['drc_boostGain'] = int(aec_prms[17])
            commands[i]['param']['drc_AT'] = int(aec_prms[18])
            commands[i]['param']['drc_RT'] = int(aec_prms[19])
            commands[i]['param']['mic_mute'] = False #false固定 v1.4.0でMicMuteON状態でPresetStore&DLされた場合のLoad時不具合対策
            commands[i]['param']['cng_noise'] = float(aec_prms[21])
            commands[i]['param']['bmInput_fixedGain'] = float(aec_prms[22])
            commands[i]['param']['nlp_fixedGain'] = float(aec_prms[23])
            commands[i]['param']['drc_fixedGain'] = float(aec_prms[24])

    #2,3
    for i in range(2,4):
        commands[i]['type'] = 'nc'
        commands[i]['param'] = {'bypass':None,'reduction_level':None}
        if i % 2 == 0:
            if nc_prms[0] == 'true':
                commands[i]['param']['bypass'] = True
            else:
                commands[i]['param']['bypass'] = False
            commands[i]['param']['reduction_level'] = int(nc_prms[1])
    #4,5
    for i in range(4,6):
        commands[i]['type'] = 'microphonearray'
        commands[i]['param'] = {'dir':None,'dis':None,'update_mode':None}
        commands[i]['param']['doa']= {'peak_threshold':None,'smooth_tc':None,'source_pos_x_max':None,'source_pos_y_max':None,'source_pos_x_min':None,'source_pos_y_min':None}
        if i % 2 == 0:
            commands[i]['param']['dir'] = int(bf_prms[0])
            commands[i]['param']['dis'] = float(bf_prms[1]) #[m]
            commands[i]['param']['update_mode'] = bf_prms[2]
            commands[i]['param']['doa']['peak_threshold'] = int(bf_prms[3])
            commands[i]['param']['doa']['smooth_tc'] = float(bf_prms[4])
            commands[i]['param']['doa']['source_pos_x_min'] = float(bf_prms[5])
            commands[i]['param']['doa']['source_pos_x_max'] = float(bf_prms[6])
            commands[i]['param']['doa']['source_pos_y_min'] = float(bf_prms[7])
            commands[i]['param']['doa']['source_pos_y_max'] = float(bf_prms[8])

        else:
            commands[i]['status']['doa']= {'peak':None,'lag':None,'source_pos_x':None,'source_pos_y':None}
            commands[i]['status']['bf']= {'focus_x':None,'focus_y':None}
    #6,7 aec設定反映用 param_set_flag は、最後に送る必要があるため、末尾に追加
    for i in range(6,8):
        commands[i]['type'] = 'aec'
        commands[i]['param'] = {'param_set_flag':None}
        if i % 2 == 0:
            commands[i]['param']['param_set_flag'] = 1 #1固定

    ### Config ファイル 読み込み (contled.txt)
    ### Mic mute ON/OFFを確認
    ### ONなら素通り。OFFならマイクミュート
    # config設定読み込み
    # 先にPresetファイルより先にConfig設定を読むと、Preset読み込み時に変数を上書きするため、ここで読み込んで書き換える。
    # Presetファイルがmic_muteパラメータを持ってしまっている。
    if Confirm_Config_Setting("MIC_MUTE") == dc.ON:
        #Mic Mute 設定 OFFの場合
        commands[0]['param']['mic_mute'] = True #mic_mute変数をTrueに


    with codecs.open(c_fname,'w', codecs_open_char, codecs_open_ignore) as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)
    
    with codecs.open(conf_data_fname,'w', codecs_open_char, codecs_open_ignore) as f:
        f.write(conf_prms)

def Make_Init_Matrix_Change(c_fname):
    ### Config ファイル 読み込み (contled.txt)
    ### Speaker Output Assign ON/OFFを確認
    ### ONなら素通り。OFFならマイクミュート

    if os.path.exists(c_fname):
        with codecs.open(c_fname,'r', codecs_open_char, codecs_open_ignore) as f:
            commands = json.load(f)

        # config設定読み込み
        if Confirm_Config_Setting("SPOUT_ASSIGN_CODEC") == dc.OFF:
            # Codec in --> MuteON --> Spaker Out
            for i in range(0,len(commands)):
                if commands[i]['param']['gain']['input_ch'] == 2 and commands[i]['param']['gain']['output_ch'] == 3:
                    if commands[i]['access'] == 'set' and commands[i]['block_no'] == BlockNo.MATRIX_1:
                        commands[i]['param']['gain']['gain'] = master_data_const.MATRIX_GAIN_MIN
                elif commands[i]['param']['gain']['input_ch'] == 2 and commands[i]['param']['gain']['output_ch'] == 4:
                    if commands[i]['access'] == 'set' and commands[i]['block_no'] == BlockNo.MATRIX_1:
                        commands[i]['param']['gain']['gain'] = master_data_const.MATRIX_GAIN_MIN
                        
        if Confirm_Config_Setting("SPOUT_ASSIGN_AUX") == dc.OFF:
            # AUX in --> MuteON --> Spaker Out
            for i in range(0,len(commands)):
                if commands[i]['param']['gain']['input_ch'] == 5 and commands[i]['param']['gain']['output_ch'] == 4:
                    if commands[i]['access'] == 'set' and commands[i]['block_no'] == BlockNo.MATRIX_1:
                        commands[i]['param']['gain']['gain'] = master_data_const.MATRIX_GAIN_MIN
                elif commands[i]['param']['gain']['input_ch'] == 6 and commands[i]['param']['gain']['output_ch'] == 3:
                    if commands[i]['access'] == 'set' and commands[i]['block_no'] == BlockNo.MATRIX_1:
                        commands[i]['param']['gain']['gain'] = master_data_const.MATRIX_GAIN_MIN

        with codecs.open(c_fname,'w', codecs_open_char, codecs_open_ignore) as f:
            # 辞書型をjsonとして出力
            json.dump(commands, f, indent=True)
    else:
        pass
        

#---------------------------------------------------------------------
def Make_FactoryPreset_Command_Json():

    # copy preset data
    shutil.copyfile('./preset/preset0_defNo.txt', './preset/preset_defNo.txt')
    shutil.copyfile('./preset/preset0_aec_nc.txt', './preset/preset1_aec_nc.txt')
    shutil.copyfile('./preset/preset0_aec_nc.txt', './preset/preset2_aec_nc.txt')
    shutil.copyfile('./preset/preset0_comp.txt', './preset/preset1_comp.txt')
    shutil.copyfile('./preset/preset0_comp.txt', './preset/preset2_comp.txt')
    shutil.copyfile('./preset/preset0_gain.txt', './preset/preset1_gain.txt')
    shutil.copyfile('./preset/preset0_gain.txt', './preset/preset2_gain.txt')
    shutil.copyfile('./preset/preset0_1_iir.txt', './preset/preset1_iir.txt')
    shutil.copyfile('./preset/preset0_2_iir.txt', './preset/preset2_iir.txt')

    with open('./preset/preset_nowloadNo.txt', 'r+' if os.path.exists('./preset/preset_nowloadNo.txt') else 'w') as f:
        # write 時は排他ロック
        fcntl.flock(f, fcntl.LOCK_EX)
        if f.mode == 'r+':
            f.truncate(0)
            f.seek(os.SEEK_SET)

        f.write('1')

    # copy config data
    shutil.copyfile('./config/config_net_def.txt', './config/config_net.txt')
    shutil.copyfile('./config/config_userpass_def.txt', './config/config_userpass.txt')
    shutil.copyfile('./config/config_contled_def.txt', './config/config_contled.txt')
    values = GetDefault_Conf_Bluetooth()
    with open(lbl.SETTING_DATA_PATH + './config/config_bt.json', 'w') as f:
        fcntl.flock(f, fcntl.LOCK_EX)
        json.dump(values, f, indent=True, sort_keys=True)

    # Re-writable
    RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)    # at first, Popen was used
    RWMOUNT.wait()

    # copy preset data from home to home_org
    shutil.copyfile('./preset/preset0_aec_nc.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_aec_nc.txt')
    shutil.copyfile('./preset/preset0_aec_nc.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_aec_nc.txt')
    shutil.copyfile('./preset/preset0_comp.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_comp.txt')
    shutil.copyfile('./preset/preset0_comp.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_comp.txt')
    shutil.copyfile('./preset/preset0_gain.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_gain.txt')
    shutil.copyfile('./preset/preset0_gain.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_gain.txt')
    shutil.copyfile('./preset/preset0_1_iir.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_iir.txt')
    shutil.copyfile('./preset/preset0_2_iir.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_iir.txt')

    # copy config data from home to home_org
    shutil.copyfile('./config/config_net_def.txt', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt')
    shutil.copyfile('./config/config_userpass_def.txt', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_userpass.txt')
    shutil.copyfile('./config/config_contled_def.txt', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_contled.txt')
    shutil.copyfile('./config/config_bt.json', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_bt.json')

    # Back to Read only
    ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)  # at first, Popen was used
    ROMOUNT.wait()

    preset_no = 0
    Make_init_gain(preset_no,'../../tmp/command_cf1_init_gain.json')
    Make_init_comp(preset_no,'../../tmp/command_cf1_init_comp.json')
    Make_init_iir(preset_no,'../../tmp/command_cf1_init_iir.json')
    Make_init_aec_nc(preset_no,'../../tmp/command_cf1_init_aec_nc.json')
    shutil.copyfile('./init_json/command_cf1_init_matrix.json', '../../tmp/command_cf1_init_matrix.json')
    Make_Init_Matrix_Change('../../tmp/command_cf1_init_matrix.json')

#---------------------------------------------------------------------
def Make_Init_Command_json():
    shutil.copyfile('./init_json/block_cf1_init.json', '../../tmp/block_cf1_init.json') #<- tab
    shutil.copyfile('./init_json/command_cf1_init_matrix.json', '../../tmp/command_cf1_init_matrix.json')
    try:
        with codecs.open('./preset/preset_defNo.txt','r', codecs_open_char, codecs_open_ignore) as f:
            preset_no = f.read()
            preset_no = int(preset_no.strip())
        
        with codecs.open('./preset/preset_nowloadNo.txt','r+' if os.path.exists('./preset/preset_nowloadNo.txt') else 'w', codecs_open_char, codecs_open_ignore) as f:
            # write 時は排他ロック
            fcntl.flock(f, fcntl.LOCK_EX)
            if f.mode == 'r+':
                f.truncate(0)
                f.seek(os.SEEK_SET)

            f.write(str(preset_no))
        
        if Check_Config_Data('/home/toa/TOA_AM-CF1/Application/data/config/') == -1:
            Make_FactoryPreset_Command_Json()

        if Check_Preset_Data(preset_no,'/home/toa/TOA_AM-CF1/Application/data/preset/') == -1:
            Make_FactoryPreset_Command_Json()
        else:
            Make_init_gain(preset_no,'../../tmp/command_cf1_init_gain.json')
            Make_init_comp(preset_no,'../../tmp/command_cf1_init_comp.json')
            Make_init_iir(preset_no,'../../tmp/command_cf1_init_iir.json')
            Make_init_aec_nc(preset_no,'../../tmp/command_cf1_init_aec_nc.json')
            Make_Init_Matrix_Change('../../tmp/command_cf1_init_matrix.json')

    except:
        Make_FactoryPreset_Command_Json()

#----------------------------------------------------------------------------------------
def Load_PresetData(i_num):
    if i_num < 3:
        main_SPgain_sts_fname = "/home/toa/TOA_AM-CF1/tmp/volume/main_SPgain_sts.txt"
        preset_nowloadNo_fname = "/home/toa/TOA_AM-CF1/Application/data/preset/preset_nowloadNo.txt"
        PRESET_LOAD_FLAG = "/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG"
        web_stop_flag = '/home/toa/TOA_AM-CF1/tmp/WEB_STOP_flag'  # if file exists then WEB_STOP

        if not os.path.exists(web_stop_flag):
            with codecs.open(web_stop_flag,'w', codecs_open_char, codecs_open_ignore) as wsf:
                fcntl.flock(wsf, fcntl.LOCK_EX)
                wsf.write(" ")
        
        with codecs.open(main_SPgain_sts_fname,'w', codecs_open_char, codecs_open_ignore) as f:
            f.write(str(0))

        Make_init_gain(i_num, PATH + '../../tmp/m_load_command_cf1_init_gain.json')
        Make_init_iir(i_num, PATH + '../../tmp/m_load_command_cf1_init_iir.json')
        Make_init_aec_nc(i_num, PATH + '../../tmp/m_load_command_cf1_init_aec_nc.json')
        send_command(PATH + '../../tmp/m_load_command_cf1_init_iir.json', PATH + '../../tmp/m_load_result_init_iir.json')
        Wait_Param_Set_Flag()
        send_command(PATH + '../../tmp/m_load_command_cf1_init_aec_nc.json', PATH + '../../tmp/m_load_result_init_aec_nc.json')
        send_command(PATH + '../../tmp/m_load_command_cf1_init_gain.json',PATH + '../../tmp/m_load_result_init_gain.json')
        with codecs.open(PRESET_LOAD_FLAG,'w', codecs_open_char, codecs_open_ignore) as f:
            f.write('')

        with codecs.open(preset_nowloadNo_fname,'r+' if os.path.exists(preset_nowloadNo_fname) else 'w', codecs_open_char, codecs_open_ignore) as f:
            # write 時は排他ロック
            fcntl.flock(f, fcntl.LOCK_EX)
            if f.mode == 'r+':
                f.truncate(0)
                f.seek(os.SEEK_SET)

            f.write(str(i_num))
