# -*- coding:utf-8 -*-
import os
import json

develop_conf_path = "/home/toa/"
develop_conf_file_name = "config_develop.json"
develop_conf_file = os.path.join(develop_conf_path, develop_conf_file_name)

# ---------------------------------------------------------
def Get_develop_config():

    result = {}
    if os.path.exists(develop_conf_file):
        with open(develop_conf_file, 'r') as f:
            temp = json.load(f)
            if isinstance(temp, list) is True:
                # jsonファイルを配列の0番目に入っているため、辞書型のみにする
                result = temp[0]
            else:
                print(temp + 'is not list')


    if isinstance(result, dict) is False:
        print(develop_conf_file_name + 'is not dict')
        result = {}

    return result

# ---------------------------------------------------------
def Get_skip_login_from_json_data(json_dict):

    if isinstance(json_dict, dict) is False:
        print(json_dict + 'is not dict')
        return False

    DEVELOP_CONFIG_REMOTE = 'remote'
    DEVELOP_CONFIG_SKIP_LOGIN = 'remote_skiplogin'

    # パスワード認証のスキップ機能の設定が未定義であれば、常に無効とする
    result = False
    if DEVELOP_CONFIG_REMOTE in json_dict:
        if DEVELOP_CONFIG_SKIP_LOGIN in json_dict[DEVELOP_CONFIG_REMOTE]:
            if json_dict[DEVELOP_CONFIG_REMOTE][DEVELOP_CONFIG_SKIP_LOGIN] == 'on':
                result = True
            else:
                result = False

    return result
