# -*- coding:utf-8 -*-
import json
import subprocess as sp

# モジュールをインポートする
import RPi.GPIO as GPIO
import time


#    pythonスクリプトの中で、pythonを実行
#    # Python実行
#    subprocess.call('python ../script/test.py')

# GPIO指定をGPIO番号で行う
GPIO.setmode(GPIO.BCM)
GPIO.setup(7, GPIO.OUT)
GPIO.output(7, 0)
time.sleep(1)
GPIO.output(7, 1)
GPIO.cleanup()
time.sleep(3)

sp.run(['./startup.out','block_cf1_hardtest.json','netlist.bin'])

sp.run(['./control.out','command_cf1_hardtest_input_gain.json'  ,'netlist.bin', 'result_hardtest_intput_gain.json'   ])
#sp.run(['./control.out','command_cf1_init_comp.json'        ,'netlist.bin', 'result_init_comp.json'          ])
#sp.run(['./control.out','command_cf1_init_iir.json'         ,'netlist.bin', 'result_init_iir.json'           ])
#sp.run(['./control.out','command_cf1_init_aec_nc.json'      ,'netlist.bin', 'result_init_aec_nc.json'        ])
sp.run(['./control.out','command_cf1_hardtest_matrix.json'      ,'netlist.bin', 'result_hardtest_matrix.json'        ])
sp.run(['./control.out','command_cf1_hardtest_output_gain.json' ,'netlist.bin', 'result_hardtest_output_gain.json'   ])
