/************************************************************************
 *
 *	coeff_gain.c
 *
 *	20020906	Tsuyoshi Ogawa
 *
 ************************************************************************/
#include "fdesign_prototypes.h"

namespace dsp_lib {

/*============================================================*/
void
Fdesign_Gain(
	float	gain_,
	float	*coeff_
)
{
	if (coeff_) {
		coeff_[0] *= gain_;	/* b0 */
		coeff_[1] *= gain_;	/* b1 */
		coeff_[2] *= gain_;	/* b2 */
	}
}

/*============================================================*/
} // namespace dsp_lib
