/************************************************************************
 *
 *	coeff_lpf24.c
 *
 *	20020925	Tsuyoshi Ogawa
 *
 ************************************************************************/

#include "fdesign_prototypes.h"

#ifndef	NULL
#include <stdio.h>
#endif

namespace dsp_lib {

/*============================================================*/
void
Fdesign_LPF24_CheckParameter(
	float*	f_,
	float*	q1_,
	float*	q2_
)
{
	Fdesign_LPF12_CheckParameter(f_, q1_);
	Fdesign_LPF12_CheckParameter(NULL, q2_);
}

/*============================================================*/
void
Fdesign_LPF24(
	float	f_,
	float	q1_,
	float	q2_,
	int		bypass_,
	float	*coeff1_,
	float	*coeff2_
)
{
	Fdesign_LPF12(f_, q1_, bypass_, coeff1_);
	Fdesign_LPF12(f_, q2_, bypass_, coeff2_);
}

/*============================================================*/
} // namespace dsp_lib
