/*
 * simulated_malloc.h
 *
 *  Created on: 2017/03/15
 *      Author: toa29548
 */

#pragma once

#include <stdint.h>
#include <stddef.h>

namespace dsp_ctrl {

extern const uint32_t LOCALRAM_ADDRESS_UNIT_BYTE;
extern const uint32_t ADDRESS_UNIT_RATIO;
//extern const uint32_t DSP_DM_WORD_ALIGN = 8;
//extern const uint32_t DSP_PM_WORD_ALIGN = 8;

extern uint32_t	g_local_heap_address_base;
extern uint32_t	g_local_heap_address_boot_info;
extern uint32_t g_local_heap_address_map;
extern uint32_t g_local_heap_address_dm;
extern uint32_t g_local_heap_address_pm;

bool
InitializeLocalHeap(void);
void*
simulated_malloc_dm(uint32_t size_);
void*
simulated_malloc_pm(uint32_t size_);
void
PrintHeapInfo(void);
bool
SaveHeapInfo(void);

} // namespace dsp_ctrl
