/*
 * null_check.h
 *
 *  Created on: 2016/09/27
 *      Author: toa29548
 */

#pragma once
#include <stddef.h>

namespace dsp_lib {

//---------------------------------------------------
#if 0
// TODO: ADIのみで動作すめETIでC++11に対応したら置き換える

inline
bool
NullCheck()
{
  return true;
}

template<typename First, typename... Rest>
inline
bool
NullCheck(
	const First& first,
	const Rest&... rest
)
{
	if (first==NULL) {
		return false;
	} else {
		return NullCheck(rest...);
}
}
#endif

//---------------------------------------------------
inline bool
NullCheck(
	const void*	var0_
)
{
	return (var0_ != NULL);
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_,
	const void*	var3_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL)&&(var3_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_,
	const void*	var3_,
	const void*	var4_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL)&&(var3_ != NULL)&&(var4_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_,
	const void*	var3_,
	const void*	var4_,
	const void*	var5_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL)&&(var3_ != NULL)&&(var4_ != NULL)&&(var5_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_,
	const void*	var3_,
	const void*	var4_,
	const void*	var5_,
	const void*	var6_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL)&&(var3_ != NULL)&&(var4_ != NULL)&&(var5_ != NULL)&&(var6_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_,
	const void*	var3_,
	const void*	var4_,
	const void*	var5_,
	const void*	var6_,
	const void*	var7_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL)&&(var3_ != NULL)&&(var4_ != NULL)&&(var5_ != NULL)&&(var6_ != NULL)&&(var7_ != NULL));
}

inline bool
NullCheck(
	const void*	var0_,
	const void*	var1_,
	const void*	var2_,
	const void*	var3_,
	const void*	var4_,
	const void*	var5_,
	const void*	var6_,
	const void*	var7_,
	const void*	var8_,
	const void*	var9_
)
{
	return ((var0_ != NULL)&&(var1_ != NULL)&&(var2_ != NULL)&&(var3_ != NULL)&&(var4_ != NULL)&&(var5_ != NULL)&&(var6_ != NULL)&&(var7_ != NULL)&&(var8_ != NULL)&&(var9_ != NULL));
}

} //namespace dsp_lib
