#!/bin/sh

### This script returns :
###   0: On success.
###   1: Error has been occured.

MYSELF_DIR=$(dirname "${0}")
ENVIRONMENT_FILE="${MYSELF_DIR}"

LBL_VERSION="version_for_developer"
NOW_CPU_FW_VERSION="/home/root/TOA_AM-CF1/Application/data/config/amcf1_massp_version.json"
_new_version=$(cat ${NOW_CPU_FW_VERSION} | sed 's/^\[{\(.*\)}]$/\1/' | grep ${LBL_VERSION} | cut -d ':' -f 2- | tr -d '}' | tr -d ' "' | tr -d '\n' )

org_DELETE_PHP="/var/www/html/delete.php"
new_DELETE_PHP="${ENVIRONMENT_FILE}/delete.php"

if [ ! -f ${new_DETELE_PHP} ]; then exit 1; fi

if [ ${_new_version} = '1.1.1.0.0' ]; then
  echo "modify delete.php"
  cp -rf ${new_DELETE_PHP} ${org_DELETE_PHP}
  if [ ${?} -ne 0 ]; then
  exit 1
  fi
fi

exit 0