/*--------------------------------------------------------------------------*/
/*																			*/
/*	BTModuleLib.h (Rev 1.00)												*/
/*																			*/
/*	1.概要																	*/
/*		BM64制御処理														*/
/*																			*/
/*	2.改版履歴																*/
/*																			*/
/*																			*/
/*--------------------------------------------------------------------------*/


/* status  */
#define BT_STATUS_SUCCESS             (0)
#define BT_STATUS_FALSE               (1)

/* APIs */
extern int32_t LibBT_Init(uint8_t* deviceNamePath, uint32_t pathSize);
extern uint32_t LibBT_Control( uint32_t i_state, uint32_t setControl, uint32_t keyLockState, uint32_t *bt_remote_processed_flag );
extern int32_t LibBT_getMuteEvent(void);

extern uint32_t LibBT_DefKeyLock(void);
extern uint32_t LibBT_DefKeyUnLock(void);
extern uint32_t LibBT_DefControlInvalid(void);
extern uint32_t LibBT_DefControlOn(void);
extern uint32_t LibBT_DefControlOff(void);
extern uint32_t LibBT_DefModeStatusNone(void);
extern uint32_t LibBT_DefModeStatusIdle(void);
extern uint32_t LibBT_DefModeStatusPairing(void);
extern uint32_t LibBT_DefModeStatusConnected(void);
extern uint32_t LibBT_DefModeStatusReconnect(void);

