# -*- coding:utf-8 -*-
import json
import subprocess as sp
import copy,os, sys, time

from hello.send_command import send_command
import fcntl    # for ファイル排他
import hello.def_block_no as BlockNo
from hello.param_set_get_flag import Wait_Param_Set_Flag
from eq_setting_param import Write_eq_param
#    pythonスクリプトの中で、pythonを実行
#    # Python実行
#    subprocess.call('python ../script/test.py')
import codecs

import define_const as dc
from data_converter import Convert_nlp_ratio_1

sys.path.append('/home/toa/TOA_AM-CF1/Application/data/')
from cf1_init_func import Confirm_Config_Setting

codecs_open_char = 'utf-8' #ファイルオープン時文字コード定義(www-dataがアクセスする対象ファイルは、fopen時に文字コード定義が必要)
codecs_open_ignore = 'ignore' #読み込むときに定義 utf-8以外の行を無視する

PATH = '/home/toa/TOA_AM-CF1/tmp/'

def Make_init_gain(preset_no,c_fname):
    preset_fname = PATH + '../Application/data/preset/preset' + str(preset_no) + '_gain.txt'
    mute_sts_fname = PATH + 'volume/' + 'mute_sts.txt' #Change!!
    WEB_SP_gain_fname = PATH + 'volume/' + 'web_SPgain_sts.txt' #Change!!
    main_SPgain_sts_fname = PATH + 'volume/' + 'main_SPgain_sts.txt'
    SPout_block_no = BlockNo.GAIN_SPoutL #SP OUT L
    mute_or_unmute_blockno = [
        BlockNo.GAIN_USBinL,BlockNo.GAIN_USBinR,BlockNo.GAIN_BTinL,BlockNo.GAIN_BTinR,BlockNo.GAIN_CODECin,BlockNo.GAIN_AUXinL,BlockNo.GAIN_AUXinR,
        BlockNo.GAIN_SPoutL,BlockNo.GAIN_SPoutR,BlockNo.GAIN_USBoutL,BlockNo.GAIN_USBoutR,BlockNo.GAIN_BToutL,BlockNo.GAIN_CODECout,BlockNo.GAIN_AUXoutL,BlockNo.GAIN_AUXoutR] # (Ref.) WEB Mixer Left to Right 


    # BlockNo.47 is Mic gain.
    #プリセットロード直前にマイクミュートであっても解除します

    ##################### Dynamic Change #####################
    blocknums = []
    gain_vals = []
    mute_sts = []
    mute_web_gain_sts =[]
    mute_blockno = []

    MUTE_GAIN = -150

    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            gain_vals.append(vals[1])
            if len(vals) >= 3:
                mute_blockno.append(vals[0])
                mute_sts.append(vals[2])
                mute_web_gain_sts.append(vals[1])

    if mute_sts[0] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[0])] = MUTE_GAIN       #USB L 26
        gain_vals[blocknums.index(mute_or_unmute_blockno[1])] = MUTE_GAIN       #USB R 33
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[0])] = gain_vals[blocknums.index(mute_or_unmute_blockno[0])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[1])] = gain_vals[blocknums.index(mute_or_unmute_blockno[0])]

    if mute_sts[1] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[2])] = MUTE_GAIN       #Bluetooth L 47
        gain_vals[blocknums.index(mute_or_unmute_blockno[3])] = MUTE_GAIN       #Bluetooth R 54
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[2])] = gain_vals[blocknums.index(mute_or_unmute_blockno[2])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[3])] = gain_vals[blocknums.index(mute_or_unmute_blockno[2])]

    if mute_sts[2] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[4])] = MUTE_GAIN       #CODEC 40
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[4])] = gain_vals[blocknums.index(mute_or_unmute_blockno[4])]

    if mute_sts[3] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[5])] = MUTE_GAIN       #AUX L 61
        gain_vals[blocknums.index(mute_or_unmute_blockno[6])] = MUTE_GAIN       #AUX R 68
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[5])] = gain_vals[blocknums.index(mute_or_unmute_blockno[5])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[6])] = gain_vals[blocknums.index(mute_or_unmute_blockno[5])]

    if mute_sts[4] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[7])] = MUTE_GAIN       #SP OUT L 82
        gain_vals[blocknums.index(mute_or_unmute_blockno[8])] = MUTE_GAIN       #SP OUT R 79
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[7])] = gain_vals[blocknums.index(mute_or_unmute_blockno[7])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[8])] = gain_vals[blocknums.index(mute_or_unmute_blockno[7])]

    if mute_sts[5] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[9])] = MUTE_GAIN       #USB L   89
        gain_vals[blocknums.index(mute_or_unmute_blockno[10])] = MUTE_GAIN      #USB R   75
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[9])] = gain_vals[blocknums.index(mute_or_unmute_blockno[9])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[10])] = gain_vals[blocknums.index(mute_or_unmute_blockno[9])]

    if mute_sts[6] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[11])] = MUTE_GAIN      #Bluetooth 91
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[11])] = gain_vals[blocknums.index(mute_or_unmute_blockno[11])]

    if mute_sts[7] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[12])] = MUTE_GAIN      #CODEC 73
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[12])] = gain_vals[blocknums.index(mute_or_unmute_blockno[12])]

    if mute_sts[8] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[13])] = MUTE_GAIN      #AUX L 89
        gain_vals[blocknums.index(mute_or_unmute_blockno[14])] = MUTE_GAIN      #AUX R 77
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[13])] = gain_vals[blocknums.index(mute_or_unmute_blockno[13])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[14])] = gain_vals[blocknums.index(mute_or_unmute_blockno[13])]

    blocknums.extend(blocknums)
    blk_ln = len(gain_vals)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = int(blocknums[i])
        commands[i]['type'] = 'gain'
        commands[i]['param'] = {'gain':None}

    for i in range(0,blk_ln):
        commands[i]['access'] = 'set'
        if commands[i]['block_no'] == BlockNo.GAIN_SPoutL or commands[i]['block_no'] == BlockNo.GAIN_SPoutR:
            commands[i]['param']['gain'] = int(gain_vals[i]) #Sum SP out
        else:
            commands[i]['param']['gain'] = int(gain_vals[i])

    ### Config ファイル 読み込み (contled.txt)
    ### Mic mute ON/OFFを確認
    ### ONなら素通り。OFFならマイクミュート
    # config設定読み込み
    # 先にPresetファイルより先にConfig設定を読むと、Preset読み込み時に変数を上書きするため、ここで読み込んで書き換える。
    # Presetファイルがマイクゲインを持ってしまっている。
    MUTE_ON_GAIN = -100
    if Confirm_Config_Setting("MIC_MUTE") == dc.ON:
        # マイク機能OFF
        for i in range(0,blk_ln):
            if commands[i]['block_no'] == BlockNo.GAIN_MIC:
                commands[i]['param']['gain'] = MUTE_ON_GAIN

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    with open(mute_sts_fname, 'r+' if os.path.exists(mute_sts_fname) else 'w') as f:
        try:
            # write 時は'r+'で open して排他ロック
            fcntl.flock(f, fcntl.LOCK_EX)
            if f.mode == 'r+':
                f.truncate(0)
                f.seek(os.SEEK_SET)

            f.write(",".join(mute_sts))
            f.write('\n')
            f.write(",".join(mute_web_gain_sts))
        except IOError as io_ex:
            print('[{0}] exception : {1}'.format(
                inspect.currentframe().f_code.co_name, io_ex))

    sp_index = mute_blockno.index(str(SPout_block_no))

    with open(WEB_SP_gain_fname, 'r+' if os.path.exists(WEB_SP_gain_fname) else 'w') as f:
        try:
            # write 時は'r+'で open して排他ロック
            fcntl.flock(f, fcntl.LOCK_EX)
            if f.mode == 'r+':
                f.truncate(0)
                f.seek(os.SEEK_SET)

            f.write(mute_web_gain_sts[sp_index])
            f.write('\n')
            f.write(mute_sts[sp_index])
        except IOError as io_ex:
            print('[{0}] exception : {1}'.format(
                inspect.currentframe().f_code.co_name, io_ex))

    with open(main_SPgain_sts_fname,'w') as f:
        f.write(str(0))

def Make_init_iir(preset_no,c_fname):
    # 工場出荷設定時のみ preset_no = 0 が入るため、必ず preset0_1_iir.txtを読み込む。
    if preset_no == 0:
        preset_fname = PATH + '../Application/data/preset/preset0_1_iir.txt'
    else:
        preset_fname = PATH + '../Application/data/preset/preset' + str(preset_no) + '_iir.txt'
    EQSP_param_fname = PATH + 'EQ/EQSP_set_param.txt'
    EQAUX_param_fname = PATH + 'EQ/EQAUX_set_param.txt'
    ##################### Dynamic Change #####################
    blocknums = []
    stagenums = []

    typs = []
    freq = []
    gain = []
    q = []

    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            stagenums.append(int(vals[1]))
            typs.append(vals[2])
            freq.append(float(vals[3]))
            q.append(float(vals[4]))
            gain.append(float(vals[5]))

    SP_types = []
    SP_freqs = []
    SP_gains = []
    SP_qs = []
    AUX_types = []
    AUX_freqs = []
    AUX_gains = []
    AUX_qs = []

    for i in range(len(blocknums)):
        if blocknums[i] == BlockNo.EQ_SPoutL:
            SP_types.append(typs[i])
            SP_freqs.append(str(freq[i]))
            SP_gains.append(str(gain[i]))
            SP_qs.append(str(q[i]))
        elif blocknums[i] == BlockNo.EQ_AUXoutL:
            AUX_types.append(typs[i])
            AUX_freqs.append(str(freq[i]))
            AUX_gains.append(str(gain[i]))
            AUX_qs.append(str(q[i]))

    Write_eq_param(EQSP_param_fname, SP_types, SP_freqs, SP_qs, SP_gains)
    Write_eq_param(EQAUX_param_fname, AUX_types, AUX_freqs, AUX_qs, AUX_gains)

    blk_ln = len(blocknums)

    blocknums.extend(blocknums)
    stagenums.extend(stagenums)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {},
        'config': {},
        'status': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = blocknums[i]
        commands[i]['type'] = 'iir'
        commands[i]['param'] = {'stage':None, 'type':None, 'frequency':None, 'q':None, 'gain':None}
        commands[i]['param']['stage'] = stagenums[i]

    for i in range(0,blk_ln):
        commands[i]['access'] = 'set'
        commands[i]['param']['type'] = typs[i]
        commands[i]['param']['frequency'] = freq[i]
        commands[i]['param']['q'] = q[i]
        commands[i]['param']['gain'] = gain[i]

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)


def Make_init_aec_nc(preset_no,c_fname):
    preset_fname = PATH + '../Application/data/preset/preset' + str(preset_no) + '_aec_nc.txt'
    conf_data_fname = PATH + 'audio/' + 'audio_set_conf.txt' #change!!
    ##################### Dynamic Change #####################
    blocknums = []
    
    with codecs.open(preset_fname,'r', codecs_open_char, codecs_open_ignore) as f:
        vals = f.readlines()
        aec_prms = vals[1].strip().split(',') ## Qモデルでは、"mu_"パラメータを'/'区切りにしてください。
        nc_prms = vals[3].strip().split(',')
        bf_prms = vals[5].strip().split(',')
        conf_prms = vals[7].strip()

        del aec_prms[0] #0番目のblock番号要素を削除
        del nc_prms[0] #0番目のblock番号要素を削除
        del bf_prms[0] #0番目のblock番号要素を削除

        ## mu_パラメータを抽出し、'[]'削除し、/'で区切り、floatに変換
        _mu_prms = aec_prms[1].lstrip('[').rstrip(']').split('/')
        mu_prms = [float(i) for i in _mu_prms]

    # WEB設定を変数に格納(nlp_ratio1パラメータ決定用)
    split_conf_prms = conf_prms.split(',')
    nlplevel = split_conf_prms[2] #NLP Level high/mid/low
    aeconoff = split_conf_prms[3] #AEC on/off
    
    command = {
        'access': 'get',
        'block_no': None,
        'type': None,
        'param': {},
        'config': {},
        'status': {}
    }

    commands = []

    ## blocknumsでは、param_set_flagを確実に最後に設定するため、BlockNo.AECを末尾にも定義している
    blocknums=[BlockNo.AEC,BlockNo.NC,BlockNo.BF,BlockNo.AEC]
    blk_ln = len(blocknums)

    cnt = 0
    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        if i % 2 == 0:
            commands[i]['access'] = 'set'
            commands[i]['block_no'] = int(blocknums[cnt])
        else:
            commands[i]['block_no'] = int(blocknums[cnt])
            cnt = cnt + 1
    #0,1
    for i in range(0,2):
        commands[i]['type'] = 'aec'
        commands[i]['param'] = {'on':None,'mu_':None,'errmu_limit':None,'rcv_dly_':None,'nlp_ratio0':None,'nlp_ratio1':None,
                                'nlp_enhance0':None,'nlp_enhance1':None,'nlp_alpha0':None,'nlp_alpha1':None,'nlp_alpha2':None,'nlp_step':None,
                                'drc_compTh':None,'drc_compRatio':None,'drc_compGain':None,'drc_boostTh':None,'drc_boostRatio':None,'drc_boostGain':None,
                                'drc_AT':None,'drc_RT':None,'mic_mute':None,'cng_noise':None,'bmInput_fixedGain':None,'nlp_fixedGain':None,'drc_fixedGain':None
                                }
        if i % 2 == 0:
            if aec_prms[0] == 'true':
                commands[i]['param']['on'] = True
            else:
                commands[i]['param']['on'] = False
            commands[i]['param']['mu_'] = mu_prms
            commands[i]['param']['errmu_limit'] = float(aec_prms[2])
            commands[i]['param']['rcv_dly_'] = int(aec_prms[3])
            commands[i]['param']['nlp_ratio0'] = float(aec_prms[4])

            commands[i]['param']['nlp_ratio1'] = float(aec_prms[5])
            # 以下、nlp_ratio1をAEC_ONOFF、NLP Levelより判断する処理
            ## DSPパラメータ調整時、presetファイルのnlp_ratio1の値をそのまま反映させたい場合は、ここから下をコメントアウトしてください。(use preset nlp_ratio1)
            if aeconoff == "ON":
                commands[i]['param']['nlp_ratio1'] = Convert_nlp_ratio_1(nlplevel)
            else:
                commands[i]['param']['nlp_ratio1'] = dc.NLP_LEVEL_AECOFF
            ## ここまでコメントアウト(use preset nlp_ratio1)
            
            commands[i]['param']['nlp_enhance0'] = float(aec_prms[6])
            commands[i]['param']['nlp_enhance1'] = float(aec_prms[7])
            commands[i]['param']['nlp_alpha0'] = float(aec_prms[8])
            commands[i]['param']['nlp_alpha1'] = float(aec_prms[9])
            commands[i]['param']['nlp_alpha2'] = float(aec_prms[10])
            commands[i]['param']['nlp_step'] = int(aec_prms[11])
            commands[i]['param']['drc_compTh'] = int(aec_prms[12])
            commands[i]['param']['drc_compRatio'] = int(aec_prms[13])
            commands[i]['param']['drc_compGain'] = int(aec_prms[14])
            commands[i]['param']['drc_boostTh'] = int(aec_prms[15])
            commands[i]['param']['drc_boostRatio'] = int(aec_prms[16])
            commands[i]['param']['drc_boostGain'] = int(aec_prms[17])
            commands[i]['param']['drc_AT'] = int(aec_prms[18])
            commands[i]['param']['drc_RT'] = int(aec_prms[19])
            commands[i]['param']['mic_mute'] = False #false固定 v1.4.0でMicMuteON状態でPresetStore&DLされた場合のLoad時不具合対策
            commands[i]['param']['cng_noise'] = float(aec_prms[21])
            commands[i]['param']['bmInput_fixedGain'] = float(aec_prms[22])
            commands[i]['param']['nlp_fixedGain'] = float(aec_prms[23])
            commands[i]['param']['drc_fixedGain'] = float(aec_prms[24])

    #2,3
    for i in range(2,4):
        commands[i]['type'] = 'nc'
        commands[i]['param'] = {'bypass':None,'reduction_level':None}
        if i % 2 == 0:
            if nc_prms[0] == 'true':
                commands[i]['param']['bypass'] = True
            else:
                commands[i]['param']['bypass'] = False
            commands[i]['param']['reduction_level'] = int(nc_prms[1])

    #4,5
    for i in range(4,6):
        commands[i]['type'] = 'microphonearray'
        commands[i]['param'] = {'dir':None,'dis':None,'update_mode':None}
        commands[i]['param']['doa']= {'peak_threshold':None,'smooth_tc':None,'source_pos_x_max':None,'source_pos_y_max':None,'source_pos_x_min':None,'source_pos_y_min':None}
        if i % 2 == 0:
            commands[i]['param']['dir'] = int(bf_prms[0])
            commands[i]['param']['dis'] = float(bf_prms[1]) #[m]
            commands[i]['param']['update_mode'] = bf_prms[2]
            commands[i]['param']['doa']['peak_threshold'] = int(bf_prms[3])
            commands[i]['param']['doa']['smooth_tc'] = float(bf_prms[4])
            commands[i]['param']['doa']['source_pos_x_min'] = float(bf_prms[5])
            commands[i]['param']['doa']['source_pos_x_max'] = float(bf_prms[6])
            commands[i]['param']['doa']['source_pos_y_min'] = float(bf_prms[7])
            commands[i]['param']['doa']['source_pos_y_max'] = float(bf_prms[8])

        else:
            commands[i]['status']['doa']= {'peak':None,'lag':None,'source_pos_x':None,'source_pos_y':None}
            commands[i]['status']['bf']= {'focus_x':None,'focus_y':None}
    
    #6,7 aec設定反映用 param_set_flag は、最後に送る必要があるため、末尾に追加
    for i in range(6,8):
        commands[i]['type'] = 'aec'
        commands[i]['param'] = {'param_set_flag':None}
        if i % 2 == 0:
            commands[i]['param']['param_set_flag'] = 1 #1固定(1でないとAEC設定を反映しない)

    ### Config ファイル 読み込み (contled.txt)
    ### Mic mute ON/OFFを確認
    ### ONなら素通り。OFFならマイクミュート
    # config設定読み込み
    # 先にPresetファイルより先にConfig設定を読むと、Preset読み込み時に変数を上書きするため、ここで読み込んで書き換える。
    # Presetファイルがmic_muteパラメータを持ってしまっている。
    if Confirm_Config_Setting("MIC_MUTE") == dc.ON:
        #Mic Mute 設定 OFFの場合
        commands[0]['param']['mic_mute'] = True #mic_mute変数をTrueに

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    with open(conf_data_fname ,"w") as f:
        f.write(conf_prms)

def Make_Json_For_Load(p_num):
    PRESET_LOAD_FLAG = "/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG"

    Make_init_gain(p_num, PATH + 'w_load_command_cf1_init_gain.json')
    Make_init_iir(p_num, PATH + 'w_load_command_cf1_init_iir.json')
    Make_init_aec_nc(p_num, PATH + 'w_load_command_cf1_init_aec_nc.json')
    send_command(PATH + 'w_load_command_cf1_init_iir.json', PATH + 'w_load_result_init_iir.json')
    Wait_Param_Set_Flag() #param_set_flagが0になるまでまつ
    send_command(PATH + 'w_load_command_cf1_init_aec_nc.json', PATH + 'w_load_result_init_aec_nc.json')
    send_command(PATH + 'w_load_command_cf1_init_gain.json', PATH + 'w_load_result_init_gain.json')
    with open(PRESET_LOAD_FLAG,'w') as f:
        f.write('')
