# -*- coding:utf-8 -*-
import sys
import uuid
import lbl_const as lbl
import define_const as dc
sys.path.append('/home/toa/TOA_AM-CF1/Application/data/')
import dev_config


##ここにNLP_LEVELテーブル追加？横展開

# MEMO : 量産モデルのmaster_data_const.pyから流用
# 概要   ："config_bt.json"のデフォルト値を返す
# 戻り値 ：デフォルト値情報
def GetDefault_Conf_Bluetooth():
    try:
        # MACアドレスをベースにデフォルト値を作成
        DEF_NAME = 'AM-CF1_{:04X}'.format(uuid.getnode() & 0xffff)
    except:
        if dev_config.debug_trace:
            print("GetDefault_Conf_Bluetooth error.")
        DEF_NAME = 'AM-CF1'
    defs = [{
        lbl.LBL_BT :{
          lbl.LBL_BT_NAME :DEF_NAME,
        }}]
    return defs

MATRIX_GAIN_MAX = 0
MATRIX_GAIN_MIN = -200

# 概要  ：Speaker Output Assign (AUX Input) Matrix設定の取得
# 戻り値 ：Matrixのjsonを応答
def Get_Speaker_Output_Assign_Gain(state):
    if state == dc.ON:
        matrix_gain = MATRIX_GAIN_MAX
    else:
        matrix_gain = MATRIX_GAIN_MIN
    
    return matrix_gain
    