//*voli_rdsd.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

ws.onerror = function () {
    alert('Failure to connect')
};

ws.onopen = function () {
    ws.send(
        'ud_state'
    );
    ws.send(
        ' read ' + ' config '
    );
    ws.send(
        ' read ' + ' EQ ' + ' AUX '
    );
    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:usbin_gain, 2:BTin_gain,
        //3:Codecin_gain, 4:AUXin_gain,
        //5:SPout_gain, 6:USBout_gain,
        //7:BT_gain, 8:Codecout_gain,
        //9:AUX_gain, 10～18:mute_sts*9 (0:ON 1:OFF)
        var arrayString = e.data.split(",");
        if (arrayString[0] == 'dialog') {
            alert(arrayString[1])

        } else if (arrayString[0] == 'config'){
            ip = arrayString[1]
            sm = arrayString[2]
            dg = arrayString[3]
            usn = arrayString[4]
            psw = arrayString[5]
            btn_tmp = arrayString[6]
            cin1 = arrayString[7]
            cin2 = arrayString[8]
            cou1 = arrayString[9]
            cou2 = arrayString[10]
            trk = arrayString[11]
            lev = arrayString[12]
            mute = arrayString[13]
            cver = arrayString[14]
            times = arrayString[15].split("/") //AM-CF1 Current Time
            keylock_sideswall = arrayString[16]
            mic_mute_func = arrayString[17]
            spout_assign_codec = arrayString[18]
            spout_assign_aux = arrayString[19]

            //bluetooth nameは"&nbsp;"をスペースに変換必要
            btn = btn_tmp.replace(/&nbsp;/g, ' ');

            controls.config.NETWORK.ipfields[0].ip.updateValue(ip)
            controls.config.NETWORK.ipfields[1].ip.updateValue(sm)
            controls.config.NETWORK.ipfields[2].ip.updateValue(dg)
            controls.config.USER.username.text.updateValue(usn)
            controls.config.USER.password.text.updateValue(psw)
            controls.config.BLUETOOTH.devname.text.updateValue(btn)

            if (cin1 == 'Volume_Up') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Up")
            } else if (cin1 == 'Volume_Down') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[0].input.updateValue(cin1)
            }
            if (cin2 == 'Volume_Up') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Up")
            } else if (cin2 == 'Volume_Down') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[1].input.updateValue(cin2)
            }

            if (cou1 == 'Mute_Status') {
                controls.config.CONTACT.outputs[0].output.updateValue("Mute Status")
            } else if (cou1 == 'Synch_Input1') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input1")
            } else if (cou1 == 'Synch_Input2') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[0].output.updateValue(cou1)
            }

            if (cou2 == 'Mute_Status') {
                controls.config.CONTACT.outputs[1].output.updateValue("Mute Status")
            } else if (cou2 == 'Synch_Input1') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input1")
            } else if (cou2 == 'Synch_Input2') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[1].output.updateValue(cou2)
            }

            controls.config.INDICATE.toggles[0].onoff.updateValue(trk)
            controls.config.INDICATE.toggles[1].onoff.updateValue(lev)
            if (mute == 'Only_Center') {
                controls.config.INDICATE.mute.mute.updateValue("Only Center")
            } else if (mute == 'ALL_LED') {
                controls.config.INDICATE.mute.mute.updateValue("ALL LED")
            }
            // Add CPU Version and DSP Version data
            document.getElementById("firm_version").textContent = cver;
            if (times.length == 6){
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    times[0] + "/" + times[1] + "/" +
                    times[2] + " " + times[3] + ":" +
                    times[4];
            }else{
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    "Failed to load.";
            }
            controls.config.KEYLOCK.toggles[0].onoff.updateValue(keylock_sideswall);

            controls.config.MIC_MUTE_FUNC.toggles[0].onoff.updateValue(mic_mute_func);
            controls.config.SPOUT_ASSIGN.toggles[0].onoff.updateValue(spout_assign_codec);
            controls.config.SPOUT_ASSIGN.toggles[1].onoff.updateValue(spout_assign_aux);
            
        } else if (arrayString[0] == 'EQ_AUX'){
            controls.EQ.FILTERS.filter1.filter1.updateValue(arrayString[1])
            controls.EQ.FILTERS.filter2.filter2.updateValue(arrayString[5])
            controls.EQ.FREQUENCY.frequencies[0].frequency.updateValue(arrayString[6])
            controls.EQ.FREQUENCY.frequencies[1].frequency.updateValue(arrayString[7])
            controls.EQ.FREQUENCY.frequencies[2].frequency.updateValue(arrayString[8])
            controls.EQ.FREQUENCY.frequencies[3].frequency.updateValue(arrayString[9])
            controls.EQ.FREQUENCY.frequencies[4].frequency.updateValue(arrayString[10])
            controls.EQ.GAIN.gains[0].gain.updateValue(arrayString[11])
            controls.EQ.GAIN.gains[1].gain.updateValue(arrayString[12])
            controls.EQ.GAIN.gains[2].gain.updateValue(arrayString[13])
            controls.EQ.GAIN.gains[3].gain.updateValue(arrayString[14])
            controls.EQ.GAIN.gains[4].gain.updateValue(arrayString[15])
            controls.EQ.Q.qValues[0].q.updateValue(arrayString[16])
            controls.EQ.Q.qValues[1].q.updateValue(arrayString[17])
            controls.EQ.Q.qValues[2].q.updateValue(arrayString[18])
            controls.EQ.Q.qValues[3].q.updateValue(arrayString[19])
            controls.EQ.Q.qValues[4].q.updateValue(arrayString[20])
        }
    }
}



$(function () {
    $('#EQAUX_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        if(controls.EQ.FILTERS.filter1.filter1.value == 'HPF'){
            var FILTER_1 = 'hpf12';
        }else{
            var FILTER_1 = 'peq';
        }

        if(controls.EQ.FILTERS.filter2.filter2.value == 'LPF'){
            var FILTER_2 = 'lpf12';
        }else{
            var FILTER_2 = 'peq';
        }
        ws.send(
            ' send ' + ' EQ ' + ' AUX ' +
            FILTER_1 + ' peq ' + ' peq ' + ' peq ' + FILTER_2 + ' ' +
            controls.EQ.FREQUENCY.frequencies[0].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[1].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[2].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[3].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[4].frequency.value + ' ' +
            controls.EQ.Q.qValues[0].q.value + ' ' +
            controls.EQ.Q.qValues[1].q.value + ' ' +
            controls.EQ.Q.qValues[2].q.value + ' ' +
            controls.EQ.Q.qValues[3].q.value + ' ' +
            controls.EQ.Q.qValues[4].q.value + ' ' +
            controls.EQ.GAIN.gains[0].gain.value + ' ' +
            controls.EQ.GAIN.gains[1].gain.value + ' ' +
            controls.EQ.GAIN.gains[2].gain.value + ' ' +
            controls.EQ.GAIN.gains[3].gain.value + ' ' +
            controls.EQ.GAIN.gains[4].gain.value
        );
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});

(function () {
    var ip_form = document.getElementById("ipchange")
    var config_down = document.getElementById("config_down")
    var div_ip = document.getElementById("ipaddress")
    

    ip_form.setAttribute("action", "http://" + NOW_IPADDRESS + "/ipchange.php");
    config_down.setAttribute("action", "http://" + NOW_IPADDRESS + "/config_download.php");
    div_ip.setAttribute("title", NOW_IPADDRESS);

})();

$(window).on('load resize', function () {
    var w = $(window).width();
    var x = 360;
    if (w <= x) {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '250px' });
    } else {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '' });
        $('.btn-send.fixed').css({ 'right': '10px' });
    }
});

$(function () {
    $('#EQ_Reset').on('click', function () {
        //Resetボタンを押した時に値初期化 EQの工場出荷設定を変更する場合はここも変更する必要あり。
        controls.EQ.FILTERS.filter1.filter1.updateValue("PEQ");
        controls.EQ.FILTERS.filter2.filter2.updateValue("PEQ");
        controls.EQ.FREQUENCY.frequencies[0].frequency.updateValue(200);
        controls.EQ.FREQUENCY.frequencies[1].frequency.updateValue(630);
        controls.EQ.FREQUENCY.frequencies[2].frequency.updateValue(1600);
        controls.EQ.FREQUENCY.frequencies[3].frequency.updateValue(4000);
        controls.EQ.FREQUENCY.frequencies[4].frequency.updateValue(10000);
        controls.EQ.GAIN.gains[0].gain.updateValue(0);
        controls.EQ.GAIN.gains[1].gain.updateValue(0);
        controls.EQ.GAIN.gains[2].gain.updateValue(0);
        controls.EQ.GAIN.gains[3].gain.updateValue(0);
        controls.EQ.GAIN.gains[4].gain.updateValue(0);
        controls.EQ.Q.qValues[0].q.updateValue(4.318);
        controls.EQ.Q.qValues[1].q.updateValue(4.318);
        controls.EQ.Q.qValues[2].q.updateValue(4.318);
        controls.EQ.Q.qValues[3].q.updateValue(4.318);
        controls.EQ.Q.qValues[4].q.updateValue(4.318);
    });
});