$(function () {
    $('#network_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
    });
});


$(function () {
    $('#user_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        MAX_TEXT_LEN = 16; //最大入力可能数(1バイト文字)
        MIN_TEXT_LEN = 4;
        if ($('#username').val().match(/[^0-9a-zA-Z]+/) || $('#username').val().length < MIN_TEXT_LEN || $('#username').val().length > MAX_TEXT_LEN )  {
            alert('Must be 4-16 alphanumeric characters.')
        } else if ($('#password').val().match(/[^0-9a-zA-Z]+/) || $('#username').val().length < MIN_TEXT_LEN || $('#username').val().length > MAX_TEXT_LEN ) {
            alert('Must be 4-16 alphanumeric characters.')
        } else {
            ws.send(
                ' send ' + ' config ' + ' user ' +
                controls.config.USER.username.text.value + ' ' +
                controls.config.USER.password.text.value + ' '
            );
            // websokcet already close? readyState:2 closing, 3 closed
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
            }
        }
    });
});


$(function () {
    $('#bt_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        MAX_TEXT_LEN = 24; //最大入力可能数(1バイト文字)
        MIN_TEXT_LEN = 1;
        if ($('#devname').val().match(/[^0-9a-zA-Z\-_ .]+/) || $('#devname').val().length < MIN_TEXT_LEN || $('#devname').val().length > MAX_TEXT_LEN )  {
            alert('Must be 1-24 alphanumeric characters.')
        } else {
            //デバイス名は半角スペースを許可しているため、websocketで送るために"&nbsp;"に置換する。
            var btname_tmp = controls.config.BLUETOOTH.devname.text.value;
            btname = btname_tmp.replace(/ /g, '&nbsp;');
            ws.send(
                ' send ' + ' config ' + ' bt ' +
                btname + ' '
            );
            // websokcet already close? readyState:2 closing, 3 closed
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
            }
        }
    });
});

$(function () {
    $('#cont_led_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        if (controls.config.CONTACT.inputs[0].input.value == 'Volume Up') {
            var CONTACT_IN1 = 'Volume_Up';
        } else if (controls.config.CONTACT.inputs[0].input.value == 'Volume Down') {
            var CONTACT_IN1 = 'Volume_Down';
        } else {
            var CONTACT_IN1 = controls.config.CONTACT.inputs[0].input.value;
        }

        if (controls.config.CONTACT.inputs[1].input.value == 'Volume Up') {
            var CONTACT_IN2 = 'Volume_Up';
        } else if (controls.config.CONTACT.inputs[1].input.value == 'Volume Down') {
            var CONTACT_IN2 = 'Volume_Down';
        } else {
            var CONTACT_IN2 = controls.config.CONTACT.inputs[1].input.value;
        }

        if (controls.config.CONTACT.outputs[0].output.value == 'Mute Status') {
            var CONTACT_OUT1 = "Mute_Status";
        } else if (controls.config.CONTACT.outputs[0].output.value == 'Synch Input1') {
            var CONTACT_OUT1 = "Synch_Input1";
        } else if (controls.config.CONTACT.outputs[0].output.value == 'Synch Input2') {
            var CONTACT_OUT1 = "Synch_Input2";
        } else {
            var CONTACT_OUT1 = controls.config.CONTACT.outputs[0].output.value;
        }

        if (controls.config.CONTACT.outputs[1].output.value == 'Mute Status') {
            var CONTACT_OUT2 = "Mute_Status";
        } else if (controls.config.CONTACT.outputs[1].output.value == 'Synch Input1') {
            var CONTACT_OUT2 = "Synch_Input1";
        } else if (controls.config.CONTACT.outputs[1].output.value == 'Synch Input2') {
            var CONTACT_OUT2 = "Synch_Input2";
        } else {
            var CONTACT_OUT2 = controls.config.CONTACT.outputs[1].output.value;
        }

        if (controls.config.INDICATE.mute.mute.value == 'Only Center') {
            var INDICATE_MUTE = "Only_Center";
        } else if (controls.config.INDICATE.mute.mute.value == 'ALL LED') {
            var INDICATE_MUTE = "ALL_LED";
        }

        ws.send(
            ' send ' + ' config ' + ' cont_led ' +
            CONTACT_IN1 + ' ' +
            CONTACT_IN2 + ' ' +
            CONTACT_OUT1 + ' ' +
            CONTACT_OUT2 + ' ' +
            controls.config.INDICATE.toggles[0].onoff.value + ' ' +
            controls.config.INDICATE.toggles[1].onoff.value + ' ' +
            INDICATE_MUTE + ' ' +
            controls.config.KEYLOCK.toggles[0].onoff.value + ' ' +
            controls.config.MIC_MUTE_FUNC.toggles[0].onoff.value + ' ' +
            controls.config.SPOUT_ASSIGN.toggles[0].onoff.value + ' ' +
            controls.config.SPOUT_ASSIGN.toggles[1].onoff.value
        );
        // websokcet already close? readyState:2 closing, 3 closed
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});


$(function () {
    $("#time_send").click(function () {
        var dateObj = new Date(controls.config.TIME.years.year.value, controls.config.TIME.monthes.month.value - 1, controls.config.TIME.days.day.value);
        var weekDayList = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
        var weekday = weekDayList[dateObj.getDay()];
        var hour = controls.config.TIME.hours.hour.value;
        var minute = controls.config.TIME.minutes.minute.value;
        var second = controls.config.TIME.seconds.second.value;
        var str = controls.config.TIME.years.year.value + " " +
            controls.config.TIME.monthes.month.value + " " +
            controls.config.TIME.days.day.value + " " +
            hour + " " + minute + " " + second + " " + weekday;
        if (controls.config.TIME.years.year.value < 2017 || controls.config.TIME.years.year.value >= 2034) {
            alert("Invalid date. Enter today's date.")
            return;
        }
        $.blockUI({
            message: "Please wait...",
            baseZ: 1000000  //一番手前で表示する
        });
        ws.send(' send ' + ' config ' + ' time_send ' + str);
        // websokcet already close? readyState:2 closing, 3 closed
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
            $.unblockUI();
        }else{
            setTimeout('window.location.reload()', 20000);
        }
    });
});

// ignore Enterkey
$(function () {
    $("input").keydown(function (e) {
        if ((e.which && e.which === 13) || (e.keyCode && e.keyCode === 13)) {
            return false;
        } else {
            return true;
        }
    });
});