# -*- coding:utf-8 -*-
import json, copy, sys
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command
import time

TMP_PATH = '/home/toa/TOA_AM-CF1/tmp/'
command_set_flag_fname = TMP_PATH + 'command_get_param_set_flag.json' #param_set_flag取得用command
result_set_flag_fname = TMP_PATH +  'result_get_param_set_flag.json' #param_set_flag取得用result
command_get_flag_fname = TMP_PATH +  'command_get_param_get_flag.json' #param_get_flag取得用command
result_get_flag_fname = TMP_PATH +  'result_get_param_get_flag.json' #param_get_flag取得用result

# ---------------------------------------------------------
def Comfirm_Param_Set_Get_Flag_Init():
    #--- 起動時にparam_set_flagを取得するコマンドjsonを作成する
    set_flag_commands = [
        {
        'access': 'get',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'param_set_flag':None }
        }
        ]
    
    get_flag_commands = [
        {
        'access': 'get',
        'block_no': BlockNo.AEC,
        'type': 'aec',
        'param': { 'param_get_flag':None }
        }
        ]

    with open(command_set_flag_fname, 'w') as f:
        # jsonファイルを辞書型として読み込み
        json.dump(set_flag_commands, f, indent=True)
    
    with open(command_get_flag_fname, 'w') as f:
        # jsonファイルを辞書型として読み込み
        json.dump(get_flag_commands, f, indent=True)

def Comfirm_Param_Set_Flag():
    #result_json_fname: param_set_flagを含むresult.jsonファイル名(DSP設定時にgetした値。なければ追加でgetした値)
    res_param_set_flag = 1 #変数初期化

    send_command(command_set_flag_fname,result_set_flag_fname)

    with open(result_set_flag_fname, 'r') as f:
        result_data = json.load(f)
    res_param_set_flag = int(result_data[0]["param"]["param_set_flag"])
    
    return res_param_set_flag

def Comfirm_Param_Get_Flag():
    #result_json_fname: param_set_flagを含むresult.jsonファイル名(DSP設定時にgetした値。なければ追加でgetした値)
    res_param_get_flag = 1 #変数初期化
    
    send_command(command_get_flag_fname,result_get_flag_fname)

    with open(result_get_flag_fname, 'r') as f:
        result_data = json.load(f)
    res_param_get_flag = int(result_data[0]["param"]["param_get_flag"])

    return res_param_get_flag

def Wait_Param_Set_Flag():
    while Comfirm_Param_Set_Flag() == 1:
        time.sleep(0.01) #param_set_flagが0になるまでまつ

def Wait_Param_Get_Flag():
    while Comfirm_Param_Get_Flag() == 1:
        time.sleep(0.01) #param_set_flagが0になるまでまつ