//*voli_rdsd.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

ws.onerror = function () {
    alert('Failure to connect')
};

ws.onopen = function () {
    ws.send(
        'ud_state'
    );
    ws.send(
        ' read ' + ' config '
    );
    ws.send(
        ' read ' + ' EQ ' + ' AUX '
    );
    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:usbin_gain, 2:BTin_gain,
        //3:Codecin_gain, 4:AUXin_gain,
        //5:SPout_gain, 6:USBout_gain,
        //7:BT_gain, 8:Codecout_gain,
        //9:AUX_gain, 10～18:mute_sts*9 (0:ON 1:OFF)
        var arrayString = e.data.split(",");
        if (arrayString[0] == 'dialog') {
            alert(arrayString[1])

        } else if (arrayString[0] == 'config'){
            controls.config.NETWORK.ipfields[0].ip.updateValue(arrayString[1])
            controls.config.NETWORK.ipfields[1].ip.updateValue(arrayString[2])
            controls.config.NETWORK.ipfields[2].ip.updateValue(arrayString[3])
            controls.config.USER.username.text.updateValue(arrayString[4])
            controls.config.USER.password.text.updateValue(arrayString[5])

            if (arrayString[6] == 'Volume_Up'){
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Up")
            }else if(arrayString[6] == 'Volume_Down'){
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Down")
            }else{
                controls.config.CONTACT.inputs[0].input.updateValue(arrayString[6])
            }
            if (arrayString[7] == 'Volume_Up'){
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Up")
            }else if(arrayString[7] == 'Volume_Down'){
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Down")
            }else{
                controls.config.CONTACT.inputs[1].input.updateValue(arrayString[7])
            }

            if (arrayString[8] == 'Mute_Status'){
                controls.config.CONTACT.outputs[0].output.updateValue("Mute Status")
            }else if(arrayString[8] == 'Synch_Input1'){
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input1")
            }else if(arrayString[8] == 'Synch_Input2'){
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input2")
            }else{
                controls.config.CONTACT.outputs[0].output.updateValue(arrayString[8])
            }

            if (arrayString[9] == 'Mute_Status'){
                controls.config.CONTACT.outputs[1].output.updateValue("Mute Status")
            }else if(arrayString[9] == 'Synch_Input1'){
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input1")
            }else if(arrayString[9] == 'Synch_Input2'){
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input2")
            }else{
                controls.config.CONTACT.outputs[1].output.updateValue(arrayString[9])
            }

            controls.config.INDICATE.toggles[0].onoff.updateValue(arrayString[10])
            controls.config.INDICATE.toggles[1].onoff.updateValue(arrayString[11])
            if (arrayString[12] == 'Only_Center'){
                controls.config.INDICATE.mute.mute.updateValue("Only Center")
            }else if(arrayString[12] == 'ALL_LED'){
                controls.config.INDICATE.mute.mute.updateValue("ALL LED")
            }
            // Add CPU Version and DSP Version data
            document.getElementById("firm_version").textContent = arrayString[13];
            if (arrayString.length > 14){
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    arrayString[14] + "/" + arrayString[15] + "/" +
                    arrayString[16] + " " + arrayString[17] + ":" +
                    arrayString[18];
            }else{
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    "Failed to load.";
            }
            
        } else if (arrayString[0] == 'EQ_AUX'){
            controls.EQ.FILTERS.filter1.filter1.updateValue(arrayString[1])
            controls.EQ.FILTERS.filter2.filter2.updateValue(arrayString[5])
            controls.EQ.FREQUENCY.frequencies[0].frequency.updateValue(arrayString[6])
            controls.EQ.FREQUENCY.frequencies[1].frequency.updateValue(arrayString[7])
            controls.EQ.FREQUENCY.frequencies[2].frequency.updateValue(arrayString[8])
            controls.EQ.FREQUENCY.frequencies[3].frequency.updateValue(arrayString[9])
            controls.EQ.FREQUENCY.frequencies[4].frequency.updateValue(arrayString[10])
            controls.EQ.GAIN.gains[0].gain.updateValue(arrayString[11])
            controls.EQ.GAIN.gains[1].gain.updateValue(arrayString[12])
            controls.EQ.GAIN.gains[2].gain.updateValue(arrayString[13])
            controls.EQ.GAIN.gains[3].gain.updateValue(arrayString[14])
            controls.EQ.GAIN.gains[4].gain.updateValue(arrayString[15])
            controls.EQ.Q.qValues[0].q.updateValue(arrayString[16])
            controls.EQ.Q.qValues[1].q.updateValue(arrayString[17])
            controls.EQ.Q.qValues[2].q.updateValue(arrayString[18])
            controls.EQ.Q.qValues[3].q.updateValue(arrayString[19])
            controls.EQ.Q.qValues[4].q.updateValue(arrayString[20])
        }
    }
}



$(function () {
    $('#EQAUX_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信
        if(controls.EQ.FILTERS.filter1.filter1.value == 'HPF'){
            var FILTER_1 = 'hpf12';
        }else{
            var FILTER_1 = 'peq';
        }

        if(controls.EQ.FILTERS.filter2.filter2.value == 'LPF'){
            var FILTER_2 = 'lpf12';
        }else{
            var FILTER_2 = 'peq';
        }
        ws.send(
            ' send ' + ' EQ ' + ' AUX ' +
            FILTER_1 + ' peq ' + ' peq ' + ' peq ' + FILTER_2 + ' ' +
            controls.EQ.FREQUENCY.frequencies[0].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[1].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[2].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[3].frequency.value + ' ' +
            controls.EQ.FREQUENCY.frequencies[4].frequency.value + ' ' +
            controls.EQ.Q.qValues[0].q.value + ' ' +
            controls.EQ.Q.qValues[1].q.value + ' ' +
            controls.EQ.Q.qValues[2].q.value + ' ' +
            controls.EQ.Q.qValues[3].q.value + ' ' +
            controls.EQ.Q.qValues[4].q.value + ' ' +
            controls.EQ.GAIN.gains[0].gain.value + ' ' +
            controls.EQ.GAIN.gains[1].gain.value + ' ' +
            controls.EQ.GAIN.gains[2].gain.value + ' ' +
            controls.EQ.GAIN.gains[3].gain.value + ' ' +
            controls.EQ.GAIN.gains[4].gain.value
        );
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});

(function () {
    var ip_form = document.getElementById("ipchange")
    var config_down = document.getElementById("config_down")
    var div_ip = document.getElementById("ipaddress")
    

    ip_form.setAttribute("action", "http://" + NOW_IPADDRESS + "/ipchange.php");
    config_down.setAttribute("action", "http://" + NOW_IPADDRESS + "/config_download.php");
    div_ip.setAttribute("title", NOW_IPADDRESS);

})();

$(window).on('load resize', function () {
    var w = $(window).width();
    var x = 360;
    if (w <= x) {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '250px' });
    } else {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '' });
        $('.btn-send.fixed').css({ 'right': '10px' });
    }
});