#!/bin/sh
#*************************************************
#          etc_change.sh
#                        ver.1.0.0.8
#*************************************************
#set -e

echo "etc_boot_change.sh"

# directory cp
CP_OPTION="-r -f -p";

etc_src_dir=/home/toa/etc_new/;
etc_dir=/etc/;
boot_src_dir=/home/toa/boot_new/;
boot_dir=/boot/;
#etc_etc_src_dir=/home/toa/UPDATE_TEST/home/toa/etc_new/; for DEBUG
#etc_dir=/home/toa/UPDATE_TEST/etc/; for DEBUG
#
#*************************************************
# Change /etc files
#*************************************************
cd /home/toa/etc_new;

## permission modify
# etc boot file permission modify
chmod -R 777 ./config
chmod -R 777 ./preset

chmod 755 ./ufw
chmod 640 ./ufw/user6.rules
chmod 640 ./ufw/user.rules
chmod 644 ./ufw/ufw.conf
chmod 755 ./systemd
chmod 644 ./systemd/journald.conf
chmod 755 ./ssh
chmod 644 ./ssh/sshd_config
chmod 755 ./samba
chmod 644 ./samba/smb.conf
chmod 755 ./php
chmod 755 ./php/7.1
chmod 755 ./php/7.1/apache2
chmod 644 ./php/7.1/apache2/php.ini
chmod 755 ./logrotate.d
chmod 644 ./logrotate.d/unattended-upgrades
chmod 644 ./logrotate.d/ufw
chmod 644 ./logrotate.d/speech-dispatcher
chmod 644 ./logrotate.d/samba
chmod 644 ./logrotate.d/rsyslog
chmod 644 ./logrotate.d/ppp
chmod 644 ./logrotate.d/pm-utils
chmod 644 ./logrotate.d/php7.0-fpm
chmod 644 ./logrotate.d/lightdm
chmod 644 ./logrotate.d/dpkg
chmod 644 ./logrotate.d/cups-daemon
chmod 644 ./logrotate.d/aptitude
chmod 644 ./logrotate.d/apt
chmod 644 ./logrotate.d/apport
chmod 644 ./logrotate.d/apache2
chmod 755 ./init.d
chmod 755 ./init.d/saveoverlays
chmod 755 ./cron.hourly
chmod 755 ./cron.hourly/logrotate
chmod 755 ./apt
chmod 755 ./apt/apt.conf.d
chmod 644 ./apt/apt.conf.d/20auto-upgrades
chmod 755 ./apache2
chmod 644 ./apache2/apache2.conf
chmod 640 ./shadow
chmod 755 ./rc.local
chmod 644 ./logrotate.conf
chmod 644 ./localtime
chmod 644 ./fstab
chmod 644 ./crontab
##

chmod -R 777 ./config
chmod -R 777 ./preset

# for inspection (TVC ver1.0.0.11)
rm -r /home/toa/TOA_AM-CF1/Application/data/config/*.txt
rm -r /home/toa/TOA_AM-CF1/Application/data/preset/*

cp $CP_OPTION ./config ../TOA_AM-CF1/Application/data/
cp $CP_OPTION ./preset ../TOA_AM-CF1/Application/data/
cp $CP_OPTION ./config /home_org/toa/TOA_AM-CF1/Application/data/
cp $CP_OPTION ./preset /home_org/toa/TOA_AM-CF1/Application/data/

rm -r ./config
rm -r ./preset
################
# etc dir move
rm etc_change.sh

for file in `\find ./ -type f -not -name 'etc_boot_change.sh'`;
do
    cp -r -f $etc_src_dir$file $etc_dir$file;
done;

# boot dir move
cd /home/toa/boot_new;

## permission modify
chmod 755 ./config.txt
chmod 755 ./cmdline.txt
##

mount -o remount,rw /boot;

for file in `\find ./ -type f`;
do
    cp -r -f $boot_src_dir$file $boot_dir$file;
done;

mount -o remount,ro /boot;

cd /home/toa;
#*************************************************
# Remove /etc files
#*************************************************
# rm {UNNECESSARY_FILE};


#*************************************************
# Move /etc files
#*************************************************
# cp {OLD_DIR}/{FILENAME} {NEW_DIR}/{FILENAME};
# rm {OLD_DIR}/{FILENAME};

#add 20171025 ver1.0.1.15
#touch /home/toa/TOA_AM-CF1/REBOOT_2nd;

#add 20171201 ver1.0.2.1


echo "# Update etc boot OK #" >> /home/toa/TOA_AM-CF1/install.log;