#!/bin/sh

# directory cp
CP_OPTION="-r -f -p";
# directory rm
RM_OPTION="-f -r";

dir_src1=/home/toa/TOA_AM-CF1_new;
dir_src2=/home/toa/StartupShell_new;
dir_src3=/var/www/html_new;
dir_src4=/home/toa/etc_new;
dir_src5=/home/toa/boot_new;

dir_src1_org=/home_org/toa/TOA_AM-CF1_new;
dir_src2_org=/home_org/toa/StartupShell_new;
dir_src3_org=/var_org/www/html_new;
dir_src4_org=/home_org/toa/etc_new;
dir_src5_org=/home_org/toa/boot_new;

dir_rm1=/home/toa/TOA_AM-CF1_new_broken;
dir_rm2=/home/toa/StartupShell_new_broken;
dir_rm3=/var/www/html_new_broken;
dir_rm4=/home/toa/etc_new_broken;
dir_rm5=/home/toa/boot_new_broken;

dir_rm1_org=/home_org/toa/TOA_AM-CF1_new_broken;
dir_rm2_org=/home_org/toa/StartupShell_new_broken;
dir_rm3_org=/var_org/www/html_new_broken;
dir_rm4_org=/home_org/toa/etc_new_broken;
dir_rm5_org=/home_org/toa/boot_new_broken;

ChangeOwnerPermissionOfIPAddressFiles() {
    ## Change owner to root
    FILES_TO_CHANGE_OWNER_ROOT='
	    /home/toa/StartupShell/ipaddress.conf
    /home_org/toa/StartupShell/ipaddress.conf
        /home/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
    /home_org/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
        /home/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    /home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    ' # end of quote
    for file in ${FILES_TO_CHANGE_OWNER_ROOT}
    do
        chown root:root ${file}
    done
    
    ## Change permission to 777
    FILES_TO_CHANGE_PERMISSION_777='
	    /home/toa/StartupShell/ipaddress.conf
    /home_org/toa/StartupShell/ipaddress.conf
	    /home/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
    /home_org/toa/TOA_AM-CF1/Webserver/static/js/ws_set.js
        /home/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    /home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt
    ' # end of quote
    for file in ${FILES_TO_CHANGE_PERMISSION_777}
    do
        chmod 777 ${file}
    done
}

# If there are ***_broken, any update has not been done.
if [ -e $dir_rm1 ] || [ -e $dir_rm2 ] || [ -e $dir_rm3 ] || [ -e $dir_rm4 ] || [ -e $dir_rm5 ]; then
	mount -o remount,rw /
	rm $RM_OPTION $dir_src1;
	rm $RM_OPTION $dir_src2;
	rm $RM_OPTION $dir_src3;
	rm $RM_OPTION $dir_src4;
	rm $RM_OPTION $dir_src5;
	rm $RM_OPTION $dir_src1_org;
	rm $RM_OPTION $dir_src2_org;
	rm $RM_OPTION $dir_src3_org;
	rm $RM_OPTION $dir_src4_org;
	rm $RM_OPTION $dir_src5_org;

	rm $RM_OPTION $dir_rm1;
	rm $RM_OPTION $dir_rm2;
	rm $RM_OPTION $dir_rm3;
	rm $RM_OPTION $dir_rm4;
	rm $RM_OPTION $dir_rm5;
	rm $RM_OPTION $dir_rm1_org;
	rm $RM_OPTION $dir_rm2_org;
	rm $RM_OPTION $dir_rm3_org;
	rm $RM_OPTION $dir_rm4_org;
	rm $RM_OPTION $dir_rm5_org;
	mount -o remount,ro /
else
	# update directory counter = [4 is update success], [0~3 is update failed].
	COUNT=0;
	# /home/toa/TOA_AM-CF1

	dir_src=/home/toa/TOA_AM-CF1_new;
	dir_src_org=/home_org/toa/TOA_AM-CF1_new;
	dir_dst=/home/toa/TOA_AM-CF1;
	dir_dst_org=/home_org/toa/TOA_AM-CF1;
	dir_rm=/home/toa/TOA_AM-CF1_new_broken;
	dir_rm_org=/home_org/toa/TOA_AM-CF1_new_broken;

	dir_preset=/home/toa/TOA_AM-CF1/Application/data/preset;
	dir_config=/home/toa/TOA_AM-CF1/Application/data/config;
	dir_data_new=/home/toa/TOA_AM-CF1_new/Application/data;
	dir_data_new_org=/home_org/toa/TOA_AM-CF1_new/Application/data;

	if [ -e $dir_src ]; then
		mount -o remount,rw /

		# permission modify
		chmod 777 /home/toa;
		chown root:root /home/toa;
		chmod -R 777 $dir_src;
		chown -R root:root $dir_src;
		chmod 777 /home_org/toa;
		chown root:root /home_org/toa;
		chmod -R 777 $dir_src_org;
		chown -R root:root $dir_src_org;

		echo "# File Copy to /TOA_AM-CF1 #"
		# ** -> **_new hikitsugi config data (config***.txt only)
		rm $dir_data_new/config/config*;
		rm $dir_data_new_org/config/config*;
		cp $CP_OPTION $dir_config/config* $dir_data_new/config;
		cp $CP_OPTION $dir_config/config* $dir_data_new_org/config;
		# ** -> **_new hikitsugi preset data (config***.txt only)
		rm $RM_OPTION $dir_data_new/preset;
		rm $RM_OPTION $dir_data_new_org/preset;
		cp $CP_OPTION $dir_preset $dir_data_new;
		cp $CP_OPTION $dir_preset $dir_data_new_org;
		# TOA_AM-CF1_new -> TOA_AM-CF1
		rm $RM_OPTION $dir_dst;
		rm $RM_OPTION $dir_dst_org;
		cp $CP_OPTION $dir_src $dir_dst;
		cp $CP_OPTION $dir_src $dir_dst_org;
		rm $RM_OPTION $dir_src;
		rm $RM_OPTION $dir_src_org;

		echo "# File Copy to /TOA_AM-CF1 OK #"
		mount -o remount,ro /;
		COUNT=$(( COUNT + 1 ));
	fi

	# /var/www/html

	dir_src=/var/www/html_new;
	dir_src_org=/var_org/www/html_new;
	dir_dst=/var/www/html;
	dir_dst_org=/var_org/www/html;
	dir_rm=/var/www/html_new_broken;
	dir_rm_org=/var_org/www/html_new_broken;

	if [ -e $dir_src ]; then
		mount -o remount,rw /

		# permission modify
		chmod -R 777 /var/www;
		chown -R root:root /var/www;
		chmod -R 777 /var_org/www;
		chown -R root:root /var_org/www;

		echo "# File Copy to /var/www/html #"
		rm $RM_OPTION $dir_dst;
		rm $RM_OPTION $dir_dst_org;
		cp $CP_OPTION $dir_src $dir_dst;
		cp $CP_OPTION $dir_src $dir_dst_org;
		rm $RM_OPTION $dir_src;
		rm $RM_OPTION $dir_src_org;
		echo "# File Copy to /var/www/html OK #"
		mount -o remount,ro /
		COUNT=$(( COUNT + 1 ));
	fi

	# /home/toa/StartupShell

	dir_src=/home/toa/StartupShell_new;
	dir_src_org=/home_org/toa/StartupShell_new;
	dir_dst=/home/toa/StartupShell;
	dir_dst_org=/home_org/toa/StartupShell;
	dir_rm=/home/toa/StartupShell_new_broken;
	dir_rm_org=/home_org/toa/StartupShell_new_broken;

	ipaddressconf_new=/home/toa/StartupShell_new/ipaddress.conf;
	ipaddressconf_new_org=/home_org/toa/StartupShell_new/ipaddress.conf;
	ipaddressconf=/home/toa/StartupShell/ipaddress.conf;
	ipaddressconf_org=/home_org/toa/StartupShell/ipaddress.conf;

	if [ -e $dir_src ]; then
		mount -o remount,rw /

		echo `ls /home/toa/StartupShell_new`

		# permission modify
		chmod -R 777 $dir_src;
		chown -R root:root $dir_src;
		chmod -R 777 $dir_src_org;
		chown -R root:root $dir_src_org;

		echo "# File Copy to /StartupShell #"
		rm $ipaddressconf_new;
		rm $ipaddressconf_new_org;
		cp $ipaddressconf $ipaddressconf_new;
		cp $ipaddressconf $ipaddressconf_new_org;
		rm $RM_OPTION $dir_dst;
		rm $RM_OPTION $dir_dst_org;
		cp $CP_OPTION $dir_src $dir_dst;
		cp $CP_OPTION $dir_src $dir_dst_org;
		rm $RM_OPTION $dir_src;
		rm $RM_OPTION $dir_src_org;
		echo `ls /home/toa/StartupShell`
		echo "# File Copy to /StartupShell OK #"
		mount -o remount,ro /
		COUNT=$(( COUNT + 1 ));
	fi

	# /home/toa/etc

	dir_src1=/home/toa/etc_new;
	dir_src1_org=/home_org/toa/etc_new;
	dir_src2=/home/toa/boot_new;
	dir_src2_org=/home_org/toa/boot_new;

	if [ -e $dir_src1 ] && [ -e $dir_src2 ]; then
		mount -o remount,rw /
		echo "# File Copy to /etc #";
		# if update from 1.3.0.1, execute /etc/etc_change.sh
		sh $dir_src1/etc_boot_change.sh 2>&1; 
		rm $RM_OPTION $dir_src1;
		rm $RM_OPTION $dir_src1_org;
		rm $RM_OPTION $dir_src2;
		rm $RM_OPTION $dir_src2_org;
		mount -o remount,ro /
		COUNT=$(( COUNT + 1 ));
	fi

	# reboot condition when /TOA_AM-CF1, /StartupShell, /varwww, /etc is all updated.
	if [ $COUNT -eq 4 ]; then
		mount -o remount,rw /
		ChangeOwnerPermissionOfIPAddressFiles
		echo "#UPDATE CHECK#"
		sh /home/toa/StartupShell/chkfile_for_update.sh >> /home/toa/TOA_AM-CF1/install.log
		if [ ${?} -eq 0 ]; then
			echo "#CHECK OK Success#"
			rm /home/toa/TOA_AM-CF1/install.log;
			rm /home_org/toa/TOA_AM-CF1/install.log;
			sync;
			sleep 3;
			sync;
			sleep 3;
			sync;
			sleep 3;
			mount -o remount,ro /;
			reboot;
		else
			echo "#CHECK NG Failed#" >> /home/toa/TOA_AM-CF1/install.log
			touch /home/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG;
			rm /home/toa/StartupShell/chkfile_for_update.sh
			rm /home_org/toa/StartupShell/chkfile_for_update.sh
			rm /home/toa/StartupShell/chkfile_dat.tar.xz
			rm /home_org/toa/StartupShell/chkfile_dat.tar.xz
			mount -o remount,ro /
		fi
	fi
fi
