#pragma once
#include <stdint.h>
#define pm // ADIのキーワードを無効化

namespace control {

float
PowerToDb(float power_);

float
ToDb(float antilog_);

float
ToAntiLog(float db_);

uint32_t
ToDspAddressing(void* cpu_addressing_);

void
ConvertIirCoefToAdi(
		const float * before_,
		float * after_
);

void
ConvertIirCoefFromAdi(
		const float * before_,
		float * after_
);


} // namespace control
