# -*- coding:utf-8 -*-
import json
import subprocess as sp
import copy,os,sys,time
import shutil
sys.path.append('/home/toa/TOA_AM-CF1/Webserver/hello/')
import def_block_no as BlockNo
from send_command import send_command
from check_preset_config import Check_Preset_Data
from check_preset_config import Check_Config_Data
#    pythonスクリプトの中で、pythonを実行
#    # Python実行
#    subprocess.call('python ../script/test.py')

def startup():
    sp.run(['./startup.out','../../tmp/block_cf1_init.json','netlist.bin'])  #change!!

    sp.run(['./control.out','../../tmp/command_cf1_init_gain.json'  ,'netlist.bin', '../../tmp/result_init_gain.json'   ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_comp.json'        ,'netlist.bin', '../../tmp/result_init_comp.json'          ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_iir.json'         ,'netlist.bin', '../../tmp/result_init_iir.json'           ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_aec_nc.json'      ,'netlist.bin', '../../tmp/result_init_aec_nc.json'        ])  #change!!
    sp.run(['./control.out','../../tmp/command_cf1_init_matrix.json'      ,'netlist.bin', '../../tmp/result_init_matrix.json'        ])  #change!!


#Webserver/templates/commandのcommand.jsonもここで作る必要あり
PATH = '/home/toa/TOA_AM-CF1/Application/data/'

def Make_init_gain(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_gain.txt'
    mute_sts_fname = PATH + '../../tmp/volume/' + 'mute_sts.txt' #Change!!
    WEB_SP_gain_fname = PATH + '../../tmp/volume/' + 'web_SPgain_sts.txt' #Change!!
    SPout_block_no = BlockNo.GAIN_SPoutL #SP OUT L
    mute_or_unmute_blockno = [
        BlockNo.GAIN_USBinL,BlockNo.GAIN_USBinR,BlockNo.GAIN_BTinL,BlockNo.GAIN_BTinR,BlockNo.GAIN_CODECin,BlockNo.GAIN_AUXinL,BlockNo.GAIN_AUXinR,
        BlockNo.GAIN_SPoutL,BlockNo.GAIN_SPoutR,BlockNo.GAIN_USBoutL,BlockNo.GAIN_USBoutR,BlockNo.GAIN_BToutL,BlockNo.GAIN_CODECout,BlockNo.GAIN_AUXoutL,BlockNo.GAIN_AUXoutR] # (Ref.) WEB Mixer Left to Right 
    ##################### Dynamic Change #####################
    blocknums = []
    gain_vals = []
    mute_sts = []
    mute_web_gain_sts =[]
    mute_blockno = []

    MUTE_GAIN = -150

    with open(preset_fname,'r') as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            gain_vals.append(vals[1])
            if len(vals) >= 3:
                mute_blockno.append(vals[0])
                mute_sts.append(vals[2])
                mute_web_gain_sts.append(vals[1])

    if mute_sts[0] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[0])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[1])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[0])] = gain_vals[blocknums.index(mute_or_unmute_blockno[0])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[1])] = gain_vals[blocknums.index(mute_or_unmute_blockno[0])]

    if mute_sts[1] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[2])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[3])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[2])] = gain_vals[blocknums.index(mute_or_unmute_blockno[2])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[3])] = gain_vals[blocknums.index(mute_or_unmute_blockno[2])]

    if mute_sts[2] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[4])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[4])] = gain_vals[blocknums.index(mute_or_unmute_blockno[4])]

    if mute_sts[3] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[5])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[6])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[5])] = gain_vals[blocknums.index(mute_or_unmute_blockno[5])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[6])] = gain_vals[blocknums.index(mute_or_unmute_blockno[5])]

    if mute_sts[4] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[7])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[8])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[7])] = gain_vals[blocknums.index(mute_or_unmute_blockno[7])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[8])] = gain_vals[blocknums.index(mute_or_unmute_blockno[7])]

    if mute_sts[5] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[9])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[10])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[9])] = gain_vals[blocknums.index(mute_or_unmute_blockno[9])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[10])] = gain_vals[blocknums.index(mute_or_unmute_blockno[9])]

    if mute_sts[6] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[11])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[11])] = gain_vals[blocknums.index(mute_or_unmute_blockno[11])]

    if mute_sts[7] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[12])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[12])] = gain_vals[blocknums.index(mute_or_unmute_blockno[12])]

    if mute_sts[8] == '0':
        gain_vals[blocknums.index(mute_or_unmute_blockno[13])] = MUTE_GAIN
        gain_vals[blocknums.index(mute_or_unmute_blockno[14])] = MUTE_GAIN
    else:
        gain_vals[blocknums.index(mute_or_unmute_blockno[13])] = gain_vals[blocknums.index(mute_or_unmute_blockno[13])]
        gain_vals[blocknums.index(mute_or_unmute_blockno[14])] = gain_vals[blocknums.index(mute_or_unmute_blockno[13])]

    blocknums.extend(blocknums)
    blk_ln = len(gain_vals)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = int(blocknums[i])
        commands[i]['type'] = 'gain'
        commands[i]['param'] = {'gain':None}

    for i in range(0,blk_ln):
        commands[i]['access'] = 'set'
        if commands[i]['block_no'] == BlockNo.GAIN_SPoutL or commands[i]['block_no'] == BlockNo.GAIN_SPoutR:
            commands[i]['param']['gain'] = int(gain_vals[i]) #Sum SP out
        else:
            commands[i]['param']['gain'] = int(gain_vals[i])

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    with open(mute_sts_fname, 'w') as f:
        f.write(",".join(mute_sts))
        f.write('\n')
        f.write(",".join(mute_web_gain_sts))

    with open(WEB_SP_gain_fname, 'w') as f:
        sp_index = mute_blockno.index(str(SPout_block_no))
        f.write(mute_web_gain_sts[sp_index])
        f.write('\n')
        f.write(mute_sts[sp_index])

def Make_init_comp(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_comp.txt'
    ##################### Static No Change #####################
    blocknums = []
    at_t = []
    rl_t = []
    thr = []
    mkup_g = []
    rto = []
    knee = []
    lv_typ = []

    with open(preset_fname,'r') as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            at_t.append(float(vals[1]))
            rl_t.append(float(vals[2]))
            thr.append(float(vals[3]))
            mkup_g.append(float(vals[4]))
            rto.append(float(vals[5]))
            knee.append(vals[6])
            lv_typ.append(vals[7])

    blocknums.extend(blocknums)
    blk_ln = int(len(blocknums)/2)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = blocknums[i]
        commands[i]['type'] = 'comp'
        commands[i]['param'] = {'attack_time':None, 'release_time':None, 'threshold':None, 'makeup_gain':None, 'ratio':None, 'knee':None, 'level_type':None}

        if i < blk_ln:
            commands[i]['access'] = 'set'
            commands[i]['param']['attack_time'] = at_t[i]
            commands[i]['param']['release_time'] = rl_t[i]
            commands[i]['param']['threshold'] = thr[i]
            commands[i]['param']['makeup_gain'] = mkup_g[i]
            commands[i]['param']['ratio'] = rto[i]
            commands[i]['param']['knee'] = knee[i]
            commands[i]['param']['level_type'] = lv_typ[i]
        else:
            commands[i]['status'] = {'gain_target':None, 'gain_current':None, 'peak':None, 'rms':None}

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

def Make_init_iir(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_iir.txt'
    EQSP_param_fname = PATH + '../../tmp/EQ/EQSP_set_param.txt'
    EQAUX_param_fname = PATH + '../../tmp/EQ/EQAUX_set_param.txt'
    ##################### Dynamic Change #####################
    blocknums = []
    stagenums = []

    typs = []
    freq = []
    gain = []
    q = []

    with open(preset_fname,'r') as f:
        for line in f:
            if line[0] == "#":
                continue
            vals = line.strip().split(",")
            blocknums.append(int(vals[0]))
            stagenums.append(int(vals[1]))
            typs.append(vals[2])
            freq.append(float(vals[3]))
            q.append(float(vals[4]))
            gain.append(float(vals[5]))

    SP_types = []
    SP_freqs = []
    SP_gains = []
    SP_qs = []
    AUX_types = []
    AUX_freqs = []
    AUX_gains = []
    AUX_qs = []

    for i in range(len(blocknums)):
        if blocknums[i] == BlockNo.EQ_SPoutL:
            SP_types.append(typs[i])
            SP_freqs.append(str(freq[i]))
            SP_gains.append(str(gain[i]))
            SP_qs.append(str(q[i]))
        elif blocknums[i] == BlockNo.EQ_AUXoutL:
            AUX_types.append(typs[i])
            AUX_freqs.append(str(freq[i]))
            AUX_gains.append(str(gain[i]))
            AUX_qs.append(str(q[i]))

    with open(EQSP_param_fname,'w') as f:
        f.write(",".join(SP_types[0:5]))
        f.write('\n')
        f.write(",".join(SP_freqs[0:5]))
        f.write('\n')
        f.write(",".join(SP_qs[0:5]))
        f.write('\n')
        f.write(",".join(SP_gains[0:5]))
        f.write('\n')

    with open(EQAUX_param_fname,'w') as f:
        f.write(",".join(AUX_types))
        f.write('\n')
        f.write(",".join(AUX_freqs))
        f.write('\n')
        f.write(",".join(AUX_qs))
        f.write('\n')
        f.write(",".join(AUX_gains))
        f.write('\n')

    blk_ln = len(blocknums)

    blocknums.extend(blocknums)
    stagenums.extend(stagenums)

    command = {
        'access': None,
        'block_no': None,
        'type': None,
        'param': {},
        'config': {},
        'status': {}
    }

    commands = []

    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        commands[i]['access'] = 'get'
        commands[i]['block_no'] = blocknums[i]
        commands[i]['type'] = 'iir'
        commands[i]['param'] = {'stage':None, 'type':None, 'frequency':None, 'q':None, 'gain':None}
        commands[i]['param']['stage'] = stagenums[i]

    for i in range(0,blk_ln):
        commands[i]['access'] = 'set'
        commands[i]['param']['type'] = typs[i]
        commands[i]['param']['frequency'] = freq[i]
        commands[i]['param']['q'] = q[i]
        commands[i]['param']['gain'] = gain[i]

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)


def Make_init_aec_nc(preset_no,c_fname):
    preset_fname = PATH + './preset/preset' + str(preset_no) + '_aec_nc.txt'
    conf_data_fname = PATH + '../../tmp/audio/' + 'audio_set_conf.txt' #change!!
    ##################### Dynamic Change #####################
    blocknums = []

    with open(preset_fname, 'r') as f:
        vals = f.readlines()
        aec_prms = vals[1].strip().split(',')
        nc_prms = vals[3].strip().split(',')
        bf_prms = vals[5].strip().split(',')
        conf_prms = vals[7].strip()

        blocknums.append(aec_prms.pop(0))
        blocknums.append(nc_prms.pop(0))
        blocknums.append(bf_prms.pop(0))

    command = {
        'access': 'get',
        'block_no': None,
        'type': None,
        'param': {},
        'config': {},
        'status': {}
    }

    commands = []

    blk_ln = len(blocknums)

    cnt = 0
    for i in range(0,(blk_ln*2)):
        commands.append(copy.deepcopy(command))
        if i % 2 == 0:
            commands[i]['access'] = 'set'
            commands[i]['block_no'] = int(blocknums[cnt])
        else:
            commands[i]['block_no'] = int(blocknums[cnt])
            cnt = cnt + 1

    for i in range(0,2):
        commands[i]['type'] = 'aec'
        commands[i]['param'] = {'on':None,'echo_suppress':None}
        if i % 2 == 0:
            if aec_prms[0] == 'true':
                commands[i]['param']['on'] = True
            else:
                commands[i]['param']['on'] = False
            commands[i]['param']['echo_suppress'] = int(aec_prms[1])

    for i in range(2,4):
        commands[i]['type'] = 'nc'
        commands[i]['param'] = {'bypass':None,'reduction_level':None}
        if i % 2 == 0:
            if nc_prms[0] == 'true':
                commands[i]['param']['bypass'] = True
            else:
                commands[i]['param']['bypass'] = False
            commands[i]['param']['reduction_level'] = int(nc_prms[1])

    for i in range(4,6):
        commands[i]['type'] = 'microphonearray'
        commands[i]['param'] = {'dir':None,'dis':None,'update_mode':None}
        commands[i]['param']['doa']= {'peak_threshold':None,'smooth_tc':None,'source_pos_x_max':None,'source_pos_y_max':None,'source_pos_x_min':None,'source_pos_y_min':None}
        if i % 2 == 0:
            commands[i]['param']['dir'] = int(bf_prms[0])
            commands[i]['param']['dis'] = float(bf_prms[1]) #[m]
            commands[i]['param']['update_mode'] = bf_prms[2]
            commands[i]['param']['doa']['peak_threshold'] = int(bf_prms[3])
            commands[i]['param']['doa']['smooth_tc'] = float(bf_prms[4])
            commands[i]['param']['doa']['source_pos_x_min'] = float(bf_prms[5])
            commands[i]['param']['doa']['source_pos_x_max'] = float(bf_prms[6])
            commands[i]['param']['doa']['source_pos_y_min'] = float(bf_prms[7])
            commands[i]['param']['doa']['source_pos_y_max'] = float(bf_prms[8])

        else:
            commands[i]['status']['doa']= {'peak':None,'lag':None,'source_pos_x':None,'source_pos_y':None}
            commands[i]['status']['bf']= {'focus_x':None,'focus_y':None}

    with open(c_fname, 'w') as f:
        # 辞書型をjsonとして出力
        json.dump(commands, f, indent=True)

    with open(conf_data_fname ,"w") as f:
        f.write(conf_prms)

#---------------------------------------------------------------------
def Make_FactoryPreset_Command_Json():
    preset_no = 0
    Make_init_gain(preset_no,'../../tmp/command_cf1_init_gain.json')
    Make_init_comp(preset_no,'../../tmp/command_cf1_init_comp.json')
    Make_init_iir(preset_no,'../../tmp/command_cf1_init_iir.json')
    Make_init_aec_nc(preset_no,'../../tmp/command_cf1_init_aec_nc.json')
    shutil.copyfile('./init_json/command_cf1_init_matrix.json', '../../tmp/command_cf1_init_matrix.json')

    # copy preset data
    shutil.copyfile('./preset/preset0_defNo.txt', './preset/preset_defNo.txt')
    shutil.copyfile('./preset/preset0_aec_nc.txt', './preset/preset1_aec_nc.txt')
    shutil.copyfile('./preset/preset0_aec_nc.txt', './preset/preset2_aec_nc.txt')
    shutil.copyfile('./preset/preset0_comp.txt', './preset/preset1_comp.txt')
    shutil.copyfile('./preset/preset0_comp.txt', './preset/preset2_comp.txt')
    shutil.copyfile('./preset/preset0_gain.txt', './preset/preset1_gain.txt')
    shutil.copyfile('./preset/preset0_gain.txt', './preset/preset2_gain.txt')
    shutil.copyfile('./preset/preset0_iir.txt', './preset/preset1_iir.txt')
    shutil.copyfile('./preset/preset0_iir.txt', './preset/preset2_iir.txt')

    with open('./preset/preset_nowloadNo.txt','w') as f:
        f.write('1')

    # copy config data
    shutil.copyfile('./config/config_net_def.txt', './config/config_net.txt')
    shutil.copyfile('./config/config_userpass_def.txt', './config/config_userpass.txt')
    shutil.copyfile('./config/config_contled_def.txt', './config/config_contled.txt')

    # Re-writable
    RWMOUNT = sp.Popen("sudo mount -o remount,rw /", shell=True)
    RWMOUNT.wait()

    # copy preset data from home to home_org
    shutil.copyfile('./preset/preset0_aec_nc.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_aec_nc.txt')
    shutil.copyfile('./preset/preset0_aec_nc.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_aec_nc.txt')
    shutil.copyfile('./preset/preset0_comp.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_comp.txt')
    shutil.copyfile('./preset/preset0_comp.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_comp.txt')
    shutil.copyfile('./preset/preset0_gain.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_gain.txt')
    shutil.copyfile('./preset/preset0_gain.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_gain.txt')
    shutil.copyfile('./preset/preset0_iir.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset1_iir.txt')
    shutil.copyfile('./preset/preset0_iir.txt', '/home_org/toa/TOA_AM-CF1/Application/data/preset/preset2_iir.txt')

    # copy config data from home to home_org
    shutil.copyfile('./config/config_net_def.txt', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_net.txt')
    shutil.copyfile('./config/config_userpass_def.txt', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_userpass.txt')
    shutil.copyfile('./config/config_contled_def.txt', '/home_org/toa/TOA_AM-CF1/Application/data/config/config_contled.txt')

    # Back to Read only
    ROMOUNT = sp.Popen("sudo mount -o remount,ro /", shell=True)
    ROMOUNT.wait()

#---------------------------------------------------------------------
def Make_Init_Command_json():
    shutil.copyfile('./init_json/block_cf1_init.json', '../../tmp/block_cf1_init.json') #<- tab
    shutil.copyfile('./init_json/command_cf1_init_matrix.json', '../../tmp/command_cf1_init_matrix.json')
    try:
        with open('./preset/preset_defNo.txt', 'r') as f:
            preset_no = f.read()
            preset_no = int(preset_no.strip())

        with open('./preset/preset_nowloadNo.txt','w') as f:
            f.write(str(preset_no))

        if Check_Config_Data('/home/toa/TOA_AM-CF1/Application/data/config/') == -1:
            Make_FactoryPreset_Command_Json()

        if Check_Preset_Data(preset_no,'/home/toa/TOA_AM-CF1/Application/data/preset/') == -1:
            Make_FactoryPreset_Command_Json()
        else:
            Make_init_gain(preset_no,'../../tmp/command_cf1_init_gain.json')
            Make_init_comp(preset_no,'../../tmp/command_cf1_init_comp.json')
            Make_init_iir(preset_no,'../../tmp/command_cf1_init_iir.json')
            Make_init_aec_nc(preset_no,'../../tmp/command_cf1_init_aec_nc.json')

    except:
        Make_FactoryPreset_Command_Json()

#----------------------------------------------------------------------------------------
def Load_PresetData(i_num):
    if i_num < 3:
        main_SPgain_sts_fname = "/home/toa/TOA_AM-CF1/tmp/volume/main_SPgain_sts.txt"
        preset_nowloadNo_fname = "/home/toa/TOA_AM-CF1/Application/data/preset/preset_nowloadNo.txt"
        PRESET_LOAD_FLAG = "/home/toa/TOA_AM-CF1/tmp/PRESET_LOAD_FLAG"
        with open(main_SPgain_sts_fname,'w') as f:
            f.write(str(0))

        with open(preset_nowloadNo_fname,'w') as f:
            f.write(str(i_num))

        Make_init_gain(i_num, PATH + '../../tmp/m_load_command_cf1_init_gain.json')
        Make_init_iir(i_num, PATH + '../../tmp/m_load_command_cf1_init_iir.json')
        Make_init_aec_nc(i_num, PATH + '../../tmp/m_load_command_cf1_init_aec_nc.json')
        send_command(PATH + '../../tmp/m_load_command_cf1_init_iir.json', PATH + '../../tmp/m_load_result_init_iir.json')
        send_command(PATH + '../../tmp/m_load_command_cf1_init_aec_nc.json', PATH + '../../tmp/m_load_result_init_aec_nc.json')
        send_command(PATH + '../../tmp/m_load_command_cf1_init_gain.json',PATH + '../../tmp/m_load_result_init_gain.json')
        with open(PRESET_LOAD_FLAG,'w') as f:
            f.write('')
