/************************************************************************
 *
 *	coeff_hpf12.c
 *
 *	20020920	Tsuyoshi Ogawa
 *
 ************************************************************************/
#include "fdesign_prototypes.h"

namespace dsp_lib {

/*============================================================*/
void
Fdesign_HPF12_CheckParameter(
	float*	f_,
	float*	q_
)
{
	Fdesign_LPF12_CheckParameter(f_, q_);
}

/*============================================================*/
void
Fdesign_HPF12(
	float	f_,
	float	q_,
	int		bypass_,
	float*	coeff_
)
{
	Fdesign_XOverHPF12(f_, q_, 1.0f, bypass_, coeff_);
}

/*============================================================*/
} // namespace dsp_lib
