/************************************************************************
 *
 *	coeff_hpf24.c
 *
 *	20020925	Tsuyoshi Ogawa
 *
 ************************************************************************/

#include "fdesign_prototypes.h"

namespace dsp_lib {

/*============================================================*/
void
Fdesign_HPF24_CheckParameter(
	float*	f_,
	float*	q1_,
	float*	q2_
)
{
	Fdesign_LPF24_CheckParameter(f_, q1_, q2_);
}

/*============================================================*/
void
Fdesign_HPF24(
	float	f_,
	float	q1_,
	float	q2_,
	int		bypass_,
	float*	coeff1_,
	float*	coeff2_
)
{
	Fdesign_HPF12(f_, q1_, bypass_, coeff1_);
	Fdesign_HPF12(f_, q2_, bypass_, coeff2_);
}

/*============================================================*/
} // namespace dsp_lib
