/************************************************************************
 *
 *	fdesign_through.c
 *
 *
 ************************************************************************/

#include <dsp_lib/misc/biquad/fdesign_prototypes.h>

//======================================================================
namespace dsp_lib {

void
Fdesign_Through(
	float*	coeff_
)
{
	/*------------------------------------------------------------*/
	float	a0, a1, a2, b1, b2;	/* 菫よ焚 */

	/*------------------------------------------------------------*/
	a0 = 1.0f;
	a1 = 0.0f;
	a2 = 0.0f;
	b1 = 0.0f;
	b2 = 0.0f;
	
	/*------------------------------------------------------------*/
	if (coeff_) {
		#ifndef BIQUAD_C	//BIQUAD
		coeff_[0] = a0;
		coeff_[1] = a1;
		coeff_[2] = a2;
		coeff_[3] = b1;
		coeff_[4] = b2;
		#else
		coeff_[0] = a0;		//BIQUAD_C
		coeff_[1] = a1;
		coeff_[2] = a2;
		coeff_[4] = b1;
		coeff_[5] = b2;
		#endif
	}		
	/*------------------------------------------------------------*/
}

} // namespace dsp_lib
//======================================================================
