# -*- coding: utf-8 -*-

print("BM64 Test start")

locate = "section_import_shared_library"
from time import sleep
from ctypes import *
libbm64=CDLL("./libCF1DriversLib.so")

import ctypes
cbfunc=CFUNCTYPE(c_int,POINTER(c_ubyte),c_int) 

def EventCallback(buffer,length):
	return 0

ret = libbm64.LibBM64_Init()
if ret != 0:
	print("LibBM64_Init error {0}".format(ret))

pfunc = cbfunc(EventCallback)
ret = libbm64.LibBM64_CallbackSet(pfunc)
if ret != 0:
	print("LibBM64_CallbackSet error {0}".format(ret))

cmddata = ctypes.c_ubyte * 3
cmdarry = cmddata(0x02, 0x00, 0x53)

ret = libbm64.LibBM64_SendUserCommand(byref(cmdarry),len(cmdarry))
if ret != 0:
	print("LibBM64_LibBM64_SendUserCommand error {0}".format(ret))

sleep(1)

cmdarry = cmddata(0x02, 0x00, 0x54)

ret = libbm64.LibBM64_SendUserCommand(byref(cmdarry),len(cmdarry))
if ret != 0:
	print("LibBM64_LibBM64_SendUserCommand error {0}".format(ret))

ret = libbm64.LibBM64_Deinit()
if ret != 0:
	print("LibBM64_Deinit error {0}".format(ret))
			
print("BM64 Test end")
