/*--------------------------------------------------------------------------*/
/*																			*/
/*	CTIEMRLib.h (Rev 1.00)													*/
/*																			*/
/*	1.概要																	*/
/*		カウントアップタイマ												*/
/*	2.改版履歴																*/
/*																			*/
/*																			*/
/*--------------------------------------------------------------------------*/


/* status */
#define CTIMER_STATUS_SUCCESS             (0)
#define CTIMER_STATUS_FALSE               (-1)

typedef struct COUTUP_TIMER_LIST
{ 
    char 	 TimerID[32];
    uint32_t ThresholdFirst;
    uint32_t Correct;
    uint32_t Counter;
}COUTUP_TIMER_LIST; 


/* APIs */
extern int32_t LibCTIMER_Init( void ); 
extern int32_t LibCTIMER_Deinit( void ); 
extern int32_t LibCTIMER_setTimer( char* name, long first); 
extern int32_t LibCTIMER_getTimeout( char* name); 
extern void LibCTIMER_cancelTimer( char* name); 


/* extern int32_t LibCTIMER_CallbackSet( LibBM64_Callback pCallback ); */

