from django.http import HttpResponse
from channels.handler import AsgiHandler
from channels import Group

from hello.set_json import Set_Volume
from hello.set_json import Set_EQ
from hello.set_json import Set_Audio_Setting
from hello.get_json import Get_Volume
from hello.get_json import Get_EQ
from hello.get_json import Get_Level
from hello.get_json import Get_Audio_Setting

from hello.preset import Save_Preset
from hello.preset import Load_Preset
from hello.preset import Reset_Preset
from hello.preset import Get_Default_Preset
from hello.preset import Set_Default_Preset

from hello.config import Set_Config
from hello.config import Get_Config
from hello.config import Set_Login

from hello.inspection import Get_Mic_Level

import json
import collections as cl
import re
import sys
import subprocess as sp
import copy
import os, time

row =1
connection =1

#thisNAME_PATH = os.path.dirname(os.path.abspath(__name__))
thisNAME_PATH = "/home/toa/TOA_AM-CF1/Application/data/"
PATH = os.path.join(thisNAME_PATH, '../../tmp/')

#CPUアップデートに失敗
UPDATE_FAILED_flag = "/home/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG"
#CPUアップデートに失敗(DSPアップデートできないFW) home_orgにも保存しているのでorgも削除
UPDATE_FAILED_flag2 = "/home/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG2"
UPDATE_FAILED_flag2_org = "/home_org/toa/TOA_AM-CF1/FAIL_UPDATE_FLAG2"

WEB_STOP_flag = PATH + 'WEB_STOP_flag'

#websocket接続
def ws_add(message):
	#print('aaaaaaaaaaaaaaaaaaaa')
	message.reply_channel.send({"accept": True})
	Group("chat").add(message.reply_channel)

	global row
	global connection

#メッセージを受け取ったら、メッセージを返す
def ws_message(message):
	#print('bbbbbbbbbbbb')
	#msgに受け取ったメッセージ格納
	msg = message.content['text']
	global row

	input_value = msg.split()
	#print("{input_value}".format(**locals()))

	#WEBブラウザから受信した各種パラメータを以下でjson形式に整形、出力
	#beam_str state
	if input_value[0] == 'send':
		#以下WEBブラウザからのsend時
		if input_value[1] == 'volume':
			#サイドパネル動作中か確認(gainとレベル取得のところに持っていくこと)
			if os.path.exists(WEB_STOP_flag):
				dialog = "dialog,External controls in use. Please wait to sync."
				Group("chat").send({"text": "%s" %(str(dialog))})
				return
			else:
				ws_send = Set_Volume(input_value,thisNAME_PATH)
				#print(ws_send)
				Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'audio':
			ws_send = Set_Audio_Setting(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'config':
			ws_send = Set_Config(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'config':
			ws_send = Set_Config(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'EQ':
			ws_send = Set_EQ(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'preset':
			ws_send = Set_Default_Preset(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		
		elif input_value[1] == 'login':
			ws_send = Set_Login(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})


	elif input_value[0] == 'read':
		#print(json_rdsd_flag)

		if (input_value[1] == 'volume'):
			ws_send = Get_Volume(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif (input_value[1] == 'level'):
			#サイドパネル動作中か確認(gainとレベル取得のところに持っていくこと)
			if os.path.exists(WEB_STOP_flag):
				dialog = "dialog,External controls in use. Please wait to sync."
				Group("chat").send({"text": "%s" %(str(dialog))})
				return
			else:
				ws_send = Get_Level(input_value,thisNAME_PATH)
				#print(ws_send)
				Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'audio':
			ws_send = Get_Audio_Setting(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'config':
			ws_send = Get_Config(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'EQ':
			ws_send = Get_EQ(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})

		elif input_value[1] == 'preset':
			ws_send = Get_Default_Preset(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
	
	elif input_value[0] == 'store':
		ws_send = Save_Preset(input_value,thisNAME_PATH)
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})

	elif input_value[0] == 'load':
		ws_send = Load_Preset(input_value,thisNAME_PATH)
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})

	elif input_value[0] == 'reset':
		ws_send = Reset_Preset(input_value,thisNAME_PATH)
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})
	
	#inspection
	elif input_value[0] == 'insp':
		if input_value[1] == 'mic_level':
			ws_send = Get_Mic_Level(input_value,thisNAME_PATH)
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
	
	#update_status(success or failure)
	elif input_value[0] == 'ud_state':
		if os.path.exists(UPDATE_FAILED_flag):
			ws_send = "dialog,Firmware writing was failed. Please retry."
			#print(ws_send)
			os.remove(UPDATE_FAILED_flag)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		elif os.path.exists(UPDATE_FAILED_flag2) or os.path.exists(UPDATE_FAILED_flag2_org):
			version_fname = thisNAME_PATH + 'config/amcf1_version.json'
			with open(version_fname,'r') as file:
				version_rdata = json.load(file)
			cpu_version = version_rdata['version']  #version
			ws_send = "dialog,This AM-CF1 has been updated to firmware v" +  cpu_version + ". Support for later versions requires an update to the unit’s OS. For information on updating your AM-CF1 to the latest OS version. Please contact Customer Support."
			#print(ws_send)
			if os.path.exists(UPDATE_FAILED_flag2):
				os.remove(UPDATE_FAILED_flag2)
			if os.path.exists(UPDATE_FAILED_flag2_org):
				sp.call("sudo mount -o remount,rw /", shell=True)
				os.remove(UPDATE_FAILED_flag2_org)
				os.sync()
				sp.call("sudo mount -o remount,ro /", shell=True)
			Group("chat").send({"text": "%s" %(str(ws_send))})
		else:
			ws_send = ""
			#print(ws_send)
			Group("chat").send({"text": "%s" %(str(ws_send))})
	
	#update_response(if message from web browser, return OK)
	elif input_value[0] == 'ud_response':
		ws_send = "UPLOAD OK."
		#print(ws_send)
		Group("chat").send({"text": "%s" %(str(ws_send))})

	##################################################

#websocket切断
def ws_disconnect(message):
	Group("chat").discard(message.reply_channel)

	global connection