from django.conf.urls import url
from . import views

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
	url(r'^$', views.page_Volume, name = 'page_Volume'),
	url(r'^mixer/$', views.page_Volume, name='page_Volume'),
	url(r'^EQ_SP/$', views.page_EQ_SP, name='page_EQ_SP'),
	url(r'^EQ_AUX/$', views.page_EQ_AUX, name='page_EQ_AUX'),
	url(r'^audiosetting/$', views.page_AudioSetting, name='page_AudioSetting'),
	url(r'^presetsaveload/$', views.page_PresetSaveLoad, name='page_PresetSaveLoad'),
	url(r'^login/$', views.page_Login, name='page_Login'),
	url(r'^mic8_check_kojokensayou/$', views.page_Mic_check, name='page_Mic_check'),
	url(r'^json/volume.json', views.resl_json_vol, name='resl_json_vol'),
	url(r'^json/level.json', views.resl_json_lev, name='resl_json_lev')
] + static(settings.STATIC_URL, document_root = settings.STATIC_ROOT)
