from django.http.response import HttpResponse
from django.shortcuts import render

def hello_world(request):
	return HttpResponse('Hello world')

def page_Volume(request):
	return render(request, 'index.html')

def page_EQ_SP(request):
	return render(request, 'EQSP.html')

def page_EQ_AUX(request):
	return render(request, 'EQAUX.html')

def page_AudioSetting(request):
	return render(request, 'audiosetting.html')

def page_PresetSaveLoad(request):
	return render(request, 'presetsaveload.html')

def page_Login(request):
	return render(request, 'login.html')

def page_Mic_check(request):
	return render(request, 'inspection/mic_check.html')

def comm_json_vol(request):
	return render(request, 'command/volume.json')

def comm_json_lev(request):
	return render(request, 'command/level.json')

def resl_json_vol(request):
	return render(request, 'result/volume.json')

def resl_json_lev(request):
	return render(request, 'result/level.json')

def json_audio_i(request):
	return render(request, 'result/audio_in.json')

def json_audio_o(request):
	return render(request, 'result/audio_out.json')
	
def json_aec_nc(request):
	return render(request, 'result/aec_nc.json')