function preset_upload_php() {
    // フォームデータを取得
    var formdata = new FormData($('#preset_upload').get(0));

    //ip取得
    var ipaddress = document.getElementById('ipaddress').title;

    $.blockUI({
        message: "Please wait...",
        baseZ: 1000000  //一番手前で表示する
    });

    // POSTでアップロード
    $.ajax({
        url: "http://" + ipaddress + "/preset_upload.php",
        type: "POST",
        data: formdata,
        cache: false,
        contentType: false,
        processData: false,
        dataType: "html"
    })
        .done(function (data, textStatus, jqXHR) {
            $.unblockUI();

            //ajaxでjsonp取得
            $.ajax({
                url: 'http://' + ipaddress + '/jsonp_upload_php.js',
                dataType: 'jsonp',
                jsonpCallback: 'callback'
            })
                .then(
                function (json) {
                    var error_messages = json.error_messages;
                    //messagesが入っていたらエラー表示するだけ
                    if (error_messages) {
                        alert(error_messages);
                    } else {	//正常にアップロードできた場合
                        var check_result = json.check_result;
                        if (check_result == -1) {
                            alert("Improperly configured file.");
                            //アップロードファイルの削除
                            $.ajax({
                                url: "http://" + ipaddress + "/delete.php",
                                type: "POST",
                                data: formdata,
                                cache: false,
                                contentType: false,
                                processData: false,
                                dataType: "html"
                            })
                                .then(
                                function (data) {
                                },
                                function () {
                                }
                                );

                        } else {
                            var msg_sure = "Are you sure you want to overwrite this preset?\n";
                            //Dialog
                            if (window.confirm(msg_sure)) {	//Dialog OK時の処理
                                //indicator
                                $.blockUI({
                                    message: "Uploading. Do not shutdown.",
                                    baseZ: 1000000  //一番手前で表示する
                                });
                                //ajaxでpreset_update.php
                                $.ajax({
                                    url: "http://" + ipaddress + "/preset_update.php",
                                    type: "POST",
                                    data: formdata,
                                    cache: false,
                                    contentType: false,
                                    processData: false,
                                    dataType: "html"
                                })
                                    .then(
                                    //preset_update success
                                    function (data) {
                                        //alert(now_load_preset)
                                        if (now_load_preset == 1) {	//Dialog OK時の処理
                                            $.ajax({
                                                url: 'http://' + ipaddress + "/preset1_dspchange.php",
                                                type: "POST",
                                                data: formdata,
                                                cache: false,
                                                contentType: false,
                                                processData: false,
                                                dataType: "html"
                                            })
                                                .then(
                                                //dsp success
                                                function (data) {
                                                    $.unblockUI();
                                                    $.ajax({
                                                        url: "http://" + ipaddress + "/delete.php",
                                                        type: "POST",
                                                        data: formdata,
                                                        cache: false,
                                                        contentType: false,
                                                        processData: false,
                                                        dataType: "html"
                                                    })
                                                        .then(
                                                        function (data) {
                                                        },
                                                        function () {
                                                        }
                                                        );
                                                    alert("Preset uploaded.")
                                                },
                                                //dsp fail
                                                function () {
                                                    $.unblockUI();
                                                    $.ajax({
                                                        url: "http://" + ipaddress + "/delete.php",
                                                        type: "POST",
                                                        data: formdata,
                                                        cache: false,
                                                        contentType: false,
                                                        processData: false,
                                                        dataType: "html"
                                                    })
                                                        .then(
                                                        function (data) {
                                                        },
                                                        function () {
                                                        }
                                                        );
                                                    alert("System error.")
                                                }
                                                )
                                        } else {
                                            $.ajax({
                                                url: 'http://' + ipaddress + "/preset2_dspchange.php",
                                                type: "POST",
                                                data: formdata,
                                                cache: false,
                                                contentType: false,
                                                processData: false,
                                                dataType: "html"
                                            })
                                                .then(
                                                //dsp success
                                                function (data) {
                                                    $.unblockUI();
                                                    $.ajax({
                                                        url: "http://" + ipaddress + "/delete.php",
                                                        type: "POST",
                                                        data: formdata,
                                                        cache: false,
                                                        contentType: false,
                                                        processData: false,
                                                        dataType: "html"
                                                    })
                                                        .then(
                                                        function (data) {
                                                        },
                                                        function () {
                                                        }
                                                        );
                                                    alert("Preset uploaded.")
                                                },
                                                //dsp fail
                                                function () {
                                                    $.unblockUI();
                                                    $.ajax({
                                                        url: "http://" + ipaddress + "/delete.php",
                                                        type: "POST",
                                                        data: formdata,
                                                        cache: false,
                                                        contentType: false,
                                                        processData: false,
                                                        dataType: "html"
                                                    })
                                                        .then(
                                                        function (data) {
                                                        },
                                                        function () {
                                                        }
                                                        );
                                                    alert("System error.")
                                                }
                                                );
                                        }

                                    },
                                    //preset_update fail
                                    function () {
                                        alert("Upload failed!!");
                                        $.unblockUI();
                                        $.ajax({
                                            url: "http://" + ipaddress + "/delete.php",
                                            type: "POST",
                                            data: formdata,
                                            cache: false,
                                            contentType: false,
                                            processData: false,
                                            dataType: "html"
                                        })
                                            .then(
                                            function (data) {
                                            },
                                            function () {
                                            }
                                            );

                                    }
                                    );

                            } else {	//Dialog NG時の処理
                                //アップロードファイルの削除
                                $.unblockUI();
                                $.ajax({
                                    url: "http://" + ipaddress + "/delete.php",
                                    type: "POST",
                                    data: formdata,
                                    cache: false,
                                    contentType: false,
                                    processData: false,
                                    dataType: "html"
                                })
                                    .then(
                                    function (data) {
                                    },
                                    function () {
                                    }
                                    );
                            }
                        }
                    }
                },
                function () {
                    $.unblockUI();
                    alert('System error (file not found)');	//jsonpが見つからなかった時
                }
                );
        })
        .fail(function (jqXHR, textStatus, errorThrown) {
            $.unblockUI();
            alert("Error. Please check your connection or reboot your system.");	//POSTアップロードのphp失敗
            //アップロードファイルの削除
            $.ajax({
                url: "http://" + ipaddress + "/delete.php",
                type: "POST",
                data: formdata,
                cache: false,
                contentType: false,
                processData: false,
                dataType: "html"
            })
                .then(
                function (data) {
                },
                function () {
                }
                );
        });
}