//*voli_rdsd.js*//
var WS_URL = 'ws://' + NOW_IPADDRESS + ':8000';
var ws = new WebSocket(WS_URL);

ws.onerror = function () {
    alert('Failure to connect')
};

ws.onopen = function () {
    ws.send(
        'ud_state'
    );
    ws.send(
        ' read ' + ' config '
    );
    ws.send(
        ' read ' + ' level '
    );
    ws.send(
        ' read ' + ' volume '
    );
    ws.onmessage = function (e) {
        //arrayString =
        //0:type, 1:usbin_gain, 2:BTin_gain,
        //3:Codecin_gain, 4:AUXin_gain,
        //5:SPout_gain, 6:USBout_gain,
        //7:BT_gain, 8:Codecout_gain,
        //9:AUX_gain, 10～18:mute_sts*9 (0:ON 1:OFF)
        var arrayString = e.data.split(",");
        if (arrayString[0] == 'dialog') {
            alert(arrayString[1])
            ws.send(
                ' read ' + ' level '
            );
        }
        else if (arrayString[0] == 'volume') {
            if (controls.volume.INPUT.USB.mute.value == "OFF") {
                controls.volume.INPUT.USB.gain.updateValue(arrayString[1]);
                if (arrayString[10] == 0) {
                    controls.volume.INPUT.USB.mute.updateValue("ON");
                }
            } else {
                if (arrayString[10] == 1) {
                    controls.volume.INPUT.USB.mute.updateValue("OFF");
                    controls.volume.INPUT.USB.gain.updateValue(arrayString[1]);
                }
            }
            if (controls.volume.INPUT.BLUETOOTH.mute.value == "OFF") {
                controls.volume.INPUT.BLUETOOTH.gain.updateValue(arrayString[2]);
                if (arrayString[11] == '0') {
                    controls.volume.INPUT.BLUETOOTH.mute.updateValue("ON");
                }
            } else {
                if (arrayString[11] == '1') {
                    controls.volume.INPUT.BLUETOOTH.mute.updateValue("OFF");
                    controls.volume.INPUT.BLUETOOTH.gain.updateValue(arrayString[2]);
                }
            }

            if (controls.volume.INPUT.CODEC.mute.value == "OFF") {
                controls.volume.INPUT.CODEC.gain.updateValue(arrayString[3]);
                if (arrayString[12] == '0') {
                    controls.volume.INPUT.CODEC.mute.updateValue("ON");
                }
            } else {
                if (arrayString[12] == '1') {
                    controls.volume.INPUT.CODEC.mute.updateValue("OFF");
                    controls.volume.INPUT.CODEC.gain.updateValue(arrayString[3]);
                }
            }

            if (controls.volume.INPUT.AUX.mute.value == "OFF") {
                controls.volume.INPUT.AUX.gain.updateValue(arrayString[4]);
                if (arrayString[13] == '0') {
                    controls.volume.INPUT.AUX.mute.updateValue("ON");
                }
            } else {
                if (arrayString[13] == '1') {
                    controls.volume.INPUT.AUX.mute.updateValue("OFF");
                    controls.volume.INPUT.AUX.gain.updateValue(arrayString[4]);
                }
            }

            if (controls.volume.OUTPUT.SP.mute.value == "OFF") {
                controls.volume.OUTPUT.SP.gain.updateValue(arrayString[5]);
                if (arrayString[14] == '0') {
                    controls.volume.OUTPUT.SP.mute.updateValue("ON");
                }
            } else {
                if (arrayString[14] == '1') {
                    controls.volume.OUTPUT.SP.mute.updateValue("OFF");
                    controls.volume.OUTPUT.SP.gain.updateValue(arrayString[5]);
                }
            }

            if (controls.volume.OUTPUT.USB.mute.value == "OFF") {
                controls.volume.OUTPUT.USB.gain.updateValue(arrayString[6]);
                if (arrayString[15] == '0') {
                    controls.volume.OUTPUT.USB.mute.updateValue("ON");
                }
            } else {
                if (arrayString[15] == '1') {
                    controls.volume.OUTPUT.USB.mute.updateValue("OFF");
                    controls.volume.OUTPUT.USB.gain.updateValue(arrayString[6]);
                }
            }

            if (controls.volume.OUTPUT.BLUETOOTH.mute.value == "OFF") {
                controls.volume.OUTPUT.BLUETOOTH.gain.updateValue(arrayString[7]);
                if (arrayString[16] == '0') {
                    controls.volume.OUTPUT.BLUETOOTH.mute.updateValue("ON");
                }
            } else {
                if (arrayString[16] == '1') {
                    controls.volume.OUTPUT.BLUETOOTH.mute.updateValue("OFF");
                    controls.volume.OUTPUT.BLUETOOTH.gain.updateValue(arrayString[7]);
                }
            }

            if (controls.volume.OUTPUT.CODEC.mute.value == "OFF") {
                controls.volume.OUTPUT.CODEC.gain.updateValue(arrayString[8]);
                if (arrayString[17] == 0) {
                    controls.volume.OUTPUT.CODEC.mute.updateValue("ON");
                }
            } else {
                if (arrayString[17] == 1) {
                    controls.volume.OUTPUT.CODEC.mute.updateValue("OFF");
                    controls.volume.OUTPUT.CODEC.gain.updateValue(arrayString[8]);
                }
            }

            if (controls.volume.OUTPUT.AUX.mute.value == "OFF") {
                controls.volume.OUTPUT.AUX.gain.updateValue(arrayString[9]);
                if (arrayString[18] == 0) {
                    controls.volume.OUTPUT.AUX.mute.updateValue("ON");
                }
            } else {
                if (arrayString[18] == 1) {
                    controls.volume.OUTPUT.AUX.mute.updateValue("OFF");
                    controls.volume.OUTPUT.AUX.gain.updateValue(arrayString[9]);
                }
            }
        } else if (arrayString[0] == 'level') {
            controls.volume.INPUT.USB.level.updateValue(arrayString[1]);
            controls.volume.INPUT.BLUETOOTH.level.updateValue(arrayString[2]);
            controls.volume.INPUT.CODEC.level.updateValue(arrayString[3]);
            controls.volume.INPUT.AUX.level.updateValue(arrayString[4]);
            controls.volume.OUTPUT.SP.level.updateValue(arrayString[5]);
            controls.volume.OUTPUT.USB.level.updateValue(arrayString[6]);
            controls.volume.OUTPUT.BLUETOOTH.level.updateValue(arrayString[7]);
            controls.volume.OUTPUT.CODEC.level.updateValue(arrayString[8]);
            controls.volume.OUTPUT.AUX.level.updateValue(arrayString[9]);

            ws.send(
                ' read ' + ' level '
            );
            // websokcet already close? readyState:2 closing, 3 closed
            if (ws.readyState == 3 || ws.readyState == 2) {
                alert('Failure to connect')
            }
        } else if (arrayString[0] == 'config') {
            controls.config.NETWORK.ipfields[0].ip.updateValue(arrayString[1])
            controls.config.NETWORK.ipfields[1].ip.updateValue(arrayString[2])
            controls.config.NETWORK.ipfields[2].ip.updateValue(arrayString[3])
            controls.config.USER.username.text.updateValue(arrayString[4])
            controls.config.USER.password.text.updateValue(arrayString[5])

            if (arrayString[6] == 'Volume_Up') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Up")
            } else if (arrayString[6] == 'Volume_Down') {
                controls.config.CONTACT.inputs[0].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[0].input.updateValue(arrayString[6])
            }
            if (arrayString[7] == 'Volume_Up') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Up")
            } else if (arrayString[7] == 'Volume_Down') {
                controls.config.CONTACT.inputs[1].input.updateValue("Volume Down")
            } else {
                controls.config.CONTACT.inputs[1].input.updateValue(arrayString[7])
            }

            if (arrayString[8] == 'Mute_Status') {
                controls.config.CONTACT.outputs[0].output.updateValue("Mute Status")
            } else if (arrayString[8] == 'Synch_Input1') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input1")
            } else if (arrayString[8] == 'Synch_Input2') {
                controls.config.CONTACT.outputs[0].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[0].output.updateValue(arrayString[8])
            }

            if (arrayString[9] == 'Mute_Status') {
                controls.config.CONTACT.outputs[1].output.updateValue("Mute Status")
            } else if (arrayString[9] == 'Synch_Input1') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input1")
            } else if (arrayString[9] == 'Synch_Input2') {
                controls.config.CONTACT.outputs[1].output.updateValue("Synch Input2")
            } else {
                controls.config.CONTACT.outputs[1].output.updateValue(arrayString[9])
            }

            controls.config.INDICATE.toggles[0].onoff.updateValue(arrayString[10])
            controls.config.INDICATE.toggles[1].onoff.updateValue(arrayString[11])
            if (arrayString[12] == 'Only_Center') {
                controls.config.INDICATE.mute.mute.updateValue("Only Center")
            } else if (arrayString[12] == 'ALL_LED') {
                controls.config.INDICATE.mute.mute.updateValue("ALL LED")
            }
            // Add CPU Version and DSP Version data
            document.getElementById("firm_version").textContent = arrayString[13];
            if (arrayString.length > 14){
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    arrayString[14] + "/" + arrayString[15] + "/" +
                    arrayString[16] + " " + arrayString[17] + ":" +
                    arrayString[18];
            }else{
                document.getElementById("os_nowtime").textContent = "Current Time of AM-CF1:  " +
                    "Failed to load.";
            }
        }
    }
}

$(function () {
    $('#vol_send').on('click', function () {
        //Sendボタンを押した時にwebsocketでサーバー側にデータを送信

        if (controls.volume.INPUT.USB.mute.value == "ON") {
            var INPUT_USB_mute_sts = 0;
        } else {
            var INPUT_USB_mute_sts = 1;
        }

        if (controls.volume.INPUT.BLUETOOTH.mute.value == "ON") {
            var INPUT_BLUETOOTH_mute_sts = 0;
        } else {
            var INPUT_BLUETOOTH_mute_sts = 1;
        }

        if (controls.volume.INPUT.CODEC.mute.value == "ON") {
            var INPUT_CODEC_mute_sts = 0;
        } else {
            var INPUT_CODEC_mute_sts = 1;
        }

        if (controls.volume.INPUT.AUX.mute.value == "ON") {
            var INPUT_AUX_mute_sts = 0;
        } else {
            var INPUT_AUX_mute_sts = 1;
        }

        if (controls.volume.OUTPUT.SP.mute.value == "ON") {
            var OUTPUT_SP_mute_sts = 0;
        } else {
            var OUTPUT_SP_mute_sts = 1;
        }

        if (controls.volume.OUTPUT.USB.mute.value == "ON") {
            var OUTPUT_USB_mute_sts = 0;
        } else {
            var OUTPUT_USB_mute_sts = 1;
        }

        if (controls.volume.OUTPUT.BLUETOOTH.mute.value == "ON") {
            var OUTPUT_BLUETOOTH_mute_sts = 0;
        } else {
            var OUTPUT_BLUETOOTH_mute_sts = 1;
        }

        if (controls.volume.OUTPUT.CODEC.mute.value == "ON") {
            var OUTPUT_CODEC_mute_sts = 0;
        } else {
            var OUTPUT_CODEC_mute_sts = 1;
        }

        if (controls.volume.OUTPUT.AUX.mute.value == "ON") {
            var OUTPUT_AUX_mute_sts = 0;
        } else {
            var OUTPUT_AUX_mute_sts = 1;
        }

        ws.send(
            ' send ' + ' volume ' +
            controls.volume.INPUT.USB.gain.value + ' ' +
            controls.volume.INPUT.BLUETOOTH.gain.value + ' ' +
            controls.volume.INPUT.CODEC.gain.value + ' ' +
            controls.volume.INPUT.AUX.gain.value + ' ' +
            controls.volume.OUTPUT.SP.gain.value + ' ' +
            controls.volume.OUTPUT.USB.gain.value + ' ' +
            controls.volume.OUTPUT.BLUETOOTH.gain.value + ' ' +
            controls.volume.OUTPUT.CODEC.gain.value + ' ' +
            controls.volume.OUTPUT.AUX.gain.value + ' ' +
            INPUT_USB_mute_sts + ' ' +
            INPUT_BLUETOOTH_mute_sts + ' ' +
            INPUT_CODEC_mute_sts + ' ' +
            INPUT_AUX_mute_sts + ' ' +
            OUTPUT_SP_mute_sts + ' ' +
            OUTPUT_USB_mute_sts + ' ' +
            OUTPUT_BLUETOOTH_mute_sts + ' ' +
            OUTPUT_CODEC_mute_sts + ' ' +
            OUTPUT_AUX_mute_sts + ' '
        );
        // websokcet already close? readyState:2 closing, 3 closed
        if (ws.readyState == 3 || ws.readyState == 2) {
            alert('Failure to connect')
        }
    });
});

(function () {
    var ip_form = document.getElementById("ipchange")
    var config_down = document.getElementById("config_down")
    var div_ip = document.getElementById("ipaddress")


    ip_form.setAttribute("action", "http://" + NOW_IPADDRESS + "/ipchange.php");
    config_down.setAttribute("action", "http://" + NOW_IPADDRESS + "/config_download.php");
    div_ip.setAttribute("title", NOW_IPADDRESS);

})();

$(window).on('load resize', function () {
    var w = $(window).width();
    var x = 360;
    if (w <= x) {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '250px' });
    } else {
        $('.btn-send.fixed').css({ 'position': 'fixed' });
        $('.btn-send.fixed').css({ 'left': '' });
        $('.btn-send.fixed').css({ 'right': '10px' });
    }
});